procedure log(cad:string);
var F: TextFile;
begin
      if not logACTIVO then exit;
      AssignFile(F, ArchLOG);
      Append(F);
      WriteLn(F, cad);
      CloseFile(F);
end;
procedure logTiempo(cad:string);
var F: TextFile;
    Hour, Minute, Second, MilliSecond: word;
begin
      //if not logACTIVO then exit;
      AssignFile(F, ArchLOG);
      Append(F);
      DecodeTime(now,Hour,Minute,Second,MilliSecond);
      WriteLn(F, IntToStr(Hour)+':'+IntToStr(Minute)+':'+IntToStr(Second)+' '+cad);
      CloseFile(F);
end;

function StrToFlujo(cad:String):String;
var s,c:String; i,L:Integer;
begin
L:=Length(cad);
s:='';
for i:=1 to L do
  begin c:='000'+IntToStr(ord(cad[i]));
        s:=s+RightStr(c,3);
  end;
result:=s;
end;

function FlujoToStr(cad:string):string;
var sql,x:string; i:Integer;
begin sql:='';i:=1;
      while i<length(cad) do
        begin x:=WideChar(chr(StrToInt(copy(cad,i,3))));
              sql:=sql+UTF8Encode(x);  //El encode parece opcional ya que si se quita igual funciona
              inc(i,3);
        end;
      result:=sql;
end;

{$I ../uBiblio/bib1.pas}

function strIntStr(cad:String):String;
begin
result:=IntToStr(StrToInt(trim(cad)));
end;

function splTrim(cad, car: string): integer;
var c, L, i: integer;
begin
  CAD:=CAD+CAR; L:=length(cad); c:=0;
  pTabTrim[0]:=0;
  for i:=1 to L do
    if cad[i] = car then  begin c:=c+1;
                                pTabTrim[c]:=i;
                          end;
  if c > 0 then begin for i:=1 to c do
                        if pTabTrim[i] - pTabTrim[i - 1] > 1
                           then pTextTrim[i]:=trim(copy(cad, pTabTrim[i - 1]+1, pTabTrim[i] - pTabTrim[i - 1] - 1))
                           else pTextTrim[i]:='';
                end;
  Result:=c;
end;

function lPad(cadena, car: string; ancho: integer): string;
var i: integer;
begin
  while length(cadena) < ancho do
    cadena:=car+cadena;
  Result:=cadena;
end;

function rPad(cadena, car: string; ancho: integer): string;
var i: integer;
begin
  while length(cadena) < ancho do
    cadena:=cadena+car;
  Result:=cadena;
end;

function iif(condicion: boolean; cad1, cad2: string): string;
begin if condicion
         then Result:=cad1
         else Result:=cad2;
end;
function IbFecha(xFecha: TDate): string;        //31/1/1111 to '1111/1/31'
var Year, Month, Day: word;
begin DecodeDate(xFecha, Year, Month, Day);
      Result:=IntToStr(Year)+'/'+IntToStr(Month)+'/'+IntToStr(Day);
end;
function IbFechaGuion(xFecha: TDate): string;        //31/1/1111 to '1111-01-31'
var Year, Month, Day: word;
begin DecodeDate(xFecha, Year, Month, Day);
      Result:=IntToStr(Year)+'-'+lPad(IntToStr(Month),'0',2)+'-'+lPad(IntToStr(Day),'0',2);
end;
function dmyTOymd(sFechaDDMMYYYY:string):string;
begin Result:=IbFecha(StrToDate(sFechaDDMMYYYY));
end;
function dmyTOymdGuion(sFechaDDMMYYYY:string):string;
begin Result:=IbFechaGuion(StrToDate(sFechaDDMMYYYY));
end;
function ymdTOddmmyy(sFechaYYYYMMDD:string):string;
begin Result:=copy(sFechaYYYYMMDD,9,2)+'/'+copy(sFechaYYYYMMDD,6,2)+'/'+copy(sFechaYYYYMMDD,3,2);
end;
function ymdTOddmmyyyy(sFechaYYYYMMDD:string):string;
begin Result:=copy(sFechaYYYYMMDD,9,2)+'/'+copy(sFechaYYYYMMDD,6,2)+'/'+copy(sFechaYYYYMMDD,1,4);
end;
function ddmmaa(ddmmaaaa:string):string;
begin Result:=copy(ddmmaaaa,1,2)+'.'+copy(ddmmaaaa,4,2)+'.'+RightStr(ddmmaaaa,2);
end;
function mmaa(ddmmaaaa:string):string;
begin Result:=copy(ddmmaaaa,4,2)+'/'+copy(ddmmaaaa,9,2);
end;
function ddmmaPto(ddmmyyyy:String):String;
begin Result:=LeftStr(ddmmyyyy,2)+'.'+copy(ddmmyyyy,4,2)+'.'+RightStr(ddmmyyyy,1)
end;


