procedure log(cad:string);
var F: TextFile;
begin
      if not logACTIVO then exit;
      AssignFile(F, ArchLOG);
      Append(F);
      WriteLn(F, cad);
      CloseFile(F);
end;

function splitCar(cad:String;car:string='|'): integer;
var c, L, i: integer;
begin
IF length(cad)=0 THEN BEGIN result:=0; exit; END;
CAD:=CAD+CAR;
L:=length(cad);
c:=0;
pTab[0]:=0;
for i:=1 to L do
   if cad[i]=car then
      begin c:=c+1;
            pTab[c]:=i;
      end;
if c > 0 then
   begin for i:=1 to c do
           if pTab[i] - pTab[i - 1] > 1
              then pT[i]:=copy(cad, pTab[i - 1]+1, pTab[i] - pTab[i - 1] - 1)
              else pT[i]:='';
   end;
Result:=c;
end;

function StrToFlujo(cad:String):String;
var s,c:String; i,L:Integer;
begin
L:=Length(cad);
s:='';
for i:=1 to L do
  begin c:='000'+IntToStr(ord(cad[i]));
        s:=s+RightStr(c,3);
  end;
result:=s;
end;

function FlujoToStr(cad:string):string;
var sql,x:string; i:Integer;
begin sql:='';i:=1;
      while i<length(cad) do
        begin x:=WideChar(chr(StrToInt(copy(cad,i,3))));
              sql:=sql+UTF8Encode(x);  //El encode parece opcional ya que si se quita igual funciona
              inc(i,3);
        end;
      result:=sql;
end;

function lPad(cadena, car: string; ancho: integer): string;
var i: integer;
begin
  while length(cadena) < ancho do
    cadena:=car+cadena;
  Result:=cadena;
end;

function rPad(cadena, car: string; ancho: integer): string;
var i: integer;
begin
  while length(cadena) < ancho do
    cadena:=cadena+car;
  Result:=cadena;
end;
procedure w(cad: string);
begin if printSI then
         if SALTOLINEA
            then writeln(cad)
            else Write(cad);
end;
procedure GenVm(id,dat:string);
begin inc(tvCampo);vC[tvCampo].Id:=id; vC[tvCampo].value:=dat;
end;

function Lee(archivo:string;soloBody:boolean):string;
var F:Textfile;
    s,finLinea,linea:String;
    swBody:boolean;
    i:Integer;
begin
finLinea:=#13#10;
AssignFile(F,archivo);
Reset(F);
swBody:=false;
s:='';
i:=0;
while not EOF(F) do
  begin ReadLn(F, linea);
        if not soloBody
           then s:=s+linea+finLinea
           else
                if swBody
                   then begin i:=pos('</BODY',uppercase(linea));
                              if i>0 then begin s:=s+LeftStr(linea,i-1)+finLinea;
                                                break;
                                           end;
                              for i:=1 to length(linea)do s:=s+linea[i];
                              s:=s+finLinea;
                        end
                   else begin i:=pos('<BODY',uppercase(linea));
                              if i>0 then
                                 begin while((linea[i+1]<>'>') and (not EOF(F)) and (i<length(linea))) do
                                          begin inc(i);
                                                //ReadLn(F, linea);
                                          end;
                                       s:=s+RightStr(linea,length(linea)-i-1)+finLinea;
                                       swBody:=true;
                                 end;
                         end;
  end;
CloseFile(F);
result:=s;
end;

function charHumaniza(cad:string):string;
var p,L,i,tvRemp:integer;
    s,r,sHex:string;
    sC:array[1..250] of string;
begin
sHex:='%F1%D1%E1%E9%ED%F3%FA%C1%C9%CD%D3%DA%40%2F%28%29%5B%5D%7B%7D%BF%2B%2C%3B%3C%3E%21%22%23%24%25%26%2F%28%29%3D%3F%A1%7C%27%20';
i:=0;
inc(i);sC[i]:='ñ';
inc(i);sC[i]:='Ñ';
inc(i);sC[i]:='á';
inc(i);sC[i]:='é';
inc(i);sC[i]:='í';
inc(i);sC[i]:='ó';
inc(i);sC[i]:='ú';
inc(i);sC[i]:='Á';
inc(i);sC[i]:='É';
inc(i);sC[i]:='Í';
inc(i);sC[i]:='Ó';
inc(i);sC[i]:='Ú';
inc(i);sC[i]:='@';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='[';
inc(i);sC[i]:=']';
inc(i);sC[i]:='{';
inc(i);sC[i]:='}';
inc(i);sC[i]:='¿';
inc(i);sC[i]:='+';
inc(i);sC[i]:=',';
inc(i);sC[i]:=';';
inc(i);sC[i]:='<';
inc(i);sC[i]:='>';
inc(i);sC[i]:='!';
inc(i);sC[i]:='"';
inc(i);sC[i]:='#';
inc(i);sC[i]:='$';
inc(i);sC[i]:='%';
inc(i);sC[i]:='&';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='=';
inc(i);sC[i]:='?';
inc(i);sC[i]:='¡';
inc(i);sC[i]:='|';
inc(i);sC[i]:='''';
inc(i);sC[i]:=' ';
s:=trim(cad);
L:=length(s);
i:=0;r:='';
while i<L do
  begin inc(i);
        if s[i]='+' then r:=r+' '
        else if s[i]='%' then
                begin p:=pos(s[i]+s[i+1]+s[i+2],sHex);
                      if p>0 then begin r:=r+sC[(p+2) div 3];
                                        i:=i+2;
                                  end;
                end
             else r:=r+s[i];
  end;
result:=r;
end;

function uPos(xCad, xCar: string): integer;
var i: integer;
begin
  Result:=0;
  for i:=1 to length(xCad) do
    if xCad[i] = xCar then
    begin Result:=i;
          exit;
    end;
end;

function devStrP(var cadFuente: string; cadBusca, separa, igualdad: string): string;
var i, p: integer;
begin tPost:=splitCar(cadFuente, separa);
      Result:='';
      for i:=1 to tPost do
      begin p:=uPos(UpperCase(pT[i]), igualdad);
            if (p > 0) and (UpperCase(LeftStr(pT[i], p - 1)) = UpperCase(cadBusca)) then
                begin Result:=RightStr(pT[i], length(pT[i]) - p);
                      exit;
                end;
      end;
end;

function ReverseString(s: string): string;
var i: integer; s2: string;
begin s2:='';
      for i:=1 to Length(s) do s2:=s[i]+s2;
      Result:=s2;
end;

function devStr(xCad: string): string;
var i, p: integer;
begin tPost:=splitCar(a, '&');
      Result:='';
      for i:=1 to tPost do
        begin p:=uPos(UpperCase(pT[i]), '=');
              if (p > 0) and (UpperCase(LeftStr(pT[i], p - 1)) = UpperCase(xCad)) then
                  begin Result:=RightStr(pT[i], length(pT[i]) - p);
                        exit;
                  end;
        end;
end;

function devInt(xCad: string): integer;
begin Result:=StrToInt(Trim(devStr(xCad)));
end;

function devTrim(xCad: string): string;
begin Result:=Trim(devStr(xCad));
end;

function bCampo(valor:String;t:SmallInt):SmallInt;
var i:Integer;
begin
//log('<bCampo('+valor+','+IntToStr(t)+')');
  for i:=1 to t do
    if UpperCase(vC[i].Id)=valor then
       begin //log(UpperCase(vC[i].Id)+'|'+valor);
             result:=i; exit;
       end;
  result:=-1;
end;

function devHTML(arch:String):string;
var s,rs:String;
    c,i,L:Integer;
    swEnScrip:SmallInt;  //-1 inicio, 1 En script, 0 apaga
    sScript:String;
begin
log('<devHTML('+arch+')');
s:=Lee(arch,false); //log(s);
L:=length(s);
swEnScrip:=-1;
i:=0; sScript:='';
rs:='';
//log('tvCampo:'+IntToStr(tvCampo));
while i<L do
 begin inc(i);
       if (copy(s,i,2)=_Ini) and (swEnScrip=-1) then swEnScrip:=0;
       if copy(s,i,2)=_Ini then
          if swEnScrip=0
             then begin swEnScrip:=1; Inc(i,2);  sScript:='';
                  end
             else begin swEnScrip:=0; Inc(i,1);
                  end;
       if swEnScrip=1 then sScript:=sScript+s[i]
       else if swEnScrip=0 then
                begin c:=bCampo(UpperCase(trim(sScript)),tvCampo);
                      swEnScrip:=-1;
                      if c=-1
                         then rs:=rs+'{ERROR}{No existe}{'+sScript+'}'
                         else rs:=rs+UTF8Decode(vC[c].value);
                end
       else rs:=rs+s[i];
 end;
//log(rs);
result:=rs;
end;


