//{$I ../uBiblio/uVenta.pas}
uses
  dos,
  {$If Defined(linuxMySql55)}     mysql55conn,   {$IfEnd}
  {$If Defined(linuxMySql56)}     mysql56conn,   {$IfEnd}
  {$If Defined(linuxFirebird25) or Defined(windowsFirebird25)}  IBConnection,   {$IfEnd}
  sqldb,DB,dateUtils,SysUtils,process,
  ShellApi,
  FileUtil,
  Classes;

//{$R *.res}
{$I gestionIni.pas}
//  {$I ../uBiblio/bibAnx1.pas}
{$I ../uBiblio/bib1.pas}
//{$If Defined(SYSBUS)}
//{$I ../uBiblio/busBiblio.pas}
//{$IfEnd}
{$I ../uBiblio/manteIni.pas}
//{$I ../uBiblio/kxIni.pas}
//{$I ../uBiblio/vta.pas}
//{$I ../uBiblio/anlsis.pas}

//*****************************************

{$If Defined(FEDEF)}
procedure pCmdLinea(Comando:String;salida:string='salida.txt');
var UnProceso: TProcess;
    UnaLista: TStringList;
begin
log('<pCmdLinea('+Comando+','+salida+')');
// Creamos el objeto TStringList.
   UnaLista := TStringList.Create;
   UnProceso := TProcess.Create(nil);
   UnProceso.CommandLine := Comando;
   UnProceso.Options := UnProceso.Options + [poWaitOnExit, poUsePipes];
   // Lanzamos la ejecución de 'ppc386 -h'.
   UnProceso.Execute;
   UnaLista.LoadFromStream(UnProceso.Output);
   // Guardamos la salida en un archivo.
   UnaLista.SaveToFile(salida);
   UnaLista.Free;
   UnProceso.Free;
//fpsystem('dir');
//s:=dirname(__FILE__,200)."strip.exe "+trim(Memo1.Lines[0]);
//ShellExecute(Handle, PChar ('open'), PChar (s),PChar (''), PChar (trim(Memo1.Lines[0])), 1);
////ShellExecute(Handle, PChar ('open'), PChar (s),PChar ('127.0.0.1:888/utes6h'), PChar (''), 1);
end;

function solesAletras(APagar:Real):String;
var xTotal,xEntero,xDecimal:String;
begin xTotal:='0'+FloatToStr(APagar);
      if pos('.',xTotal)>0
         then begin xEntero:=LeftStr(xTotal,pos('.',xTotal)-1);
                    xDecimal:=LeftStr(RightStr(xTotal,length(xTotal)-pos('.',xTotal))+'0',2);
              end
         else begin xEntero:=xTotal;
                    xDecimal:='00';
              end;
      result:=NumLetra(StrToFloat(xEntero),1,1)+ ' con '+xDecimal+'/100 soles';
end;

function pVtaCliComboRefresh(lSend:string):String;
var s:String;
begin
log('<pVtaCliComboRefresh('+lSend+')');
//bQ('select first 100 ID,RAZONSOCIAL,RUC,DNI,DIRECCION from CLIENTE order by RAZONSOCIAL');
if lSend=''
   then begin  bQ('select ID,RAZONSOCIAL from CLIENTE where ACTIVO=''S'' order by RAZONSOCIAL'); //act2014 se quedó aquí.
               s:='<select id="idVtaCliente" style="height:30px;width:200px;font-size:12px;border:0px;border-radius:2px;" onchange="pVtaClienteGetDatos();">';
               //s:=s+'<option value=0>Público general';
               while not q.eof do
                 begin s:=s+'<option value="'+q.Fields[0].AsString+'">'+LeftStr(q.Fields[1].AsString,40)  ;
                       q.Next;
                 end;
               s:=s+'</select>';
        end
   else begin  bQ('select ID,RAZONSOCIAL,RUC,DNI,from CLIENTE where ACTIVO=''S'' order by RAZONSOCIAL');
               s:=s+q.FieldByName('RAZONSOCIAL').AsString;
        end;
result:=s;
end;

{$IfEnd}

procedure pFEprint(xvar:String);
VAR res,RUC,DNI,DIRECCION:String;
    c,i:Integer;
    sTot:Real;
begin
try
log('pFEprint('+xvar+')');
xvar:=trim(xvar);
if xvar='1' then
    CopyFile(PChar('//192.168.1.57/imgPrint/20559678491-B013-4852.js.pendiente'),
             PChar('d:/20559678491-B013-4852.js.pendiente'))
else if xvar='2' then
    CopyFile(PChar('//192.168.1.101/imgPrint/20559678491-B013-4852.js.pendiente'),
             PChar('//192.168.1.61/ACERTM20/20559678491-B013-4852.js.pendiente'))
else if xvar='3' then
    CopyFile(PChar('//192.168.1.101/imgPrint/20559678491-B013-4852.js.pendiente'),
             PChar('//192.168.1.61/ACERTM20'))
else if xvar='4' then
    CopyFile(PChar('//192.168.1.101/imgPrint/20559678491-B013-4852.js.pendiente'),
             PChar('//192.168.1.61/ACERTM20/'))
else if xvar='5' then
     CopyFile(PChar('//192.168.1.57/imgPrint/20559678491-B013-4852.js.pendiente'),
              PChar('d:/20559678491-B013-4852.js.pendiente'))
;
res:=xvar+':_:';
except  on e: Exception do
        begin log(e.Message);
              res:='Error:_:'+e.Message;
        end;
end;
w(res);
end;

procedure pFEGenXMLsinFirma(xvar:String);
var idFIni,idFFin,idProv,idIdDocTipo,idSerie,idNro,idMax,idEst,
    idFechaFil,idCajaNro,idIdDocTipoFil,idSerieFil,idNroFil,idCajaNroFil,idEstFil,
    cadBusca,buscaPor,s,sHead,pkVENTA,IDESTADO,marcaEA,cuenta,
    sFE:String;
    i,c,tCmd:SmallInt;
    total,tTotal,totTodo,igv:Real;
begin
//try
//log('<pFEGenXMLsinFirma('+xvar+')');
//if not (vAcc[uSYS] or vAcc[uADM] or vAcc[uCAJ])then DatabaseError('Ud., no puede entrar a este módulo');
//splitCar(xvar);
//idFIni:=       pT[1];
//idFFin:=       pT[2];
//idFechaFil:='';
//cadBusca:='where 1=1';
//if idProv<>'' then
//   begin c:=splitCar(idProv,' ');
//         if c=0 then pT[1]:='';
//         if esNro(trim(pT[1]))
//            then begin buscaPor:='IDCLIENTE';
//                       cadBusca:=cadBusca+' and '+BuscaPor+' like '''+(trim(pT[1]))+'%''';
//                 end
//            else begin buscaPor:='upper(CLIENTE)';
//                       cadBusca:=cadBusca+' and '+BuscaPor+' like '''+UpperCase(trim(pT[1]))+'%''';
//                       for i:=2 to c do
//                         begin cadBusca:=cadBusca+' and '+BuscaPor+' like ''%'+UpperCase(pT[i])+'%''';
//                         end;
//                 end;
//   end;
//if (idFFin<>'') and (idFFin<>'') then idFechaFil:=' and FECHA>='''+idFIni+''' and FECHA<='''+idFFin+'''';
//if idIdDocTipo<>'' then idIdDocTipoFil:=' and IDDOCUMENTO='+idIdDocTipo;
//if idSerie<>''     then idSerieFil    :=' and cast(SERIE as integer)='''+idSerie+'''';
//if idNro<>''       then idNroFil      :=' and cast(NRO as integer)='''+idNro+'''';
//if idCajaNro<>'*'  then idCajaNroFil  :=' and trim(IDCJATRM)='''+Trim(idCajaNro)+'''';
//if idEst<>'*'      then idEstFil      :=' and IDESTADO='''+idEst+'''';
//totTodo:=StrToFloat(rQ('select coalesce(sum(TOTAL),0) from VENTA where (IDESTADO=''V'' or IDESTADO=''S'')'
//                   +idFechaFil+idCajaNroFil));
//cuenta:=rQ('select count(*) from VVENTAOP '
//          +cadBusca+idFechaFil+idIdDocTipoFil+idSerieFil+idNroFil+idCajaNroFil+idEstFil
//          );
//s:='select first '+idMax+' * from VVENTAOP '
//  +cadBusca+idFechaFil+idIdDocTipoFil+idSerieFil+idNroFil+idCajaNroFil+idEstFil
//  +' order by FECHA desc,HORA desc';
//bq(s);
//s:='';i:=0;tTotal:=0;
//while not q.eof do
//  begin pkVENTA:=qs('SERIE')+palo
//                +qs('NRO')+palo
//                +qs('IDDOCUMENTO');
//        IDESTADO:=qs('IDESTADO');
//        total:=q.FieldByName('TOTAL').AsFloat;
//        if (IDESTADO<>'V') and (IDESTADO<>'S') and (IDESTADO<>'T')
//           then marcaEA:='font-style:italic;'
//           else begin marcaEA:='';
//                      tTotal:=tTotal+total;
//                end;
//        s:=s+'<tr id="rowCmd_'+IntToStr(i)+'" align=center'
//            +' onclick="rowCmd_i='+IntToStr(i)+';lFilaMarca(''rowCmd_'','
//            +IntToStr(i)+',tCmd);pVtaDetVer('''+pkVENTA+''');" style="height:20px;cursor:pointer;white-space:nowrap;'+marcaEA
//            +'" valign=top>';
//        s:=s+'<td width=1px style="font-size:11px;color:#848484;">'+IntToStr(i+1)
//            +'<td>'+strIntStr(qs('SERIE'))
//            +'<td>'+strIntStr(qs('NRO'))
//            +'<td align=left><div id="dvVtaDocDes_'+IntToStr(i)+'">'+qs('DOCUMENTO')+'</div>'
//            +'<td>'+ddmmaa(qs('FECHA'))
//            +'<td>'+qs('HORA')
//            +'<td>'+qs('DI')
//            //+'<td>'+qs('CLIENTEDNI')
//            //+'<td>'+qs('CLIENTERUC')
//            +'<td align=left>'+qs('CLIENTE')
//            +'<td align=right>'+qs('SIMBOLO')
//            +'<td align=right>'+format('%.2f',[total])
//            +'<td>'+qs('ESTADO')
//            +'<input type=hidden id=idhEstado_'+IntToStr(i)+' value="'+IDESTADO+'">'
//            +'<td valign=middle style="font-size:10px;">'+qs('CAJERO')
//            +'<td valign=middle style="font-size:10px;">'+qs('PEDIDOR')
//            +'<td>'+qs('GRUPO');
//        igv:=qf('IGV');
//        TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
//        SUBTOTAL:=aPagar-TIGVdeducido;
//        PFRACCAT0xCANT:=PFRACCAT0xCANT/(1.0+igv/100.0);
//        txtSUB_TOTAL:=format('%.2f',[SUBTOTAL]);
//        txtTOTAL:=format('%.2f',[aPagar]);
//        txtTOTAL_IGV:=format('%.2f',[StrToFloat(txtTOTAL)-StrToFloat(txtSUB_TOTAL)]);
//
//        sFE:=format('{"txtTOTAL_GRAVADAS":"%s","txtSUB_TOTAL":"%s","txtTOTAL_IGV":"%s","txtTOTAL":"%s","txtTOTAL_LETRAS":"%s"',
//                    [txtSUB_TOTAL,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,solesAletras((vIMP[iDOCCORR]))]
//                   );
//
//
//        q.Next;
//        inc(i);
//  end;
////while i<StrToInt(idMax) do begin inc(i); s:=s+'<tr><td>&nbsp;<td><td><td><td><td><td>'; end;
//tCmd:=i;
//sHead:='';
////sHead:=  '<span style="font-size:22px;">Documento de venta</span>';
//sHead:=sHead+'<div class="brdTabl1">';
////sHead:=sHead+'<div class="">';
//sHead:=sHead+'<table width=100% rules=cols style="font:12px tahoma,arial,calibri;border-collapse:collapse;border-color:#cccccc;'+csFORECOLOR+csBKCOLOR+'" cellpadding="1" cellspacing="1">';
////sHead:=sHead+'  <tr border=0 style="background-color:silver;color:#000000;white-space:normal;text-shadow:#555 1px 1px 3px;border-color:#ffffff;" valign=top>'
//sHead:=sHead+'  <tr border=0 valign=top style="background-color:#ffffff;color:#000000;white-space:normal;border-color:#ffffff;" valign=top>'
//    +'<th>Ord<th>Serie<th style="white-space:nowrap;">N°<th>Documento<th>Fecha<th>Hora<th>DNI/RUC<th>Cliente<th width=1>S/.<th width=1 title="Suma de filtrado de caja">'
//    //+iif(vAcc[uSYS] or vAcc[uADM],format('%2f',[tTotal]),'')
//    +format('%2f',[tTotal])
//    +'<td style="font-size:14px;" title="Suma de toda la caja">'
//    +format('S/%2f',[totTodo])
//    +'<th>Cajero<th>Vendedor<th>Grupo'
//    //+'<tr height=3px><td rowspan=1 colspan=13><hr>'
//    ;
//s:=sHead+s+'</table></div>:_:'+IntToStr(tCmd)+':_:'+cuenta+':_:';
//except on e: Exception do begin log(e.Message); s:=e.Message; end
//end;
//w(s);
end;

function pCPEnviaUno(docVta:String):String;
var s,drive:String; //acá se envia facturas/boletas a sunat
begin
try
log('<pCPEnviaUno('+docVta+')');  //20559678491-01-F021-98
stCad:=TStringList.Create;
//stCad.SaveToFile(dirname(__FILE__,200)."ultranet/xampp/cgi-bin/"+sisOrg+'/fe/json/'+xRUC+'-'+txtNRO_COMPROBANTE+'.js');
drive:=ExtractFileDrive(ParamStr(0));
s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/cpe_envioUno.php '
  +docVta
  ;
pCmdLinea(s,       drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docVta+'.cdr');
stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docVta+'.cdr');
log('Resultado de pCmdLinea:'+stCad.Text);
s:=trim(stCad.Text);
//splitCar(s,'"');
//if pT[1]='Ok' then
//   begin xQ('update VENTA set HASH_CDR='''+pT[2]+''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO);
//         tr.Commit;
//   end;
except on e: Exception do begin log(e.Message); s:=e.Message; end
end;
result:=s;
//pCPEnviaUno('pCPEnviaUno:'+s);
//pCPEnviaUno>
end;

function pGenXMLfromVentaUno(docVta:String):String;
var n,i,c:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    sFE,sFEdet,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,
    txtCOD_TIPO_MOTIVO,txtDESCRIPCION_MOTIVO,
    txtTIPO_COMPROBANTE_MODIFICA,txtNRO_DOCUMENTO_MODIFICA,
    txtNRO_COMPROBANTE,txtCOD_TIPO_DOCUMENTO,
    txtNRO_DOCUMENTO_CLIENTE,xRUC,IDDOC,SERIE,NRO,resCPEenviado,s,
    VTAIDDOC,VTAFECHA,VTAFVENCE,VTAHORA,
    cpeRUC,cpeRSocialTienda,cpeDomicilio,pWeb,drive
    :String;
    IGV:Real;

begin
try
log('<pGenXMLfromVentaUno('+docVta+')');
stCad:=TStringList.Create;

//OSE proceso FEmodo:='1';
FEmodo:=cnfParamGetIni('FEMODO','3','F.E. Modo');

c:=splitCar(docVta,'-'); // 20559678491-01-F021-98
xRUC:=pT[1];
txtCOD_TIPO_DOCUMENTO:=pT[2];
txtNRO_COMPROBANTE:=pT[3]+'-'+pT[4];
drive:=ExtractFileDrive(ParamStr(0));
if      txtCOD_TIPO_DOCUMENTO='01' then IDDOC:='11'
else if txtCOD_TIPO_DOCUMENTO='03' then IDDOC:='10'
else if txtCOD_TIPO_DOCUMENTO='07' then IDDOC:='63'
else DatabaseError('Error IDDOC('+txtCOD_TIPO_DOCUMENTO+') no identificado');

//if copy(pT[3],1,1)='F' then IDDOCUMENTO:=DOCFACVTA else IDDOCUMENTO:=DOCBOLVTA;
SERIE:=IntToStr(StrToInt(copy(pT[3],2,3)));
NRO:=trim(pT[4]);
pWeb:=cnfParamGetIni('FELINK','www','Link de consulta CPE');
igv:=rQFloat('select VALOR from CNFPARAM where ID=''IGV''');
ShortTimeFormat := 'hh:mm:ss';
//old 2.1 bIq('select * from VENTA,CLIENTE where IDCLIENTE=CLIENTE.ID and IDDOCUMENTO='+IDDOC+' and SERIE='+SERIE+' and NRO='+NRO);
bIq('select VENTA.*,CLIENTE.*,substring(cast(HORA as varchar(20)) from 1 for 8) FHORA from VENTA,CLIENTE where IDCLIENTE=CLIENTE.ID and IDDOCUMENTO='+IDDOC+' and SERIE='+SERIE+' and NRO='+NRO);
VTAIDDOC:=lPad(trim(qsI('VTAIDDOC')),'0',2);
VTAFECHA:=IbFechaGuion(iq.FieldByName('FECHA').AsDateTime);
VTAFVENCE:=IbFechaGuion(iq.FieldByName('FECHA').AsDateTime+30);
VTAHORA:=qsI('FHORA');

{$If Defined(BDshared)}
if bQ('select RUC,RSOCIAL,DOMIC from CAJATERMINAL,EMP where RUC=EMP.ID and CAJATERMINAL.ID='+qsI('IDCJATRM'))=0 then
   DatabaseError('<pGenXMLfromVentaUno: RUC no ubicado en CAJATERMINAL');
cpeRUC:=            qs('RUC');
cpeRSocialTienda:=  qs('RSOCIAL');
cpeDomicilio:=      qs('DOMIC');
{$Else}
cpeRUC:=            RUC;
cpeRSocialTienda:=  rSocialTienda;
cpeDomicilio:=      Domicilio;
{$IfEnd}

n:=0;
while not iq.eof do
  begin
        txtNRO_DOCUMENTO_CLIENTE:=Trim(qsI('DI'));
        //rSOCIAL:=(qsI('RAZONSOCIAL'));
        //cliDIR:=(qsI('DIRECCION'));
        rSOCIAL:=StringReplace(qsI('RAZONSOCIAL'),'&',' ',[rfReplaceAll, rfIgnoreCase]);
        rSOCIAL:=StringReplace(rSOCIAL,'"','¨',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(qsI('DIRECCION'),  '&',' ',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  '"','¨',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  'Ñ','N',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  '?',' ',[rfReplaceAll, rfIgnoreCase]);
        sFEdet:='';
        aPagar:=0;tIGV:=0;inafecta:=0;
        //post 2.1 al 11/06/2019
        s:=  'select round(IMPORTE/(1.0+18.0/100.0)/CANTIDAD,2) PUNITDEDUC,';
        s:=s+'       round(IMPORTE/(1.0+18.0/100.0),2) SUBTOTDEDUC,';
        s:=s+'       IMPORTE-round(IMPORTE/(1.0+18.0/100.0),2) IGVSUBTOTDEDUC,';
        s:=s+'       VVENTADET.* from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO');
        bQ(s);
        //old
        //bQ('select * from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO'));
        i:=0;
        while not q.eof do
          begin inc(i);
                aPagar:=aPagar+q.FieldByName('IMPORTE').AsFloat;
                tIGV:=tIGV+q.FieldByName('IMPORTE').AsFloat*(igv/100.0);
                if i>1 then sFEdet:=sFEdet+',';
                sImporte:=Format('%.2f',[qf('IMPORTE')]);
                sIGV:=Format('%.2f',[qf('IMPORTE')*(igv/100.0)]);
                sFEdet:=sFEdet
                            +'{"txtITEM":"'+IntToStr(i)
                            +'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
                            +'","txtPRECIO_DET":"'+Format('%.2f',[q.FieldByName('PUNITDEDUC').AsFloat])
//bota error desde junio    +'","txtPRECIO_DET":"'+Format('%.2f',[q.FieldByName('PUNITDEDUC').AsFloat])
                            +'","txtIMPORTE_DET":"'+Format('%.2f',[q.FieldByName('SUBTOTDEDUC').AsFloat])
                            +'","txtPRECIO_TIPO_CODIGO":"01'
                            +'","txtIGV":"'+Format('%.2f',[q.FieldByName('IGVSUBTOTDEDUC').AsFloat])
                            +'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
                            +'","txtDESCRIPCION_DET":"'
                            +StringReplace(qTrim('DESCRIPCION'),'"','¨',[rfReplaceAll, rfIgnoreCase])
                            +'"}';
//                             //post 2.1 al 11/06/2019
//                             +'{"txtITEM":"'+IntToStr(i)
//                             +'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
//                             +'","txtPRECIO_DET":"'+Format('%.2f',[qf('PFRAC')])
////old 2.1                             +'","txtPRECIO_DET":"'+Format('%.2f',[StrToFloat(sImporte)-StrToFloat(sIGV)])
//                             //+'","txtIMPORTE_DET":"'+Format('%.2f',[qf('PFRAC')*qf('CANTIDAD')-qf('PFRAC')*qf('CANTIDAD')*1.18/100.00])
//                             +'","txtIMPORTE_DET":"'+Format('%.2f',[qf('IMPORTE')/(1.0+igv/100.0)])
//                             +'","txtPRECIO_TIPO_CODIGO":"01'
//                             +'","txtIGV":"'+sIGV
//                             +'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
//                             +'","txtDESCRIPCION_DET":"'
//                             +StringReplace(qTrim('DESCRIPCION'),'"','¨',[rfReplaceAll, rfIgnoreCase])
//                             +'"}';
                q.Next;
          end;
        totalVta:=aPagar-tIGV;

        TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
        SUBTOTAL:=aPagar-TIGVdeducido;
        txtSUB_TOTAL:=format('%.2f',[SUBTOTAL]);
        txtTOTAL:=format('%.2f',[aPagar]);
        txtTOTAL_IGV:=format('%.2f',[StrToFloat(txtTOTAL)-StrToFloat(txtSUB_TOTAL)]);
        sFE:=format('{"txtTOTAL_GRAVADAS":"%s","txtSUB_TOTAL":"%s","txtTOTAL_IGV":"%s","txtTOTAL":"%s","txtTOTAL_LETRAS":"%s"',
                    [txtSUB_TOTAL,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,solesAletras(aPagar)]
                   );
        txtTIPO_COMPROBANTE_MODIFICA:='';txtNRO_DOCUMENTO_MODIFICA:='';
        txtCOD_TIPO_MOTIVO:='';txtDESCRIPCION_MOTIVO:='';
        if IDDOC=DOCNTCREDVTA then
                begin
                      if      VTAIDDOC=DOCFACVTA then
                         begin txtTIPO_COMPROBANTE_MODIFICA:='01';
                               txtNRO_DOCUMENTO_MODIFICA:='F'+lPad(trim(qsI('VTASERIE')),'0',3)+'-'+trim(qsI('VTANRO'));
                         end
                      else if VTAIDDOC=DOCBOLVTA then
                         begin txtTIPO_COMPROBANTE_MODIFICA:='03';
                               txtNRO_DOCUMENTO_MODIFICA:='B'+lPad(trim(qsI('VTASERIE')),'0',3)+'-'+trim(qsI('VTANRO'));
                         end
                      else DatabaseError('Documento interno qsI(VTAIDDOC) '+VTAIDDOC+' no definido');
                      txtCOD_TIPO_MOTIVO:='01';txtDESCRIPCION_MOTIVO:='ANULACION DE LA OPERACION';
                end;

        //txtNRO_COMPROBANTE:=iif(IDDOC=DOCFACVTA,'F','B')+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
        sFE:=sFE
            +',"txtNRO_COMPROBANTE":"'           +txtNRO_COMPROBANTE+'"'
            +',"txtFECHA_DOCUMENTO":"'           +VTAFECHA{IbFechaGuion(now)}+'"'
            +',"txtFVENCE_DOCUMENTO":"'          +VTAFVENCE+'"'
            +',"txtHORA_DOCUMENTO":"'            +VTAHORA+'"'
            +',"txtP100IGV":"'                   +FloatToStr(IGV)+'"'
            +',"txtCOD_TIPO_DOCUMENTO":"'        +txtCOD_TIPO_DOCUMENTO+'"'
            +',"txtCOD_MONEDA":"PEN"'
            +',"txtLineCountNumeric":"'          +IntToStr(i)+'"'
            +',"txtTIPO_COMPROBANTE_MODIFICA":"' +txtTIPO_COMPROBANTE_MODIFICA+'"'
            +',"txtNRO_DOCUMENTO_MODIFICA":"'    +txtNRO_DOCUMENTO_MODIFICA+'"'
            +',"txtCOD_TIPO_MOTIVO":"'           +txtCOD_TIPO_MOTIVO+'"'
            +',"txtDESCRIPCION_MOTIVO":"'        +txtDESCRIPCION_MOTIVO+'"'
            +',"txtNRO_DOCUMENTO_CLIENTE":"'     +txtNRO_DOCUMENTO_CLIENTE+'"'
            +',"txtRAZON_SOCIAL_CLIENTE":"'      +rSOCIAL+'"'
            +',"txtTIPO_DOCUMENTO_CLIENTE":"'    +iif(Length(txtNRO_DOCUMENTO_CLIENTE)=11,'6','1')+'"'
            +',"txtDIRECCION_CLIENTE":"'         +cliDIR+'"'
            +',"txtCIUDAD_CLIENTE":"TRUJILLO","txtCOD_PAIS_CLIENTE":"PE","txtNRO_DOCUMENTO_EMPRESA":"'+cpeRUC+'"'
            +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"'+cpeRSocialTienda+'"'
            +',"txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"'+cpeDomicilio+'"'
            +',"txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"'
            +cpeRSocialTienda+'"'
            +',"txtUSUARIO_SOL_EMPRESA":"'+usTiendaSOL+'"'
            +',"txtPASS_SOL_EMPRESA":"'+psTiendaSOL+'"'
            +',"psFirma":"'+psFirma+'"'
            +',"pWeb":"'+pWeb+'"'
            ;
        sFE:=sFE
            +',"txtTIPO_PROCESO":"'+FEmodo+'"'
            +',"detalle":['+sFEdet+']'
            +',"datosGenerales":[{'
            + '"IDCAJAT":""'
            +',"VENDEDOR":""'
            +',"CAJERO":""'
            +'}]'
            +'}'
            ;
        //Lee Json y genera xml firmado y hash de ida
        stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
        stCad.SaveToFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/'+docVta+'.js');
        s:=drive+'/ultranet/xampp/php/php.exe '+drive+'ultranet/xampp/htdocs/fe/controller/controller_cpeFromArchFromLazarusDaeFe.php '
          +docVta+'.js'
          ;
        pCmdLinea(s,       drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docVta+'.js.txt');
        stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docVta+'.js.txt');

        log('Resultado de pCmdLinea:'+stCad.Text);
        iq.Next;
        inc(n);
  end;
//WriteLn('Ok|XML generados para enviar a SUNAT: '+IntToStr(n));
//s:=StringReplace(stCad.Text,':_:_:','ñ',[rfReplaceAll, rfIgnoreCase]);
//DatabaseError('nO ES ERROR');
//exit;
s:=trim(stCad.Text);//Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="  (hash de ida)
splitCar(s,'"');
log('pT[1]'+pT[1]+'|');
if pT[1]='Ok'
   then  begin xQ('update VENTA set HASH_CDR='''+pT[2]+''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC);
               resCPEenviado:=pCPEnviaUno(docVta)+'"';  // este es el que envia sunat
               splitCar(resCPEenviado,'"');
               if pT[1]='1'
                  then begin if trim(rQ('select FENVIO from VENTA where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC))
                                =''
                                then xQ('update VENTA set COD_SUNAT='''
                                       +StringReplace(pT[2],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''',MSJ_SUNAT='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +iif(pT[2]='?','',''',CON_CDR=''S') //Sunat no devolvio Zip de respuesta
                                       +''',MSJ_DEVUELTO='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''',FENVIO=current_date,HENVIO=current_time,USENVIO='+IDUSLOGUEO
                                       +' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC)
                                else xQ('update VENTA set COD_SUNAT='''
                                       +StringReplace(pT[2],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''',MSJ_SUNAT='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC);
                             s:=s+pT[2]+'"'+pT[3]+'"';
                             //Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="0000"...aceptada u otro..."

                       end
                  else s:=s+'Error"'+resCPEenviado+'"';
                       //Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="Error"...mensaje de error..."
                       //0          1                      2         3
               tr.CommitRetaining;
         end
   else DatabaseError(s);
except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
w(s);
//pGenXMLfromVentaUno>
end;

function pGenXMLfromVentaRango(xvar:String):String;
var n,i,c:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    filEstado,sFE,sFEdet,idVtaCliDocTipo,
    dir1,dir2,ultProd,almProd,sAlm,cliDIR,rSOCIAL,Vend,cajero,ubigeo,sImporte,sIGV,
    FEmodo,DSERIENRO,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,txtNRO_COMPROBANTE,
    txtNRO_DOCUMENTO_CLIENTE,IDDOCUMENTO,SERIE,NRO,empresa,
    IDESTADO,fIni,fFin,ruta,drive:String;
    IGV:Real;

begin
try
log('<pGenXMLfromVentaRango('+xvar+')');
stCad:=TStringList.Create;
drive:=ExtractFileDrive(ParamStr(0));

//OSE proceso FEmodo:='1';
FEmodo:=cnfParamGetIni('FEMODO','3','F.E. Modo');

splitCar(xvar);
IDESTADO:=pT[1];fIni:=pT[2];fFin:=pT[3];
if IDESTADO='*' then filEstado:=' and (IDESTADO=''V'' or IDESTADO=''E'')'
else if IDESTADO='V' then filEstado:=' and IDESTADO=''V'''
else if IDESTADO='E' then filEstado:=' and IDESTADO=''E'''
else begin DatabaseError('Error|Estado debe ser *, V ó E');halt; end;
igv:=rQFloat('select VALOR from CNFPARAM where ID=''IGV''');
bIq('select * from VENTA,CLIENTE where IDCLIENTE=CLIENTE.ID and IDDOCUMENTO in (10,11)'+filEstado+' and VENTA.FECHA>='''+fIni+''' and VENTA.FECHA<='''+fFin+''''
   +' order by VENTA.FECHA desc,VENTA.HORA desc');
n:=0;
while not iq.eof do
  begin
        txtNRO_DOCUMENTO_CLIENTE:=Trim(qsI('DI'));
        rSOCIAL:=trim(qsI('RAZONSOCIAL'));
        cliDIR:=(qsI('DIRECCION'));
        sFEdet:='';
        aPagar:=0;tIGV:=0;inafecta:=0;
        bQ('select * from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO'));
        i:=0;
        while not q.eof do
          begin inc(i);
                aPagar:=aPagar+q.FieldByName('IMPORTE').AsFloat;
                tIGV:=tIGV+q.FieldByName('IMPORTE').AsFloat*(igv/100.0);
                if i>1 then sFEdet:=sFEdet+',';
                sImporte:=Format('%.2f',[qf('IMPORTE')]);
                sIGV:=Format('%.2f',[qf('IMPORTE')*(igv/100.0)]);
                sFEdet:=sFEdet
                             +'{"txtITEM":"'+IntToStr(i)
                             +'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
                             +'","txtPRECIO_DET":"'+Format('%.2f',[StrToFloat(sImporte)-StrToFloat(sIGV)])
                             +'","txtIMPORTE_DET":"'+sImporte
                             +'","txtPRECIO_TIPO_CODIGO":"01'
                             +'","txtIGV":"'+sIGV
                             +'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
                             +'","txtDESCRIPCION_DET":"'+qTrim('DESCRIPCION')
                             +'"}';
                q.Next;
          end;
        totalVta:=aPagar-tIGV;

        TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
        SUBTOTAL:=aPagar-TIGVdeducido;
        txtSUB_TOTAL:=format('%.2f',[SUBTOTAL]);
        txtTOTAL:=format('%.2f',[aPagar]);
        txtTOTAL_IGV:=format('%.2f',[StrToFloat(txtTOTAL)-StrToFloat(txtSUB_TOTAL)]);
        sFE:=format('{"txtTOTAL_GRAVADAS":"%s","txtSUB_TOTAL":"%s","txtTOTAL_IGV":"%s","txtTOTAL":"%s","txtTOTAL_LETRAS":"%s"',
                    [txtSUB_TOTAL,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,solesAletras(aPagar)]
                   );
        idVtaCliDocTipo:=qsI('IDDOCUMENTO');
        txtNRO_COMPROBANTE:=iif(idVtaCliDocTipo=DOCFACVTA,'F','B')+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
        sFE:=sFE
            +',"txtNRO_COMPROBANTE":"'+txtNRO_COMPROBANTE+'"'
            +',"txtFECHA_DOCUMENTO":"'+IbFechaGuion(iq.FieldByName('FECHA').AsDateTime)+'"'
            +',"txtCOD_TIPO_DOCUMENTO":"'+iif(idVtaCliDocTipo=DOCFACVTA,'01','03')+'"'
            +',"txtCOD_MONEDA":"PEN","txtTIPO_COMPROBANTE_MODIFICA":"","txtNRO_DOCUMENTO_MODIFICA":"","txtCOD_TIPO_MOTIVO":"","txtDESCRIPCION_MOTIVO":""'
            +',"txtNRO_DOCUMENTO_CLIENTE":"'+txtNRO_DOCUMENTO_CLIENTE+'"'
            +',"txtRAZON_SOCIAL_CLIENTE":"'+rSOCIAL+'"'
            +',"txtTIPO_DOCUMENTO_CLIENTE":"'+iif(Length(txtNRO_DOCUMENTO_CLIENTE)=11,'6','1')+'"'
            +',"txtDIRECCION_CLIENTE":"'+cliDIR+'"'
            +',"txtCIUDAD_CLIENTE":"TRUJILLO","txtCOD_PAIS_CLIENTE":"PE","txtNRO_DOCUMENTO_EMPRESA":"'+RUC+'"';
        //if RUC='20559678491' then
        //   sFE:=sFE
        //    +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"A & ANTICONA GROUP E.I.R.L.","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"CAL.JOSE GALVEZ NRO. 501 BARRIO CHICAGO (A 1 CDRA. DEL MAYORISTA) ","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"A & ANTICONA GROUP E.I.R.L."'
        //    +',"txtUSUARIO_SOL_EMPRESA":"ANTICO77","txtPASS_SOL_EMPRESA":"apolitano75"';
        //if RUC='20440459588' then
        //   sFE:=sFE
        //    +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"APOLO BIKES","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"PJ. GREGORIO ALBARRACIN NRO. 238 CC APOLO (2DO PISO)","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"BICI INDUSTRIAS APOLO E.I.R.L."'
        //    +',"txtUSUARIO_SOL_EMPRESA":"JAVIER19","txtPASS_SOL_EMPRESA":"apolitano"';
        //if (RUC='20602637116') //fms
        //or (RUC='10178693714') //caper
        //or (RUC='20482631275') //anvic
        //or (RUC='20481329281') //alneda
        //or (RUC='20601054184') //yetsy
        //or (RUC='10181201075') //jhoanir
        //   then
           sFE:=sFE
            +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"'+rSocialTienda+'","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"'
            +Domicilio+'","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"'+rSocialTienda+'"'
            +',"txtUSUARIO_SOL_EMPRESA":"'+usTiendaSOL+'","txtPASS_SOL_EMPRESA":"'+psTiendaSOL+'"';
        sFE:=sFE
            +',"txtTIPO_PROCESO":"'+FEmodo+'"'
            //+',"detalle":['+sFEdet+']}';
            +',"detalle":['+sFEdet+']'
            +',"datosGenerales":[{'
            + '"IDCAJAT":""'
            +',"VENDEDOR":""'
            +',"CAJERO":""'
            +'}]'
            +'}'
            ;
        //WriteLn(sFE);
        stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
        stCad.SaveToFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/'+RUC+'-'+txtNRO_COMPROBANTE+'.js');
        s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/controller_cpeFromArchFromLazarusDaeFe.php '
          +RUC+'-'+txtNRO_COMPROBANTE+'.js'
          ;
        pCmdLinea(s,drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+RUC+'-'+txtNRO_COMPROBANTE+'.js.txt');
        stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+RUC+'-'+txtNRO_COMPROBANTE+'.js.txt');

        s:=trim(stCad.Text);
        splitCar(s,'"');
        if pT[1]='Ok' then
           begin xQ('update VENTA set HASH_CDR='''+pT[2]+''' where SERIE='+trim(qsI('SERIE'))+' and NRO='+trim(qsI('NRO'))
                   +' and IDDOCUMENTO='+idVtaCliDocTipo);
                 tr.CommitRetaining;
           end;

        iq.Next;
        inc(n);
  end;
except on e: Exception do begin log(e.Message); s:=e.Message; end
end;
w(s);
//pGenXMLfromVentaRango>
end;

function pFEfiltro(xvar:String):string;
var idFIni,idFFin,idProv,idIdDocTipo,idSerie,idNro,idMax,idEst,
    idFechaFil,idCodSunat,idIdDocTipoFil,idSerieFil,idNroFil,idCodSunatFil,idEstFil,
    cadBusca,buscaPor,sI,s,sHead,pkVENTA,IDESTADO,marcaEA,idVtaCliDocTipo,
    txtCOD_TIPO_DOCUMENTO,txtTIPO_COMPROBANTE_MODIFICA,txtNRO_DOCUMENTO_MODIFICA,
    txtCOD_TIPO_MOTIVO,txtDESCRIPCION_MOTIVO,FULLDOCVTA,
    cpeRUC,
    docBKCOLOR,docForeCOLOR,
    vtaBKCOLOR,vtaForeCOLOR,
    estBKCOLOR,estForeCOLOR,
    msgBKCOLOR,msgForeCOLOR,cuenta,
    onclickCDR,docDes,cliDes,sSERIE,
    onclickTICKET:String;
    i,c,tCmd:SmallInt;
begin
try
log('<pFEfiltro('+xvar+')');
//funciona ok pCmdLinea(dirname(__FILE__,200)."ultranet\xampp\cgi-bin\daeFe/daeFe ticketConsulta 20559678491 201802284228229",'d:/pruebaDaeDeLlamadaDeCgi.txt');
if not (vAcc[uSYS] or vAcc[uADM] or vAcc[uCAJ])then DatabaseError('Ud., no puede entrar a este módulo');
splitCar(xvar);
idFIni:=       pT[1];
idFFin:=       pT[2];
idProv:=       pT[3];
idIdDocTipo:=  pT[4];
idSerie:=      trim(pT[5]);  if idSerie<>'' then idSerie:=IntToStr(StrToInt(idSerie));
idNro:=        trim(pT[6]);  if idNro<>''   then idNro:=IntToStr(StrToInt(idNro));
idMax:=        pT[7];
idCodSunat:=   pT[8];
idEst:=        pT[9];
idFechaFil:='';idIdDocTipoFil:='';idSerieFil:='';idNroFil:='';idCodSunatFil:='';idEstFil:='';

cadBusca:='';
{$If Defined(SYSANTICONA) or Defined(SYSJHOANIR) or Defined(SYSCDOLAR)}
//cadBusca:='where (IDESTADO=''V'' or IDESTADO=''E'') and IDDOCUMENTO in (10,11) and SERIE in (21,22,23,24,25,26,27,28,29)';
cadBusca:='where (IDESTADO=''V'' or IDESTADO=''E'') and IDDOCUMENTO in (10,11)';
{$IfEnd}
{$If Defined(SYSAPOLO) or Defined(SYSYETSY) or Defined(SYSDESING)}
//cadBusca:='where IDESTADO in (''V'',''E'',''C'') and IDDOCUMENTO in (10,11,63) and SERIE in (101,102,103,104,105,106,107,108,109)';
cadBusca:='where IDESTADO in (''V'',''E'',''C'') and IDDOCUMENTO in (10,11,63)';
{$IfEnd}
{$If Defined(SYSANVIC) or Defined(SYSVICAFE) or Defined(SYSESTEL) or Defined(SYSEDSA) or Defined(SYSNSO) or Defined(SYSMIMPORT) or Defined(SYSLEDCAR) or Defined(SYSICQ) or Defined(SYSCRISTHY) or Defined(SYSKACCELL) or Defined(SYSDLEOPARD) or Defined(SYSOMAPE)  or Defined(SYSJOHNNY) or Defined(SYSTURBOSQL) or Defined(SYSCALZAA) or Defined(SYSTIENDA) or Defined(SYSSALUD) or Defined(SYSAYP) or Defined(SYSAGAPITO)}
cadBusca:='where IDESTADO in (''V'',''E'',''C'') and IDDOCUMENTO in (10,11,63) and SERIE in (1,2,3,4,5,6,7,8,9)';
{$IfEnd}
{$If Defined(SYSFMS) or Defined(SYSANPER) or Defined(SYSLIDER)}
cadBusca:='where IDESTADO in (''V'',''E'',''C'') and IDDOCUMENTO in (10,11,63) and SERIE in (10,11,12,13,14,15,16,17,18,19)';
{$IfEnd}
{$If Defined(SYSBICI)}
cadBusca:='where (IDESTADO=''V'' or IDESTADO=''E'') and IDDOCUMENTO in (10,11) and SERIE in (20,21,22,23,24,25,26,27,28,29)';
{$IfEnd}
{$If Defined(SYSDYM)}
cadBusca:='where IDESTADO in (''V'',''E'',''C'') and IDDOCUMENTO in (10,11,63) and SERIE in (1,2,3,4,5,6,7,8,9)';
{$IfEnd}
{$If Defined(SYSFREMAR) or Defined(SYSHEINER) or Defined(SYSCAPER) or Defined(SYSDEMO)
  or Defined(SYSDANNY)}
cadBusca:='where IDESTADO in (''V'',''E'',''C'') and IDDOCUMENTO in (10,11,63) and SERIE in (1,2,3,4,5,6,7,8,9)';
{$IfEnd}
if cadBusca='' then DatabaseError('Empresa no registrada');

if idProv<>'' then
   begin c:=splitCar(idProv,' ');
         if c=0 then pT[1]:='';
         if esNro(trim(pT[1]))
            then begin buscaPor:='IDCLIENTE';
                       cadBusca:=cadBusca+' and '+BuscaPor+' like '''+(trim(pT[1]))+'%''';
                 end
            else begin buscaPor:='upper(CLIENTE)';
                       cadBusca:=cadBusca+' and '+BuscaPor+' like '''+UpperCase(trim(pT[1]))+'%''';
                       for i:=2 to c do
                         begin cadBusca:=cadBusca+' and '+BuscaPor+' like ''%'+UpperCase(pT[i])+'%''';
                         end;
                 end;
   end;
if (idFFin<>'') and (idFFin<>'') then idFechaFil:=' and FECHA>='''+idFIni+''' and FECHA<='''+idFFin+'''';
if idIdDocTipo<>'' then idIdDocTipoFil:=' and IDDOCUMENTO='+idIdDocTipo;
if idSerie<>''     then idSerieFil    :=' and cast(SERIE as integer)='''+idSerie+'''';
if idNro<>''       then idNroFil      :=' and cast(NRO as integer)='''+idNro+'''';
if idCodSunat<>'*' then idCodSunatFil :=' and trim(COD_SUNAT)='''+Trim(idCodSunat)+'''';
if idCodSunat=''   then idCodSunatFil :=' and (trim(COD_SUNAT)='''' or COD_SUNAT is null)';
if idEst<>'*'      then idEstFil      :=' and IDESTADO='''+idEst+'''';
cuenta:=rQ('select count(*) from VVENTACPE '
          +cadBusca+idFechaFil+idIdDocTipoFil+idSerieFil+idNroFil+idCodSunatFil+idEstFil
          );
s:='select first '+idMax+' * from VVENTACPE '
  +cadBusca+idFechaFil+idIdDocTipoFil+idSerieFil+idNroFil+idCodSunatFil+idEstFil
  +' order by FECHA,IDDOCUMENTO,cast(SERIE as integer),cast(NRO as integer),HORA';
bq(s);
s:='';i:=0;
while not q.eof do
  begin sI:=IntToStr(i);
        idVtaCliDocTipo:=qs('IDDOCUMENTO');
        //pkVENTA:=        qs('SERIE')+palo+qs('NRO')+palo+idVtaCliDocTipo;
        IDESTADO:=       qs('IDESTADO');
        {$If Defined(BDshared)}
        cpeRUC:=qs('CPERUC');
        {$Else}
        cpeRUC:=RUC;
        {$IfEnd}
        txtTIPO_COMPROBANTE_MODIFICA:='';txtNRO_DOCUMENTO_MODIFICA:='';
        txtCOD_TIPO_MOTIVO:='';txtDESCRIPCION_MOTIVO:='';

        if      idVtaCliDocTipo=DOCFACVTA    then
                begin txtCOD_TIPO_DOCUMENTO:='01';
                      sSERIE:= 'F'+lPad(strIntStr(qs('SERIE')),'0',3);
                      pkVENTA:=sSERIE+'|'+qs('NRO')+'|'+idVtaCliDocTipo;
                end
        else if idVtaCliDocTipo=DOCBOLVTA    then
                begin txtCOD_TIPO_DOCUMENTO:='03';
                      sSERIE:='B'+lPad(strIntStr(qs('SERIE')),'0',3);
                      pkVENTA:=sSERIE+'|'+qs('NRO')+'|'+idVtaCliDocTipo;
                end
        else if idVtaCliDocTipo=DOCNTCREDVTA then
                begin txtCOD_TIPO_DOCUMENTO:='07';
                      if      qs('VTAIDDOC')=DOCFACVTA then
                         begin txtTIPO_COMPROBANTE_MODIFICA:='01';
                               txtNRO_DOCUMENTO_MODIFICA:='F'+lPad(trim(qs('VTASERIE')),'0',3)+'-'+trim(qs('VTANRO'));
                               sSERIE:='F'+lPad(strIntStr(qs('SERIE')),'0',3);
                               pkVENTA:=sSERIE+'|'+qs('NRO')+'|'+idVtaCliDocTipo;
                         end
                      else if qs('VTAIDDOC')=DOCBOLVTA then
                         begin txtTIPO_COMPROBANTE_MODIFICA:='03';
                               txtNRO_DOCUMENTO_MODIFICA:='B'+lPad(trim(qs('VTASERIE')),'0',3)+'-'+trim(qs('VTANRO'));
                               sSERIE:='B'+lPad(strIntStr(qs('SERIE')),'0',3);
                               pkVENTA:=sSERIE+'|'+qs('NRO')+'|'+idVtaCliDocTipo;
                         end
                      else DatabaseError('Documento interno qs(''VTAIDDOC'') '+qs('VTAIDDOC')+' no definido');
                      txtCOD_TIPO_MOTIVO:='01';txtDESCRIPCION_MOTIVO:='ANULACION DE LA OPERACION';
                end
        else DatabaseError('Documento interno (idVtaCliDocTipo) '+idVtaCliDocTipo+' no definido');

        FULLDOCVTA:=cpeRUC+'-'+txtCOD_TIPO_DOCUMENTO+'-'+sSERIE+'-'+strIntStr(qs('NRO'));

        if      (qs('DITIPO')='0') then
             begin docBKCOLOR:='background-color:#2E4053;';docForeCOLOR:='color:#ffffff;';
             end
        else if (qs('DITIPO')='6') then
             begin docBKCOLOR:='background-color:#6E2C00;';docForeCOLOR:='color:#ffffff;';
             end
        else begin marcaEA:='';
                   docBKCOLOR:='background-color:#F2F3F4;';docForeCOLOR:='color:#000000;';
             end;
        if (qs('IDDOCUMENTO')=DOCFACVTA)
           then begin vtaBKCOLOR:='background-color:#0B5345;';vtaForeCOLOR:='color:#ffffff;';
                end
           else begin marcaEA:='';
                      vtaBKCOLOR:='background-color:#F2F3F4;';vtaForeCOLOR:='color:#000000;';
                end;
        if (IDESTADO='E')
           then begin //marcaEA:='font-style:italic;';
                      estBKCOLOR:='background-color:#943126;';estForeCOLOR:='color:#ffffff;';
                end
           else begin marcaEA:='';
                      estBKCOLOR:='background-color:#F2F3F4;';estForeCOLOR:='color:#000000;';
                end;
        if  (qs('COD_SUNAT')='0') or (qs('COD_SUNAT')='0001') then
             begin msgBKCOLOR:='background-color:#0B5345;';msgForeCOLOR:='color:#ffffff;';
             end
        else if qs('COD_SUNAT')='0002' then
             begin msgBKCOLOR:='background-color:#FE2E64;';msgForeCOLOR:='color:#FFFF00;';
             end
        else begin msgBKCOLOR:='background-color:#FFFFFF;';msgForeCOLOR:='color:#000000;';
             end;
        s:=s+'<tr id="rowCmd_'+IntToStr(i)+'" align=center style="background-color:#F2F3F4;"'
            +' onclick="rowCmd_i='+IntToStr(i)+';" valign=top>';
        onclickCDR:=' onclick="puGetStatusCdr('+IntToStr(i)+','''+FULLDOCVTA+''');"';
        splitCar(qs('CLIENTE'),' ');  cliDes:=pT[1];
        s:=s+'<td width=1px style="font-size:11px;color:#848484;">'+IntToStr(i+1)
            +'<td style="'+vtaBKCOLOR+vtaForeCOLOR+'">'
            +iif(idVtaCliDocTipo=DOCNTCREDVTA,'NC-','')
            +sSERIE
            +'<td style="'+vtaBKCOLOR+vtaForeCOLOR+'">'+strIntStr(qs('NRO'))
            +'<td>'+ddmmaa(qs('FECHA'))
            +'<td>'+qs('HORA')
            +'<td style="'+docBKCOLOR+docForeCOLOR+'font-size:12px;">'+qs('DI')
            +'<td style="'+docBKCOLOR+docForeCOLOR+'font-size:12px;" align=left title="'+qs('CLIENTE')
                          +'" onclick="pCPEq('+sI+','''+cpeRUC+'|'+qs('DI')+'|'+sSERIE+'|'+strIntStr(qs('NRO'))
                          +'|'+qs('FECHA')+'|'+format('%.2f',[qf('TOTAL')])+''');">'+cliDes
            +'<div id=dvCPEq_'+sI+'></div>'
            +'<td align=right>'+format('%.2f',[qf('TOTAL')])
            ;
        if (IDESTADO='E')
           then begin if (qTrim('COD_SUNAT')='0011') or (qTrim('COD_SUNAT')='') or (qTrim('COD_SUNAT')='0003')
                         then s:=s+'<td id=tdBaja_'+IntToStr(i)+' style="'+estBKCOLOR+estForeCOLOR
                                  +'">'+qs('IDESTADO')
                         else s:=s+'<td id=tdBaja_'+IntToStr(i)+' style="'+estBKCOLOR+estForeCOLOR
                                  +'cursor:pointer;" onclick="pDarDeBaja('''+pkVENTA+''','+IntToStr(i)+');"'
                                  +' title="Dar de baja">'+qs('IDESTADO');
                end
           else s:=s+'<td id=tdBaja_'+IntToStr(i)+' style="'+estBKCOLOR+estForeCOLOR+'">'+qs('IDESTADO')
           ;
        s:=s+'<td valign=middle style="font-size:12px;cursor:pointer;'+msgBKCOLOR+msgForeCOLOR+'" id=tdCOD_SUNAT_'+IntToStr(i)+onclickCDR+'>'+qs('COD_SUNAT')
            +'<td valign=middle style="font-size:10px;cursor:pointer;'+msgBKCOLOR+msgForeCOLOR+'" id=tdMSJ_SUNAT_'+IntToStr(i)+onclickCDR+'>'+qs('MSJ_SUNAT');
        if (IDESTADO='E')
           then s:=s+'<td valign=middle style="font-size:10px;cursor:pointer;'+msgBKCOLOR+msgForeCOLOR+'" id=tdHASH_CDR_' +IntToStr(i)+' onclick="pTicketConsulta('''+qs('TICKET')+''','+IntToStr(i)+');">'+qs('TICKET')
           else s:=s+'<td valign=middle style="font-size:10px;cursor:pointer;'+msgBKCOLOR+msgForeCOLOR+'" id=tdHASH_CDR_' +IntToStr(i)+onclickCDR+'>'+qs('HASH_CDR');
        if (qs('COD_SUNAT')='0') or (qs('COD_SUNAT')='0001') or ((IDESTADO='E') and (qs('VTAIDDOC')=''))
            then s:=s+'<td id=tdGenXMLfromVenta_'+IntToStr(i)+'>'
            else s:=s+'<td id=tdGenXMLfromVenta_'+IntToStr(i)
                     +' onclick="pGenXMLfromVentaUno('+IntToStr(i)+','''+FULLDOCVTA+''');"'
                     +' style="'+'cursor:pointer;" title="Enviar documento a SUNAT">'
                     +'<img src="/uBiblio/upload22Off.png" width=18 onmouseover="this.src=''/uBiblio/upload22.png''" onmouseout="this.src=''/uBiblio/upload22off.png''">'
                     ;
        s:=s+'<td valign=middle style="font-size:10px;cursor:pointer;color:#ccc000;" id=tdMSJ_DEVUELTO_'+IntToStr(i)+' title="'+qs('MSJ_DEVUELTO')+'">'+LeftStr(qs('MSJ_DEVUELTO'),10)
            ;    //pCPEnviaUnoUno

        q.Next;
        inc(i);
  end;
tCmd:=i;
sHead:='';
sHead:=sHead+'<div class="brdTabl1">';
sHead:=sHead+'<table id=tCPE width=100% rules=cols style="font:12px tahoma,arial,calibri;border-collapse:collapse;border-color:#cccccc;color:#000000;'+csBKCOLOR+'" cellpadding=3 cellspacing=1>';
sHead:=sHead+'  <tr border=0 valign=top style="background-color:#ffffff;color:#000000;white-space:normal;border-color:#ffffff;" valign=top>'
    +'<th>Ord<th>Serie<th style="white-space:nowrap;">N°<th>Fecha<th>Hora<th>DNI/RUC<th>Cliente<th width=1>'
    +'S/'
    +'<td style="font-size:14px;">'+'E/V'
    //+'<td style="font-size:14px;">'+'NC'
    +'<th>C.CDR<th>Mensaje (Click=Consultar)<th>Hash ó Ticket de baja'
    +'<th><th>Log'
    ;
s:=sHead+s+'</table></div>:_:'+IntToStr(tCmd)+':_:'+cuenta+':_:';
except on e: Exception do begin log(e.Message); s:=e.Message; end
end;
w(s);
//pFEfiltro>
end;

procedure pFeMarco;
var s,IDCJATERM:string;
begin
try
log('<pFeMarco('+xvar+')');
if not (vAcc[uSYS] or vAcc[uADM] or vAcc[uCAJ])then DatabaseError('Ud., no puede entrar a este módulo');
setTablaCampos;
GenVm('alerta','');
GenVm('zFiltroBotones','');
GenVm('usLogueo',usLogueo);
GenVm('zCabezaOpCentro','Compras');
GenVm('titu','<title>CPE control</title>');
GenVm('zUser','');
GenVm('pnIzq','');
GenVm('tLsBotFilt','tLsBotFilt=0');
GenVm('zB2','');
GenVm('opManteMn','<a onclick="pManteMn();"><img src="'+urlImg+'mOff.png" title="Opciones" onmouseover="this.src='''+urlImg+'mOn.png''" onmouseout="this.src='''+urlImg+'mOff.png''"></a>');
GenVm('opOpMn',IntToStr(opOpMn+1));
GenVm('opRepMn',IntToStr(opRepMn+1));
GenVm('opVtaGet',IntToStr(opVtaGet));
GenVm('opVtaHistFiltro',IntToStr(opVtaHistFiltro));
GenVm('zManteAdd','');
GenVm('btGuardaInsUp','');
GenVm('btCancelaInsUp','');
GenVm('pnIzqDet','');
GenVm('opProdSaleHistMarco',IntToStr(opProdSaleHistMarco));
GenVm('URLHTTPFOLDER', URLHTTPFOLDER);
GenVm('URLHTTPuBiblio',URLHTTPuBiblio);
GenVm('urlFullExe',urlExe);
GenVm('EXEMAIN',urlExeSoloRutaSlash+EXEMAIN);
GenVm('urlImg',urlImg);
GenVm('dvVtaProv',pVtaCliComboRefresh(''));
GenVm('idSerie','');  //10:Boleta
GenVm('idNro','');
GenVm('Msg','');
GenVm('opVtaToXls',IntToStr(opVtaToXls));
IDCJATERM:=rQ('select IDCJATERM from PERSONAL where ID='+IDUSLOGUEO);
//if vAcc[uSYS] or vAcc[uADM]
//   then  begin  bQ('select ID from CAJATERMINAL');
//                s:='<select id=idCajaNro class=selNoFlecha onchange="lDocTipoChange();" style="height:100%;text-align:center;border:0px;text-decoration:none;font:12px tahoma,arial,sans-serif;color:rgb(0, 51, 0);">';//text-shadow:0.0em 0.0em 0.08em #000000;
//                s:=s+'<option value="*">Cajas';
//                while not q.eof do
//                  begin s:=s+'<option value='+qI(0)+'>Cja '+qI(0);
//                        q.Next;
//                  end;
//                s:=s+'</select>';
//         end
//   else  s:='Cja '+IDCJATERM+'<input type=hidden id=idCajaNro value="'+IDCJATERM+'">';

GenVm('tdCaja',s);
bQ('select ID from CPE_COD_SUNAT order by ID');
s:='<select id=idCodSunat onclick="pCodSunatUpdate();" class=selNoFlecha" style="height:100%;text-align:center;border:0px;text-decoration:none;font:12px tahoma,arial,sans-serif;color:rgb(0, 51, 0);">';//text-shadow:0.0em 0.0em 0.08em #000000;
s:=s+'<option value="*">Cod.Sunat (Todos)';
while not q.eof do
  begin s:=s+'<option value='+qI(0)+'>'+qI(0);
        q.Next;
  end;
s:=s+'<option value="A">Actualizar';
s:=s+'</select>';
GenVm('tdCodSunat',s);

s:='';
bQ('select distinct IDESTADO,(select DESCRIPCION from ESTADO where ESTADO.ID=IDESTADO) from VENTA');
while not q.eof do
  begin s:=s+'<option value='+qI(0)+'>'+qI(1);
        q.Next;
  end;
GenVm('lsVtaEstado',s);
if esPollo      then GenVm('var1','esPollo=true; esFarma=false;esCBello=false;esAcp=false;esBiciMoto=false;');
if CNFBASE[vaProtoTipo]=cSisFarma then GenVm('var1','esPollo=false;esFarma=true; esCBello=false;esAcp=false;esBiciMoto=false;');
if esCBello     then GenVm('var1','esPollo=false;esFarma=false;esCBello=true; esAcp=false;esBiciMoto=false;');
if esAcp        then GenVm('var1','esPollo=false;esFarma=false;esCBello=false;esAcp=true; esBiciMoto=false;');
if esBiciMoto   then GenVm('var1','esPollo=false;esFarma=false;esCBello=false;esAcp=false;esBiciMoto=true;');
GenVm('var2','fvAnioMin='+IntToStr(YearOf(now)-2000)+';');
GenVm('opCliMante',IntToStr(OPMANTEINI-1+tablaIdToIdx('CLIENTE')));
GenVm('opSerieMante',IntToStr(OPMANTEINI-1+tablaIdToIdx('DOCCAJASERIE')));
GenVm('iniScript','CNFBASE="'+CNFBASE+'";pkHistVENTA='''';sisActual="'+sisActual+'";sisOrg="'+sisOrg+'";RUC="'+RUC+'";fullEXEMAIN="'+urlExeSoloRutaSlash+EXEMAIN+'"');
w((devHTML('../uBiblio/FEmarco.html')));
EXCEPT  on e: Exception do begin log(e.Message); w(UTF8Decode(e.Message)) end;
END;
end;

function puGetStatusCdr(FULLDOCVTA:String):string;
var cad,s,USUARIO_SOL_EMPRESA,PASS_SOL_EMPRESA,
    SERIE,NRO,IDDOCUMENTO,
    txtCOD_TIPO_DOCUMENTO,drive:String;
begin
try
log('<puGetStatusCdr('+FULLDOCVTA+')');
stCad:=TStringList.Create;
drive:=ExtractFileDrive(ParamStr(0));
splitCar(FULLDOCVTA,'-'); //20440459588-07-F103-1
SERIE:=copy(pT[3],2,3);NRO:=pT[4];
if      pT[2]='01' then IDDOCUMENTO:='11'
else if pT[2]='03' then IDDOCUMENTO:='10'
else if pT[2]='07' then IDDOCUMENTO:='63'
else DatabaseError('Error tipo de documento no existe');

cad:=FULLDOCVTA;

s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/uGetStatusCdr.php '
  +cad
  ;
pCmdLinea(s,drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/getCdrMensajes/'+cad+'.txt');
stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/getCdrMensajes/'+cad+'.txt');
if pos('|',stCad.Text)=0 then DatabaseError(stCad.Text);
splitCar(trim(stCad.Text));  //cambiado 12.06.2018 estaba sin trim
//xQ('update VENTA set COD_SUNAT='''+trim(pT[1])+''', MSJ_SUNAT='''+trim(pT[2])+''', HASH_CDR=null where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO);
xQ('update VENTA set COD_SUNAT='''+trim(pT[1])+''', MSJ_SUNAT='''+trim(pT[2])
      +''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO);
tr.Commit;
s:='Ok:_:'+stCad.Text+'|';
except on e: Exception do begin log('Error:_:'+e.Message); s:='Error:_:'+e.Message; end
end;
w(s);
//pFEfiltro>
end;

function pFEConsultaRango(xvar:String):string;
var pkVENTA,s,USUARIO_SOL_EMPRESA,PASS_SOL_EMPRESA,
    cad,SERIE,NRO,IDDOCUMENTO,drive:String;
begin
try
log('<pFEConsultaRango('+xvar+')');
drive:=ExtractFileDrive(ParamStr(0));
stCad:=TStringList.Create;
splitCar(xvar);
bQ('select * from VENTA where (COD_SUNAT is null or trim(COD_SUNAT)='''') and FECHA>='''+pT[1]+''' and FECHA<='''+pT[2]+'''');
while not q.eof do
  begin
        SERIE:=qTrim('SERIE');
        NRO:=qTrim('NRO');
        IDDOCUMENTO:=qs('IDDOCUMENTO');
        //cad:=RUC+'-'+iif(IDDOCUMENTO=DOCBOLVTA,'03-B','01-F')+lPad(SERIE,'0',3)+'-'+NRO+'-'+usTiendaSOL+'-'+psTiendaSOL;
        cad:=RUC+'-'+iif(IDDOCUMENTO=DOCBOLVTA,'03-B','01-F')+lPad(SERIE,'0',3)+'-'+NRO;
        s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/uGetStatusCdr.php '
          +cad
          ;
        pCmdLinea(s,drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/getCdrMensajes/'+cad+'.txt');
        stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/getCdrMensajes/'+cad+'.txt');
        if pos('|',stCad.Text)=0 then DatabaseError(stCad.Text);
        splitCar(stCad.Text);
        xIq('update VENTA set COD_SUNAT='''+trim(pT[1])+''', MSJ_SUNAT='''+trim(pT[2])+''', HASH_CDR=null'
          +' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO);
        tr.CommitRetaining;
        q.Next;
  end;
s:='Ok:_:';
except on e: Exception do begin log('Error:_:'+e.Message); s:='Error:_:'+e.Message; end
end;
w(s);
end;

function pDarDeBaja(pkVENTA:String):String;
var n,i,c:Integer;
    sFE,sFEdet,idVtaCliDocTipo,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,
    IDDOCUMENTO,SERIE,NRO,resCPEenviado,s,
    SECUENCIA,
    archJs,drive
    :String;
    totalVta,igv,aPagar,SUBTOTAL,TIGVdeducido:real;
begin
try
log('<pDarDeBaja('+pkVENTA+')');
stCad:=TStringList.Create;
drive:=ExtractFileDrive(ParamStr(0));
c:=splitCar(pkVENTA);
SERIE:=pT[1];
NRO:=pT[2];
IDDOCUMENTO:=pT[3];

//OSE proceso FEmodo:='1';
FEmodo:=cnfParamGetIni('FEMODO','3','F.E. Modo');

igv:=rQFloat('select VALOR from CNFPARAM where ID=''IGV''');
bIq('select extract(year from VENTA.FECHA)||lpad(extract(month from VENTA.FECHA),2,''0'')||lpad(extract(day from VENTA.FECHA),2,''0'') SERIEFECHA,VENTA.*,CLIENTE.DITIPO,CLIENTE.DI from VENTA,CLIENTE where CLIENTE.ID=IDCLIENTE and IDDOCUMENTO='+IDDOCUMENTO+' and SERIE='+SERIE+' and NRO='+NRO);
SECUENCIA:=rQ('select coalesce(max(ID),0)+1 from FEBAJA where SERIEFECHA='''+qsI('SERIEFECHA')+''' and TIPODOC='''+iif(IDDOCUMENTO=DOCFACVTA,'F','B')+'''');
aPagar:=StrToFloat(qsI('TOTAL'));
//Dejar poder extornar cod_sunat:0001,0,
TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
SUBTOTAL:=aPagar-TIGVdeducido;
n:=0;
//while not iq.eof do
  //begin //SECUENCIA:='1';

if IDDOCUMENTO=DOCFACVTA
   then begin
              sFE:='{"NRO_DOCUMENTO_EMPRESA":"'+RUC+'"'
                  +',"RAZON_SOCIAL":"'+rSocialTienda+'"'
                  +',"TIPO_DOCUMENTO":"6"'
                  +',"CODIGO":"RA"'
                  +',"SERIE":"'+qsI('SERIEFECHA')+'"'
                  +',"SECUENCIA":"'+SECUENCIA+'"'
                  +',"FECHA_REFERENCIA":"'+IbFechaGuion(iq.FieldByName('FECHA').AsDateTime)+'"'
                  +',"FECHA_BAJA":"'      +IbFechaGuion(iq.FieldByName('FECHA').AsDateTime)+'"'
                  +',"TIPO_PROCESO":"'+FEmodo+'"'
                  +',"USUARIO_SOL_EMPRESA":"'+usTiendaSOL+'","PASS_SOL_EMPRESA":"'+psTiendaSOL+'"'
                  +',"detalle":'
                  +'['
                      +'{'
                          +'"ITEM": "1",'
                          //+'"TIPO_COMPROBANTE": "1",'  //No atraca
                          +'"TIPO_COMPROBANTE": "01",'
                          +'"SERIE": "F'+lPad(trim(qsI('SERIE')),'0',3)+'",'
                          +'"NUMERO": "'+trim(qsI('NRO'))+'",'
                          +'"DESCRIPCION": "ERROR DEL SISTEMA"'
                      +'}'
                  +']'
                  +',"PSFIRMA":"'+psFirma+'"'
                  +',"IDDOC":"F"'
                  +'}'
                  ;
              archJs:=drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/jsBaja/'+RUC+'-'+qsI('SERIEFECHA')+'-F'+(SECUENCIA)+'.js';
              stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
              stCad.SaveToFile(archJs);
              s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/controller_cpe_bajaFromLz.php '
                +archJs;
              pCmdLinea(s,archJs+'.txt');
              stCad.LoadFromFile(archJs+'.txt');
              log('Resultado de pCmdLinea:'+stCad.Text);
              iq.Next;
              inc(n)
        end;
if IDDOCUMENTO=DOCBOLVTA
   then begin
              sFE:='{"NRO_DOCUMENTO_EMPRESA":"'+RUC+'"'
                  +',"RAZON_SOCIAL":"'+rSocialTienda+'"'
                  +',"TIPO_DOCUMENTO":"6"'
                  +',"CODIGO":"RC"'
                  +',"SERIE":"'+qsI('SERIEFECHA')+'"'
                  +',"SECUENCIA":"'+SECUENCIA+'"'
                  +',"FECHA_REFERENCIA":"'+IbFechaGuion(iq.FieldByName('FECHA').AsDateTime)+'"'
                  +',"FECHA_DOCUMENTO":"' +IbFechaGuion(iq.FieldByName('FECHA').AsDateTime)+'"'
                  +',"TIPO_PROCESO":"'+FEmodo+'"'
                  +',"USUARIO_SOL_EMPRESA":"'+usTiendaSOL+'","PASS_SOL_EMPRESA":"'+psTiendaSOL+'","CONTRA":"'+psFirma+'"'
                  +',"detalle":'
                  +'['
                      +'{'
                          +'"ITEM": "1",'
                          +'"TIPO_COMPROBANTE": "03",'
                          +'"NRO_COMPROBANTE": "B'+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'))+'",'
                          +'"TIPO_DOCUMENTO": "1",'
                          +'"NRO_DOCUMENTO": "'+qsI('DI')+'",'
                          +'"TIPO_COMPROBANTE_REF": "",'
                          +'"NRO_COMPROBANTE_REF": "",'
                          +'"STATU": "3",'
                          +'"COD_MONEDA": "PEN",'
                          +'"TOTAL": "'+format('%.2f',[aPagar])+'",'
                          +'"GRAVADA": "'+format('%.2f',[SUBTOTAL])+'",'
                          +'"ISC": "0",'
                          +'"IGV": "'+format('%.2f',[TIGVdeducido])+'",'
                          +'"OTROS": "0",'
                          +'"CARGO_X_ASIGNACION": "1",'
                          +'"MONTO_CARGO_X_ASIG": "0",'
                          +'"EXONERADO": "0",'
                          +'"INAFECTO": "0",'
                          +'"EXPORTACION": "0",'
                          +'"GRATUITAS": "0"'
                      +'}'
                  +']'
                  +',"PSFIRMA":"'+psFirma+'"'
                  +',"IDDOC":"B"'
                  +'}'
                  ;
              archJs:=drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/jsBaja/'+RUC+'-'+qsI('SERIEFECHA')+'-B'+(SECUENCIA)+'.js';
              stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
              stCad.SaveToFile(archJs);
              //DatabaseError('planeado');
              s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/controller_cpe_bajaFromLz.php '
                +archJs;
              pCmdLinea(s,archJs+'.txt');
              stCad.LoadFromFile(archJs+'.txt');
              log('Resultado de pCmdLinea:'+stCad.Text);
              iq.Next;
              inc(n)
        end;

  //end;
xQ('insert into FEBAJA (SERIEFECHA,TIPODOC,ID) values ('''+qsI('SERIEFECHA')+''','''+iif(IDDOCUMENTO=DOCFACVTA,'F','B')+''','+SECUENCIA+')');
if (splitCar(trim(stCad.Text),'"')>2) then
   if pT[1]='Ok' then xq('update VENTA set TICKET='''+pT[3]+''',IDFEBAJA='+SECUENCIA+' where IDDOCUMENTO='+IDDOCUMENTO+' and SERIE='+SERIE+' and NRO='+NRO);
tr.Commit;
//WriteLn('Ok|XML generados para enviar a SUNAT: '+IntToStr(n));
//s:=StringReplace(stCad.Text,':_:_:','ñ',[rfReplaceAll, rfIgnoreCase]);
s:=trim(stCad.Text);//Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="  (hash de ida)
//DatabaseError(s);
except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
w(s);
//pDarDeBaja>
end;

function pFeNC(docVta:String):String;
var n,i,c:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    sFE,sFEdet,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,txtNRO_COMPROBANTE,txtNRO_DOCUMENTO_MODIFICA,
    txtNRO_DOCUMENTO_CLIENTE,xRUC,IDDOCUMENTO,SERIE,NRO,resCPEenviado,
    ntNRO,s,drive:String;
    IGV:Real;

begin
try
log('<pFeNC('+docVta+')');
stCad:=TStringList.Create;
drive:=ExtractFileDrive(ParamStr(0));

//OSE proceso FEmodo:='1';
FEmodo:=cnfParamGetIni('FEMODO','3','F.E. Modo');

c:=splitCar(docVta); // 021|8450    |10
xRUC:=RUC;
IDDOCUMENTO:=pT[3];
SERIE:= trim(pT[1]);
NRO:=   trim(pT[2]);
igv:=rQFloat('select VALOR from CNFPARAM where ID=''IGV''');
ntNRO:=trim(rQ('select coalesce(max(NRO),0)+1 from FEVTANT where IDDOC='+IDDOCUMENTO+' and SERIE=1'));
xQ('insert into FEVTANT (NTTIPO,IDDOC,SERIE,NRO,REFNRO,REFSERIE,EMITIDO,IDUS) values (''C'','
  +IDDOCUMENTO+',1,'+ntNRO+','+NRO+','+SERIE+',current_date,'+IDUSLOGUEO+')');
tr.CommitRetaining;

bIq('select * from VENTA,CLIENTE where IDCLIENTE=CLIENTE.ID and IDDOCUMENTO='+IDDOCUMENTO+' and SERIE='+SERIE+' and NRO='+NRO);
n:=0;
while not iq.eof do
  begin
        txtNRO_DOCUMENTO_CLIENTE:=Trim(qsI('DI'));
        //rSOCIAL:=(qsI('RAZONSOCIAL'));
        //cliDIR:=(qsI('DIRECCION'));
        rSOCIAL:=StringReplace(qsI('RAZONSOCIAL'),'&',' ',[rfReplaceAll, rfIgnoreCase]);
        rSOCIAL:=StringReplace(rSOCIAL,'"','¨',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(qsI('DIRECCION'),  '&',' ',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  '"','¨',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  'Ñ','N',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  '?',' ',[rfReplaceAll, rfIgnoreCase]);
        sFEdet:='';
        aPagar:=0;tIGV:=0;inafecta:=0;

        s:=  'select round(IMPORTE/(1.0+18.0/100.0)/CANTIDAD,2) PUNITDEDUC,';
        s:=s+'       round(IMPORTE/(1.0+18.0/100.0),2) SUBTOTDEDUC,';
        s:=s+'       IMPORTE-round(IMPORTE/(1.0+18.0/100.0),2) IGVSUBTOTDEDUC,';
        s:=s+'       VVENTADET.* from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO');
        bQ(s);
        //bQ('select round(IMPORTE/(1.0+18.0/100.0),2) BASEDEDUC,IMPORTE-round(IMPORTE/(1.0+18.0/100.0),2) IGVDEDUC,VENTADET.* from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO'));
        i:=0;
        while not q.eof do
          begin inc(i);
                aPagar:=aPagar+q.FieldByName('IMPORTE').AsFloat;
                tIGV:=tIGV+q.FieldByName('IMPORTE').AsFloat*(igv/100.0);
                if i>1 then sFEdet:=sFEdet+',';
                sImporte:=Format('%.2f',[qf('IMPORTE')]);
                sIGV:=Format('%.2f',[qf('IMPORTE')*(igv/100.0)]);
                sFEdet:=sFEdet
                             +'{"txtITEM":"'+IntToStr(i)
                             +'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
                             +'","txtPRECIO_DET":"'+Format('%.2f',[q.FieldByName('PUNITDEDUC').AsFloat])
                             +'","txtIMPORTE_DET":"'+Format('%.2f',[q.FieldByName('SUBTOTDEDUC').AsFloat])
                             +'","txtPRECIO_TIPO_CODIGO":"01'
                             +'","txtIGV":"'+Format('%.2f',[q.FieldByName('IGVSUBTOTDEDUC').AsFloat])
                             +'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
                             +'","txtDESCRIPCION_DET":"'
                             +StringReplace(qTrim('DESCRIPCION'),'"','¨',[rfReplaceAll, rfIgnoreCase])
                             +'"}';
                            // post 2.1 cambiado el 11/06/2019
                            //+'{"txtITEM":"'+IntToStr(i)
                            //+'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
                            //+'","txtPRECIO_DET":"'+Format('%.2f',[StrToFloat(sImporte)-StrToFloat(sIGV)])
                            //+'","txtIMPORTE_DET":"'+sImporte
                            //+'","txtPRECIO_TIPO_CODIGO":"01'
                            //+'","txtIGV":"'+sIGV
                            //+'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
                            //+'","txtDESCRIPCION_DET":"'
                            //+StringReplace(qTrim('DESCRIPCION'),'"','¨',[rfReplaceAll, rfIgnoreCase])
                            //+'"}';
                q.Next;
                log('2');
          end;
        totalVta:=aPagar-tIGV;

        TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
        SUBTOTAL:=aPagar-TIGVdeducido;
        txtSUB_TOTAL:=format('%.2f',[SUBTOTAL]);
        txtTOTAL:=format('%.2f',[aPagar]);
        txtTOTAL_IGV:=format('%.2f',[StrToFloat(txtTOTAL)-StrToFloat(txtSUB_TOTAL)]);
        sFE:=format('{"txtTOTAL_GRAVADAS":"%s","txtSUB_TOTAL":"%s","txtTOTAL_IGV":"%s","txtTOTAL":"%s","txtTOTAL_LETRAS":"%s"',
                    [txtSUB_TOTAL,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,solesAletras(aPagar)]
                   );
        //idVtaCliDocTipo:=qsI('IDDOCUMENTO');
        txtNRO_COMPROBANTE:=       iif(IDDOCUMENTO=DOCFACVTA,'F','B')+lPad(trim('1'),'0',3)+'-'+ntNRO;
        txtNRO_DOCUMENTO_MODIFICA:=iif(IDDOCUMENTO=DOCFACVTA,'F','B')+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
        sFE:=sFE
            +',"txtNRO_COMPROBANTE":"'+txtNRO_COMPROBANTE+'"'
            +',"txtFECHA_DOCUMENTO":"'+IbFechaGuion(iq.FieldByName('FECHA').AsDateTime)+'"'
            +',"txtCOD_TIPO_DOCUMENTO":"07"'
            +',"txtCOD_MONEDA":"PEN","txtTIPO_COMPROBANTE_MODIFICA":"'
            +iif(IDDOCUMENTO=DOCFACVTA,'01','03')
            +'","txtNRO_DOCUMENTO_MODIFICA":"'+txtNRO_DOCUMENTO_MODIFICA+'","txtCOD_TIPO_MOTIVO":"01","txtDESCRIPCION_MOTIVO":"ANULACION DE LA OPERACION"'
            +',"txtNRO_DOCUMENTO_CLIENTE":"'+txtNRO_DOCUMENTO_CLIENTE+'"'
            +',"txtRAZON_SOCIAL_CLIENTE":"'+rSOCIAL+'"'
            +',"txtTIPO_DOCUMENTO_CLIENTE":"'+iif(Length(txtNRO_DOCUMENTO_CLIENTE)=11,'6','1')+'"'
            +',"txtDIRECCION_CLIENTE":"'+cliDIR+'"'
            +',"txtCIUDAD_CLIENTE":"TRUJILLO","txtCOD_PAIS_CLIENTE":"PE","txtNRO_DOCUMENTO_EMPRESA":"'+xRUC+'"';
        //if xRUC='20559678491' then //anticona
        //   sFE:=sFE
        //    +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"A & ANTICONA GROUP E.I.R.L.","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"CAL.JOSE GALVEZ NRO. 501 BARRIO CHICAGO (A 1 CDRA. DEL MAYORISTA) ","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"A & ANTICONA GROUP E.I.R.L."'
        //    +',"txtUSUARIO_SOL_EMPRESA":"ANTICO77","txtPASS_SOL_EMPRESA":"apolitano75"';
        //if xRUC='20440459588' then //apolo
        //   sFE:=sFE
        //    +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"APOLO BIKES","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"PJ. GREGORIO ALBARRACIN NRO. 238 CC APOLO (2DO PISO)","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"BICI INDUSTRIAS APOLO E.I.R.L."'
        //    +',"txtUSUARIO_SOL_EMPRESA":"JAVIER19","txtPASS_SOL_EMPRESA":"apolitano"';
        //if (xRUC='20602637116') //fms
        //or (xRUC='10178693714') //caper
        //or (xRUC='20482631275') //anvic
        //or (xRUC='20481329281') //alneda
        //or (xRUC='20601054184') //yetsy
        //or (xRUC='10181201075') //jhoanir
        //   then
           sFE:=sFE
            +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"'+rSocialTienda+'","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"'
            +Domicilio+'","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"'+rSocialTienda+'"'
            +',"txtUSUARIO_SOL_EMPRESA":"'+usTiendaSOL+'","txtPASS_SOL_EMPRESA":"'+psTiendaSOL+'"';
        sFE:=sFE
            +',"txtTIPO_PROCESO":"'+FEmodo+'"'
            //+',"detalle":['+sFEdet+']}';
            +',"detalle":['+sFEdet+']'
            +',"datosGenerales":[{'
            + '"IDCAJAT":""'
            +',"VENDEDOR":""'
            +',"CAJERO":""'
            +'}]'
            +'}'
            ;

        stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
        stCad.SaveToFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/'+xRUC+'-07-'+txtNRO_COMPROBANTE+'.js');
        exit;
        s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/controller_cpeFromArchFromLazarusDaeFe.php '
          +xRUC+'-07-'+txtNRO_COMPROBANTE+'.js'
          ;
        pCmdLinea(s,       drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+xRUC+'-07-'+txtNRO_COMPROBANTE+'.js.txt');
        stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+xRUC+'-07-'+txtNRO_COMPROBANTE+'.js.txt');
        log('Resultado de pCmdLinea:'+stCad.Text);
        iq.Next;
        inc(n);
  end;
//WriteLn('Ok|XML generados para enviar a SUNAT: '+IntToStr(n));
//s:=StringReplace(stCad.Text,':_:_:','ñ',[rfReplaceAll, rfIgnoreCase]);
exit;
s:=trim(stCad.Text);//Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="  (hash de ida)
splitCar(s,'"');
if pT[1]='Ok'
   then  begin xQ('update VENTA set HASH_CDR='''+pT[2]+''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO);
               resCPEenviado:=pCPEnviaUno(docVta)+'"';
               splitCar(resCPEenviado,'"');
               if pT[1]='1'
                  then begin if trim(rQ('select FENVIO from VENTA where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO))
                                =''
                                then xQ('update VENTA set COD_SUNAT='''
                                       +StringReplace(pT[2],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''',MSJ_SUNAT='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +iif(pT[2]='?','',''',CON_CDR=''S') //Sunat no devolvio Zip de respuesta
                                       +''',MSJ_DEVUELTO='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''',FENVIO=current_date,HENVIO=current_time,USENVIO='+IDUSLOGUEO
                                       +' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO)
                                else xQ('update VENTA set COD_SUNAT='''
                                       +StringReplace(pT[2],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''',MSJ_SUNAT='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
                                       +''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOCUMENTO);
                             s:=s+pT[2]+'"'+pT[3]+'"';
                             //Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="0000"...aceptada u otro..."

                       end
                  else s:=s+'Error"'+resCPEenviado+'"';
                       //Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="Error"...mensaje de error..."
                       //0          1                      2         3
               tr.CommitRetaining;
         end
   else DatabaseError(s);
except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
w(s);
//pFeNC>
end;

function pCPEq(xvar:String):string;
var pkVENTA,s,USUARIO_SOL_EMPRESA,PASS_SOL_EMPRESA,
    SERIE,NRO,IDDOCUMENTO,
    arch:String;
begin
try
log('<pCPEq('+xvar+')'); //'20440459588|20602482899|F103|83|12/06/2018|200.00'
                         //      1           2       3    4      5      6
stCad:=TStringList.Create;
splitCar(xvar);
GenVm('RUC',        pT[1]);
GenVm('clienteDI',  pT[2]);
GenVm('Serie',      pT[3]);
GenVm('nro',        pT[4]);
GenVm('FEmision',   pT[5]);
GenVm('cantidad',   pT[6]);
if LeftStr(pT[3],1)='F'
   then begin GenVm('idDocSunat','03');
              GenVm('cod_docide','6');
        end
   else begin GenVm('idDocSunat','06');;
              GenVm('cod_docide','1');
        end;
stCad.Text:=devHTML('../fe/controller/CPEq.html');
stCad.SaveToFile(GetEnv('DOCUMENT_ROOT')+'/fe/controller/CPEqGen.html');
except on e: Exception do begin log(e.Message); stCad.Text:=e.Message; end
end;
w(stCad.Text);
//pFEfiltro>
end;

function pCodSunatUpdate:string;
var s,drive:String;
begin
try
log('<pCodSunatUpdate()');
drive:=ExtractFileDrive(ParamStr(0));
xQ('delete from CPE_COD_SUNAT');
xQ('insert into CPE_COD_SUNAT(ID) select distinct COD_SUNAT from VENTA order by COD_SUNAT');
tr.Commit;
s:='Ok';
except on e: Exception do begin log(e.Message); s:=e.Message; end
end;
result:=s;
end;

function pTicketConsulta(cad:String):string;
var pkVENTA,s,USUARIO_SOL_EMPRESA,PASS_SOL_EMPRESA,
    SERIE,NRO,IDDOCUMENTO,drive:String;
begin
try
log('<pTicketConsulta('+cad+')');
stCad:=TStringList.Create;
drive:=ExtractFileDrive(ParamStr(0));
pCmdLinea(PChar(drive+'/ultranet/xampp/cgi-bin/daeFe/daeFe.exe ticketConsulta 20559678491 201802456406212'),
          PChar(drive+'/ultranet/xampp/cgi-bin/anticona/fe/jsTicketConsulta/mensajes/r-'+cad+'.txt'));
stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/anticona/fe/jsTicketConsulta/mensajes/r-'+cad+'.txt');
s:='Ok:_:'+stCad.Text+'|';
except on e: Exception do begin log('Error:_:'+e.Message); s:='Error:_:'+e.Message; end
end;
w(s);
//pFEfiltro>
end;

function pXMLPDFdownGet(xvar:String;multi:Boolean):String;
var n,i,c:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    sFE,sFEdet,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,txtTOTAL,
    txtCOD_TIPO_MOTIVO,txtDESCRIPCION_MOTIVO,
    txtTIPO_COMPROBANTE_MODIFICA,txtNRO_DOCUMENTO_MODIFICA,
    txtNRO_COMPROBANTE,txtCOD_TIPO_DOCUMENTO,
    txtNRO_DOCUMENTO_CLIENTE,txtSUB_TOTAL,txtTOTAL_IGV,
    xRUC,IDDOC,SERIE,NRO,resCPEenviado,s,arch,path,url,
    VTAIDDOC,VTAFECHA,docSunat,pWeb,
    cpeRUC,cpeRSocialTienda,cpeDomicilio,DOCUMENT_ROOT,okXML,okPDF,fullXML,fullPDF,archZip,
    drive
    :String;
    IGV:Real;

begin
try
log('<pXMLPDFdownGet('+xvar+')');
stCad:=TStringList.Create;
drive:=ExtractFileDrive(ParamStr(0));

//OSE proceso FEmodo:='1';
//FEmodo:=cnfParamGetIni('FEMODO','3','F.E. Modo');
FEmodo:=rQ('select VALOR from CNFPARAM where ID=''FEMODO''');

c:=splitCar(xvar); //idDoc,idSerieNro,idFDoc,idMonto
txtCOD_TIPO_DOCUMENTO:=pT[1];
txtNRO_COMPROBANTE:=   pT[2];
VTAFECHA:=             pT[3];
txtTOTAL:=             pT[4];

if      txtCOD_TIPO_DOCUMENTO='01' then IDDOC:='11'
else if txtCOD_TIPO_DOCUMENTO='03' then IDDOC:='10'
else if txtCOD_TIPO_DOCUMENTO='07' then IDDOC:='63'
else if txtCOD_TIPO_DOCUMENTO='08' then IDDOC:='58'
else DatabaseError('Error IDDOC('+txtCOD_TIPO_DOCUMENTO+') no identificado');
splitCar(txtNRO_COMPROBANTE,'-');
SERIE:=IntToStr(StrToInt(copy(pT[1],2,3)));
NRO:=  trim(pT[2]);

igv:=rQFloat('select VALOR from CNFPARAM where ID=''IGV''');
pWeb:=rQ('select VALOR from CNFPARAM where ID=''FELINK''');
//pWeb:=cnfParamGetIni('FELINK','www','Link de consulta CPE');
s:=  'select * from VENTA,CLIENTE,VENTGRUPO';
s:=s+' where IDCLIENTE=CLIENTE.ID';
s:=s+'   and GRUPO=VENTGRUPO.ID';
s:=s+'   and IDDOCUMENTO='+IDDOC+' and SERIE='+SERIE+' and NRO='+NRO;
bIq(s);
//bIq('select * from VENTA,CLIENTE where IDCLIENTE=CLIENTE.ID and IDDOCUMENTO='+IDDOC+' and SERIE='+SERIE+' and NRO='+NRO);
VTAIDDOC:=lPad(trim(qsI('VTAIDDOC')),'0',2);
VTAFECHA:=IbFechaGuion(iq.FieldByName('FECHA').AsDateTime);
{$If Defined(BDshared)}
if bQ('select RUC,RSOCIAL,DOMIC from CAJATERMINAL,EMP where RUC=EMP.ID and CAJATERMINAL.ID='+qsI('IDCJATRM'))=0 then
   DatabaseError('<pGenXMLfromVentaUno: RUC no ubicado en CAJATERMINAL');
cpeRUC:=            qs('RUC');
cpeRSocialTienda:=  qs('RSOCIAL');
cpeDomicilio:=      qs('DOMIC');
{$Else}
cpeRUC:=            RUC;
cpeRSocialTienda:=  rSocialTienda;
cpeDomicilio:=      Domicilio;
{$IfEnd}

n:=0;
txtNRO_DOCUMENTO_CLIENTE:=Trim(qsI('DI'));
rSOCIAL:=StringReplace(qsI('RAZONSOCIAL'),'&',' ',[rfReplaceAll, rfIgnoreCase]);
rSOCIAL:=StringReplace(rSOCIAL,'"','¨',[rfReplaceAll, rfIgnoreCase]);
cliDIR:= StringReplace(qsI('DIRECCION'),  '&',' ',[rfReplaceAll, rfIgnoreCase]);
cliDIR:= StringReplace(cliDIR,  '"','¨',[rfReplaceAll, rfIgnoreCase]);
cliDIR:= StringReplace(cliDIR,  'Ñ','N',[rfReplaceAll, rfIgnoreCase]);
cliDIR:= StringReplace(cliDIR,  '?',' ',[rfReplaceAll, rfIgnoreCase]);
sFEdet:='';
aPagar:=0;tIGV:=0;inafecta:=0;

bQ('select * from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO'));
i:=0;
while not q.eof do
  begin inc(i);
        aPagar:=aPagar+q.FieldByName('IMPORTE').AsFloat;
        tIGV:=tIGV+q.FieldByName('IMPORTE').AsFloat*(igv/100.0);
        if i>1 then sFEdet:=sFEdet+',';
        sImporte:=Format('%.2f',[qf('IMPORTE')]);
        sIGV:=Format('%.2f',[qf('IMPORTE')*(igv/100.0)]);
        sFEdet:=sFEdet
                     +'{"txtITEM":"'+IntToStr(i)
                     +'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
                     +'","txtPRECIO_DET":"'+Format('%.2f',[StrToFloat(sImporte)-StrToFloat(sIGV)])
                     +'","txtIMPORTE_DET":"'+sImporte
                     +'","txtPRECIO_TIPO_CODIGO":"01'
                     +'","txtIGV":"'+sIGV
                     +'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
                     +'","txtDESCRIPCION_DET":"'
                     +StringReplace(qTrim('DESCRIPCION'),'"','¨',[rfReplaceAll, rfIgnoreCase])
                     +'"}';
        q.Next;
  end;
totalVta:=aPagar-tIGV;

TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
SUBTOTAL:=aPagar-TIGVdeducido;
txtSUB_TOTAL:=format('%.2f',[SUBTOTAL]);
txtTOTAL:=format('%.2f',[aPagar]);
txtTOTAL_IGV:=format('%.2f',[StrToFloat(txtTOTAL)-StrToFloat(txtSUB_TOTAL)]);
sFE:=format('{"txtTOTAL_GRAVADAS":"%s","txtSUB_TOTAL":"%s","txtTOTAL_IGV":"%s","txtTOTAL":"%s","txtTOTAL_LETRAS":"%s"',
            [txtSUB_TOTAL,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,solesAletras(aPagar)]
           );
txtTIPO_COMPROBANTE_MODIFICA:='';txtNRO_DOCUMENTO_MODIFICA:='';
txtCOD_TIPO_MOTIVO:='';txtDESCRIPCION_MOTIVO:='';
if      IDDOC=DOCFACVTA    then
        begin txtCOD_TIPO_DOCUMENTO:='01';
              txtNRO_COMPROBANTE:='F'+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
        end
else if IDDOC=DOCBOLVTA    then
        begin txtCOD_TIPO_DOCUMENTO:='03';
              txtNRO_COMPROBANTE:='B'+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
        end
else if IDDOC=DOCNTCREDVTA then
             begin if       VTAIDDOC=DOCFACVTA then
                      begin txtTIPO_COMPROBANTE_MODIFICA:='01';
                            txtNRO_DOCUMENTO_MODIFICA:='F'+lPad(trim(qsI('VTASERIE')),'0',3)+'-'+trim(qsI('VTANRO'));
                            txtNRO_COMPROBANTE:='F'+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
                      end
                   else if  VTAIDDOC=DOCBOLVTA then
                      begin txtTIPO_COMPROBANTE_MODIFICA:='03';
                            txtNRO_DOCUMENTO_MODIFICA:='B'+lPad(trim(qsI('VTASERIE')),'0',3)+'-'+trim(qsI('VTANRO'));
                            txtNRO_COMPROBANTE:='B'+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
                      end
                   else DatabaseError('Documento interno qsI(VTAIDDOC) '+VTAIDDOC+' no definido');
                   txtCOD_TIPO_MOTIVO:='01';txtDESCRIPCION_MOTIVO:='ANULACION DE LA OPERACION';
                   txtCOD_TIPO_DOCUMENTO:='07';
             end;

docSunat:=cpeRUC+'-'+txtCOD_TIPO_DOCUMENTO+'-'+txtNRO_COMPROBANTE; // 20559678491-01-F021-98

//txtNRO_COMPROBANTE:=iif(IDDOC=DOCFACVTA,'F','B')+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
sFE:=sFE
    +',"txtNRO_COMPROBANTE":"'           +txtNRO_COMPROBANTE+'"'
    +',"txtFECHA_DOCUMENTO":"'           +VTAFECHA+'"'
    +',"txtCOD_TIPO_DOCUMENTO":"'        +txtCOD_TIPO_DOCUMENTO+'"'
    +',"txtCOD_MONEDA":"PEN"'
    +',"txtTIPO_COMPROBANTE_MODIFICA":"' +txtTIPO_COMPROBANTE_MODIFICA+'"'
    +',"txtNRO_DOCUMENTO_MODIFICA":"'    +txtNRO_DOCUMENTO_MODIFICA+'"'
    +',"txtCOD_TIPO_MOTIVO":"'           +txtCOD_TIPO_MOTIVO+'"'
    +',"txtDESCRIPCION_MOTIVO":"'        +txtDESCRIPCION_MOTIVO+'"'
    +',"txtNRO_DOCUMENTO_CLIENTE":"'     +txtNRO_DOCUMENTO_CLIENTE+'"'
    +',"txtRAZON_SOCIAL_CLIENTE":"'      +rSOCIAL+'"'
    +',"txtTIPO_DOCUMENTO_CLIENTE":"'    +iif(Length(txtNRO_DOCUMENTO_CLIENTE)=11,'6','1')+'"'
    +',"txtDIRECCION_CLIENTE":"'         +cliDIR+'"'
    +',"txtCIUDAD_CLIENTE":"TRUJILLO","txtCOD_PAIS_CLIENTE":"PE","txtNRO_DOCUMENTO_EMPRESA":"'
    +cpeRUC+'"'
    +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"'
    +cpeRSocialTienda
    +'","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"'
    +cpeDomicilio
    +'","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"'
    +cpeRSocialTienda
    +'"'
    +',"txtUSUARIO_SOL_EMPRESA":"'+usTiendaSOL+'","txtPASS_SOL_EMPRESA":"'+psTiendaSOL+'","psFirma":"'+psFirma+'"';
sFE:=sFE
    +',"txtTIPO_PROCESO":"' +FEmodo+'"'
    +',"pWeb":"'            +pWeb+'"'
    +',"EFVTADIA":"'        +qsI('EFVTADIA')+'"'
    +',"VTACRED":"'         +qsI('VTACRED')+'"'
    +',"VTATRJCRED":"'      +qsI('VTATRJCRED')+'"'
    +',"sisOrg":"'          +sisOrg+'"'
    +',"diasApagar":"'      +rQ('select firSt 1 FPAGAR-(select FECHA from VENTGRUPO where VENTGRUPO.ID=CLIENTEMOV.GRUPO) from CLIENTEMOV where GRUPO='
                                +qsI('GRUPO')+' and IDMOV=''0'' order by ID')
                            +'"'
    +',"detalle":['+sFEdet+']'
    +',"datosGenerales":[{'
    + '"IDCAJAT":""'
    +',"VENDEDOR":""'
    +',"CAJERO":""'
    +'}]'
    +'}'
    ;
stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
stCad.SaveToFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/'+docSunat+'.js');
s:=drive+'/ultranet/xampp/php/php.exe '+drive+'ultranet/xampp/htdocs/fe/controller/controller_cpeFromArchFromLazarusDaeFe.php '
  +docSunat+'.js'
  ;
pCmdLinea(s,       drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docSunat+'.js.txt');
stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docSunat+'.js.txt');
okXML:='';okPDF:='';fullXML:='';fullPDF:='';
//Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="  (hash de ida)
splitCar(trim(stCad.Text),'"');
okXML:=pT[1];
log('okXML'+okXML+'|');
if okXML='Ok'
   then begin s:=drive+'/ultranet/xampp/php/php.exe '+drive+'/ultranet/xampp/htdocs/fe/controller/genPdf.php '
                +docSunat
                ;
              pCmdLinea(s,       drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docSunat+'.pdf.txt');
              stCad.LoadFromFile(drive+'/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docSunat+'.pdf.txt');
              fullXML:='http://127.0.0.1/fe/api_cpe/PRODUCCION/'+RUC+'/'+docSunat+'.XML';
              okPDF:=trim(stCad.Text);
              if okPDF='Ok' then fullPDF:='http://127.0.0.1/fe/api_cpe/PRODUCCION/descargas/'+docSunat+'.pdf';
        end;
archZip:='/fe/api_cpe/PRODUCCION/descargas/'+docSunat+'.zip';
log('Resultado de pCmdLinea:'+stCad.Text);
s:=okXML+':_:'+okPDF+':_:'+fullXML+':_:'+fullPDF;

arch:=IDUSLOGUEO+').'+IntToStr(YearOf(now))+'.'+IlPad02(MonthOf(now))+'.'+IlPad02(DayOf(now))
     +'.'+IlPad02(HourOf(now))+'.'+IlPad02(MinuteOf(now))+'.'+IlPad02(SecondOf(now))
     +'.xls';
path:=pathHTTP+'expo/xls/';
url:=URLHTTPFOLDER+'/expo/xls/';
if not DirectoryExists(path) then
   if not createdir(path) then
      begin w('No se pudo crear carpeta '+path+'. La unidad de disco puede estar protegida para esta acción');
            exit;
      end;
if not multi then
   begin  w('<script>document.location.href="'+archZip+'"</script>');
          w('<a href="'+archZip+'">'+archZip+'</a>');
          w('<script> window.close(); </script>');
   end;

except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
w(s);
//pXMLPDFdownGet>
end;

function pXMLPDFsdownGet(xvar:String):String;
var n,i,c,tCmd:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    sFE,sFEdet,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,txtTOTAL,
    txtCOD_TIPO_MOTIVO,txtDESCRIPCION_MOTIVO,
    txtTIPO_COMPROBANTE_MODIFICA,txtNRO_DOCUMENTO_MODIFICA,
    txtNRO_COMPROBANTE,txtCOD_TIPO_DOCUMENTO,
    txtNRO_DOCUMENTO_CLIENTE,txtSUB_TOTAL,txtTOTAL_IGV,
    xRUC,IDDOC,SERIE,NRO,resCPEenviado,s,arch,path,url,
    VTAIDDOC,VTAFECHA,docSunat,pWeb,
    cpeRUC,cpeRSocialTienda,cpeDomicilio,DOCUMENT_ROOT,okXML,okPDF,fullXML,fullPDF,archZip,
    drive,
    idFIni,idFFin,idProv,idIdDocTipo,idSerie,idNro,idMax,idEst,
    idFechaFil,idCodSunat,idIdDocTipoFil,idSerieFil,idNroFil,idCodSunatFil,idEstFil,
    cadBusca,buscaPor,sI,idVtaCliDocTipo,sSERIE,IDESTADO,sHead
    :String;
    IGV:Real;

begin
try
log('<pXMLPDFsdownGet('+xvar+')');
if not (vAcc[uSYS] or vAcc[uADM] or vAcc[uCAJ])then DatabaseError('Ud., no puede entrar a este módulo');
splitCar(xvar);
idFIni:=       pT[1];
idFFin:=       pT[2];
idProv:=       pT[3];
idIdDocTipo:=  pT[4];
idSerie:=      trim(pT[5]);  if idSerie<>'' then idSerie:=IntToStr(StrToInt(idSerie));
idNro:=        trim(pT[6]);  if idNro<>''   then idNro:=IntToStr(StrToInt(idNro));
idMax:=        pT[7];
idCodSunat:=   pT[8];
idEst:=        pT[9];
idFechaFil:='';idIdDocTipoFil:='';idSerieFil:='';idNroFil:='';idCodSunatFil:='';idEstFil:='';

cadBusca:='';
{$If Defined(SYSANTICONA) or Defined(SYSJHOANIR) or Defined(SYSCDOLAR)}
cadBusca:='where (IDESTADO=''V'') and IDDOCUMENTO in (10,11)';
{$IfEnd}
{$If Defined(SYSAPOLO) or Defined(SYSYETSY) or Defined(SYSDESING)}
cadBusca:='where IDESTADO in (''V'') and IDDOCUMENTO in (10,11)';
{$IfEnd}
{$If Defined(SYSANVIC) or Defined(SYSVICAFE) or Defined(SYSESTEL) or Defined(SYSEDSA) or Defined(SYSNSO) or Defined(SYSMIMPORT) or Defined(SYSLEDCAR) or Defined(SYSICQ) or Defined(SYSCRISTHY) or Defined(SYSKACCELL) or Defined(SYSDLEOPARD) or Defined(SYSOMAPE)  or Defined(SYSJOHNNY) or Defined(SYSTURBOSQL) or Defined(SYSCALZAA) or Defined(SYSTIENDA) or Defined(SYSSALUD) or Defined(SYSAYP) or Defined(SYSAGAPITO)}
cadBusca:='where IDESTADO in (''V'') and IDDOCUMENTO in (10,11) and SERIE in (1,2,3,4,5,6,7,8,9)';
{$IfEnd}
{$If Defined(SYSFMS) or Defined(SYSANPER) or Defined(SYSLIDER)}
cadBusca:='where IDESTADO in (''V'') and IDDOCUMENTO in (10,11) and SERIE in (10,11,12,13,14,15,16,17,18,19)';
{$IfEnd}
{$If Defined(SYSBICI)}
cadBusca:='where (IDESTADO=''V'') and IDDOCUMENTO in (10,11) and SERIE in (20,21,22,23,24,25,26,27,28,29)';
{$IfEnd}
{$If Defined(SYSDYM)}
cadBusca:='where IDESTADO in (''V'') and IDDOCUMENTO in (10,11) and SERIE in (1,2,3,4,5,6,7,8,9)';
{$IfEnd}
{$If Defined(SYSFREMAR) or Defined(SYSHEINER) or Defined(SYSCAPER) or Defined(SYSDEMO)
  or Defined(SYSDANNY)}
cadBusca:='where IDESTADO in (''V'') and IDDOCUMENTO in (10,11) and SERIE in (1,2,3,4,5,6,7,8,9)';
{$IfEnd}
if cadBusca='' then DatabaseError('Empresa no registrada');

if idProv<>'' then
   begin c:=splitCar(idProv,' ');
         if c=0 then pT[1]:='';
         if esNro(trim(pT[1]))
            then begin buscaPor:='IDCLIENTE';
                       cadBusca:=cadBusca+' and '+BuscaPor+' like '''+(trim(pT[1]))+'%''';
                 end
            else begin buscaPor:='upper(CLIENTE)';
                       cadBusca:=cadBusca+' and '+BuscaPor+' like '''+UpperCase(trim(pT[1]))+'%''';
                       for i:=2 to c do
                         begin cadBusca:=cadBusca+' and '+BuscaPor+' like ''%'+UpperCase(pT[i])+'%''';
                         end;
                 end;
   end;
if (idFFin<>'') and (idFFin<>'') then idFechaFil:=' and FECHA>='''+idFIni+''' and FECHA<='''+idFFin+'''';
if idIdDocTipo<>'' then idIdDocTipoFil:=' and IDDOCUMENTO='+idIdDocTipo;
if idSerie<>''     then idSerieFil    :=' and cast(SERIE as integer)='''+idSerie+'''';
if idNro<>''       then idNroFil      :=' and cast(NRO as integer)='''+idNro+'''';
if idCodSunat<>'*' then idCodSunatFil :=' and trim(COD_SUNAT)='''+Trim(idCodSunat)+'''';
if idCodSunat=''   then idCodSunatFil :=' and (trim(COD_SUNAT)='''' or COD_SUNAT is null)';
if idEst<>'*'      then idEstFil      :=' and IDESTADO='''+idEst+'''';
cuenta:=rQ1('select count(*) from VVENTACPE '
          +cadBusca+idFechaFil+idIdDocTipoFil+idSerieFil+idNroFil+idCodSunatFil+idEstFil
          );
s:='select first '+idMax+' * from VVENTACPE '
  +cadBusca+idFechaFil+idIdDocTipoFil+idSerieFil+idNroFil+idCodSunatFil+idEstFil
  +' order by FECHA,IDDOCUMENTO,cast(SERIE as integer),cast(NRO as integer),HORA';
bq1(s);
s:='';i:=0;
while not q1.eof do
  begin sI:=IntToStr(i);
        idVtaCliDocTipo:=qs1('IDDOCUMENTO');
        txtCOD_TIPO_DOCUMENTO:='';
        if      idVtaCliDocTipo=DOCFACVTA    then
                begin txtCOD_TIPO_DOCUMENTO:='01';
                      sSERIE:= 'F'+lPad(strIntStr(qs1('SERIE')),'0',3);
                      txtNRO_COMPROBANTE:=sSERIE+'-'+trim(qs1('NRO'));
                end
        else if idVtaCliDocTipo=DOCBOLVTA    then
                begin txtCOD_TIPO_DOCUMENTO:='03';
                      sSERIE:='B'+lPad(strIntStr(qs1('SERIE')),'0',3);
                      txtNRO_COMPROBANTE:=sSERIE+'-'+trim(qs1('NRO'));
                end
        //else if idVtaCliDocTipo=DOCNTCREDVTA then
        //        begin txtCOD_TIPO_DOCUMENTO:='07';
        //              if      qs('VTAIDDOC')=DOCFACVTA then
        //                 begin txtTIPO_COMPROBANTE_MODIFICA:='01';
        //                       txtNRO_DOCUMENTO_MODIFICA:='F'+lPad(trim(qs('VTASERIE')),'0',3)+'-'+trim(qs('VTANRO'));
        //                       sSERIE:='F'+lPad(strIntStr(qs('SERIE')),'0',3);
        //                       pkVENTA:=sSERIE+'|'+qs('NRO')+'|'+idVtaCliDocTipo;
        //                 end
        //              else if qs('VTAIDDOC')=DOCBOLVTA then
        //                 begin txtTIPO_COMPROBANTE_MODIFICA:='03';
        //                       txtNRO_DOCUMENTO_MODIFICA:='B'+lPad(trim(qs('VTASERIE')),'0',3)+'-'+trim(qs('VTANRO'));
        //                       sSERIE:='B'+lPad(strIntStr(qs('SERIE')),'0',3);
        //                       pkVENTA:=sSERIE+'|'+qs('NRO')+'|'+idVtaCliDocTipo;
        //                 end
        //              else DatabaseError('Documento interno qs(''VTAIDDOC'') '+qs('VTAIDDOC')+' no definido');
        //              txtCOD_TIPO_MOTIVO:='01';txtDESCRIPCION_MOTIVO:='ANULACION DE LA OPERACION';
        //        end
        else DatabaseError('Documento interno (idVtaCliDocTipo) '+idVtaCliDocTipo+' no definido');

        //pkVENTA:=        qs1('SERIE')+palo+qs1('NRO')+palo+idVtaCliDocTipo;
        IDESTADO:=       qs1('IDESTADO');
        {$If Defined(BDshared)}
        cpeRUC:=qs1('CPERUC');
        {$Else}
        cpeRUC:=RUC;
        {$IfEnd}
        log(sI);
        pXMLPDFdownGet(txtCOD_TIPO_DOCUMENTO+'|'+txtNRO_COMPROBANTE+'||',True);
        log(sI);
        q1.Next;
        inc(i);
  end;
tCmd:=i;
sHead:='';
sHead:=sHead+'<div class="brdTabl1">';
sHead:=sHead+'<table id=tCPE width=100% rules=cols style="font:12px tahoma,arial,calibri;border-collapse:collapse;border-color:#cccccc;color:#000000;'+csBKCOLOR+'" cellpadding=3 cellspacing=1>';
sHead:=sHead+'  <tr border=0 valign=top style="background-color:#ffffff;color:#000000;white-space:normal;border-color:#ffffff;" valign=top>'
    +'<th>Ord<th>Serie<th style="white-space:nowrap;">N°<th>Fecha<th>Hora<th>DNI/RUC<th>Cliente<th width=1>'
    +'S/'
    +'<td style="font-size:14px;">'+'E/V'
    //+'<td style="font-size:14px;">'+'NC'
    +'<th>C.CDR<th>Mensaje (Click=Consultar)<th>Hash ó Ticket de baja'
    +'<th><th>Log'
    ;
s:=sHead+s+'</table></div>:_:'+IntToStr(tCmd)+':_:'+cuenta+':_:';
except on e: Exception do begin log(e.Message); s:=e.Message; end
end;
w(s);
//pXMLPDFsdownGet>
end;

function pXMLPDFdownM:String;
var n,i,c:Integer;

    IGV:Real;

begin
try
log('<pXMLPDFdownM');
GenVm('opXMLPDFdownGet',IntToStr(opXMLPDFdownGet));
w((devHTML('../uBiblio/pXMLPDFdownM.html')));
stCad:=TStringList.Create;

except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
w(s);
//pXMLPDFdownM>
end;

BEGIN //main()
//iniciar;
//log('antes de Inicializa:'+sisActual);
logACTIVO:=False;
sTmp:=Inicializa;
log('SCRIPT_FILENAME :'+GetEnv('SCRIPT_FILENAME'));
splitCar(sTmp,'|');
if pT[1]='Error' then
   begin GenVm('Error',pT[2]);
         w(devHTML('index.html'));
         if bd.Transaction.Active then bd.Close;
         halt;
   end;
op:=StrToInt(pT[1]);
//OP:=Inicializa;
log('op despues de sesionar:'+IntToStr(OP));
if OP = -1 then begin {if bd.Transaction.Active then bd.Close;} pHtmlShow('index.html'); exit; end;
log('op(Enviado):'+IntToStr(op));
case OP of
    //FE
    opFEmarco:             pFeMarco;
    opFEfiltro:            pFEfiltro(devStr('xvar'));
    opuGetStatusCdr:       puGetStatusCdr(devStr('xvar'));
    opFEConsultaRango:     pFEConsultaRango(devStr('xvar'));
    opGenXMLfromVentaUno:  pGenXMLfromVentaUno(devStr('xvar'));
    opGenXMLfromVentaRango:pGenXMLfromVentaRango(devStr('xvar'));
    opCPEnviaUno:          pCPEnviaUno(devStr('xvar'));
    opDarDeBaja:           pDarDeBaja(devStr('xvar'));
    opFeNC:                pFeNC(devStr('xvar'));
    opCPEq:                pCPEq(devStr('xvar'));
    opCodSunatUpdate:      pCodSunatUpdate;
    opTicketConsulta:      pTicketConsulta(devStr('xvar'));
    opXMLPDFdownM:         pXMLPDFdownM;
    //opXMLPDFsdownGet:      pXMLPDFsdownGet(devStr('xvar'));
    opXMLPDFdownGet:       pXMLPDFdownGet(devStr('xvar'),False);
    opXMLPDFsdownGet:      pXMLPDFsdownGet(devStr('xvar'));

  else w(opcionIncorrecta(''));
end;
if bd.Transaction.Active then bd.Close;
END.

