function pCmd2(Comando:String):String;
var UnProceso: TProcess;
    UnaLista: TStringList;
begin
log('<pCmd2('+Comando+')');
result:='Error en pCmd2';
// Creamos el objeto TStringList.
UnaLista := TStringList.Create;

// Ahora creamos UnProceso.
UnProceso := TProcess.Create(nil);

// Asignamos a UnProceso la orden que debe ejecutar.
// Vamos a lanzazar el compilador de FreePascal
UnProceso.CommandLine := Comando;

// Definimos una opción de comportamiento de 'TProccess'
// La opción poWaitOnExit hará que nuestro programa
// se detenga hasta que termine el programa lanzado
// con la opción poUsePipes    advertimos que vamos a utilizar tuberías de Entrada/Salida
// para que se capture la salida y así poder recuperar su contenido desde nuestro programa
log('pre UnProceso.Options');
UnProceso.Options := UnProceso.Options + [poWaitOnExit, poUsePipes];
//UnProceso.Options := UnProceso.Options + [poNoConsole, poUsePipes];
log('pos UnProceso.Options');

// Lanzamos la ejecución de 'ppc386 -h'.
log('pre UnProceso.Execute');
UnProceso.Execute;
log('pos UnProceso.Execute');
// Nuestro programa se detiene hasta que 'ppc386' finaliza.

// Ahora leemos la salida del programa que acabamos de ejecutar
// dentro de TStringList.
//UnaLista.LoadFromStream(UnProceso.Output);

// Guardamos la salida en un archivo.
result:=UnaLista.Text;
log('result:'+Result);
// Ahora que hemos guardado el archivo podemos liberar la memoria
   // TStringList y TProcess.
   UnaLista.Free;
   UnProceso.Free;
end;

function ptsTablaQuery(xvar:string):String;
type tCampo=record
     id:String;
     pk:String;
     end;
var  sSql,s,s1,tablas:String;
     tvCampo,i,j:SmallInt;
     vCampo:array[1..1000] of tCampo;
begin
log('<ptsTablaQuery('+xvar+')');
splitCar(xvar);
s:='select first 1000 * from '+Trim(pT[5]);
sSql:=s;
bQ(s);i:=0;s:='';
tvCampo:=q.Fields.Count;
s:='';
for i:=0 to tvCampo-1 do
if i=0 then s:=s+      q.Fields[i].DisplayName
       else s:=s+'~_~'+q.Fields[i].DisplayName; //delimita campo ~_~
while not q.eof do
  begin inc(i);
        if i>1 then s:=s+':_:'; //delimita fila
        for j:=0 to tvCampo-1 do
          if j=0 then s:=s+      q.Fields[j].AsString
                 else s:=s+'~_~'+q.Fields[j].AsString; //delimita campo ~_~
        q.Next;
  end;
Result:=sSql+'*_*'+s;
end;

function bdStructGet:String;
   var s,tablas:String;
       i:SmallInt;
begin
log('<bdStructGet');
//s:='SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE RDB$SYSTEM_FLAG=0 AND RDB$VIEW_BLR IS NULL';
s:='SELECT DISTINCT RDB$RELATION_NAME FROM RDB$RELATION_FIELDS WHERE RDB$SYSTEM_FLAG=0 AND RDB$VIEW_CONTEXT IS NULL';
//http://www.alberton.info/firebird_sql_meta_info.html
bQ(s);i:=0;s:='';
while not q.eof do
  begin inc(i);
        if i=1 then s:=s+Trim(qI(0))
               else s:=s+'|'+Trim(qI(0));
        q.Next;
  end;
Result:=s;
end;

function ptsCamposGet(xvar:string):String;
type tCampo=record
     id,pk,tipo,ancho:String;
     end;
var  s,s1,tablas:String;
     tvCampo,i:SmallInt;
     vCampo:array[1..1000] of tCampo;
begin
log('<ptsCamposGet('+xvar+')');
splitCar(xvar);
//s:='SELECT * FROM RDB$RELATION_FIELDS WHERE RDB$RELATION_NAME='''+Trim(pT[5])+''' order by RDB$FIELD_POSITION';
s:='SELECT trim(a.RDB$RELATION_NAME) OBJETO, trim(a.RDB$FIELD_NAME) CAMPO, b. RDB$FIELD_LENGTH, b.RDB$FIELD_SCALE, trim(c.RDB$TYPE_NAME) TYPE_NAME, b.RDB$FIELD_TYPE, b.RDB$FIELD_SUB_TYPE, b.RDB$FIELD_PRECISION,		 b.RDB$COMPUTED_SOURCE	,iif(RDB$FIELD_SCALE<0,RDB$FIELD_PRECISION||'',''||abs(b.RDB$FIELD_SCALE),RDB$FIELD_LENGTH) ANCHO	,trim(iif(RDB$FIELD_SCALE<0,''NUMERIC''		         ,CASE b.RDB$FIELD_TYPE		          WHEN 261 THEN ''BLOB''		          WHEN 14 THEN ''CHAR''		          WHEN 40 THEN ''CSTRING''		          WHEN 11 THEN ''D_FLOAT''		          WHEN 27 THEN ''DOUBLE''		          WHEN 10 THEN ''FLOAT''		          WHEN 16 THEN ''INT64''		          WHEN 8 THEN ''INTEGER''		          WHEN 9 THEN ''QUAD''		          WHEN 7 THEN ''SMALLINT''		          WHEN 12 THEN ''DATE''		          WHEN 13 THEN ''TIME''		          WHEN 35 THEN ''TIMESTAMP''		          WHEN 37 THEN ''VARCHAR''		          ELSE ''UNKNOWN''		        END)) AS TIPO		FROM RDB$RELATION_FIELDS a JOIN RDB$FIELDS b ON (b.RDB$FIELD_NAME = a.RDB$FIELD_SOURCE) 		LEFT JOIN RDB$TYPES c ON (b.RDB$FIELD_TYPE = c.RDB$TYPE and c.RDB$FIELD_NAME = ''RDB$FIELD_TYPE'') 		WHERE a.RDB$RELATION_NAME ='''
  +Trim(pT[5])+''' ORDER BY a.RDB$RELATION_NAME, a.RDB$FIELD_POSITION';
//http://www.alberton.info/firebird_sql_meta_info.html
bQ(s);tvCampo:=0;s:='';
while not q.eof do
  begin inc(tvCampo);
        //s1:=Trim(qI(1));
        vCampo[tvCampo].id:=    Trim(qI(1));
        vCampo[tvCampo].tipo:=  qTrim('TIPO');
        vCampo[tvCampo].ancho:= qTrim('ANCHO');
        vCampo[tvCampo].pk:=    'N';
        q.Next;
  end;

//PKs
s:='SELECT trim(RDB$FIELD_NAME),trim(s.RDB$INDEX_NAME),trim(RDB$CONSTRAINT_TYPE)'
  +' FROM rdb$index_segments AS s LEFT JOIN rdb$relation_constraints AS rc'
  +' ON (rc.rdb$index_name = s.rdb$index_name)'
  +' where rc.rdb$relation_name = '''+Trim(pT[5])+''''
  +'   and (rc.rdb$constraint_type = ''PRIMARY KEY'')';
bQ(s);
while not q.eof do
  begin for i:=1 to tvCampo do
            begin
            log('|'+vCampo[i].id+'|'+Trim(qI(0))+'|');
            if vCampo[i].id=Trim(qI(0))
               then begin vCampo[i].pk:='S'; Break; end;
            end;
        q.Next;
  end;
s:='';
for i:=1 to tvCampo do
  begin if i>1 then s:=s+'|';
        s:=s+vCampo[i].id+';'+vCampo[i].pk+';'+vCampo[i].tipo+';'+vCampo[i].ancho;
  end;
log(s);
Result:=s;
end;

function btBdConectaClick(xUsuario,xPassword: string): boolean;
label fin;
begin
try
log('<btBdConectaClick('+xUsuario+','+xPassword+')');
{$If Defined(SYSTURBOSQL)}
splitCar(devStr('xvar'));
host:=    pT[1]; pathBD:=  pT[2];
xUsuario:=pT[3]; xPassword:=pT[4];
log('<SYSTURBOSQL.btBdConectaClick ('+xUsuario+','+xPassword+')');
{$IfEnd}
Result:=False;
{$If Defined(linuxMySql55)}       bd:=TMySQL55Connection.Create(nil); {$IfEnd}
{$If Defined(linuxMySql56)}       bd:=TMySQL56Connection.Create(nil); {$IfEnd}
{$If Defined(linuxFirebird25) or Defined(windowsFirebird25)}
                                  bd:=TIBConnection.Create(nil); {$IfEnd}

tr:=TSQLTransaction.Create(nil);
iq:=TSqlQuery.Create(nil);     q:=TSqlQuery.Create(nil); q1:=TSqlQuery.Create(nil);
bd.Connected:=False;
tr.Active:=False;
{$If Defined(dfMY)}
log('host:'+host);
log('BDNOMBRE:'+BDNOMBRE);
log('criUS:'+criUS);
log('criPASS:'+criPASS);
log('CNFBASE[usDirecto]:'+CNFBASE[usDirecto]);
if CNFBASE[usDirecto]='1'
   then begin bd.HostName:=host; bd.DatabaseName:=BDNOMBRE; bd.UserName:=xUsuario;  bd.Password:=xPassword; end  //Usuario y sena son creados en servidor
   else begin bd.HostName:='localhost'; bd.DatabaseName:=BDNOMBRE; bd.UserName:=criUS;     bd.Password:=criPASS; end; //Usuario y sena están en tabla
{$IfEnd}
//pre turboSql {$If Defined(dfFB)}
//log('bd:'+host+pathBD);
//if CNFBASE[usDirecto]='1'
//   then begin bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:=xUsuario;  bd.Password:=xPassword; end  //Usuario y sena son creados en servidor
//   else begin bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:=criUS;     bd.Password:=criPASS; end; //Usuario y sena están en tabla
//{$IfEnd}
{$If Defined(SYSTURBOSQL)}
bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:=xUsuario;  bd.Password:=xPassword;
{$IfEnd}
{$If Defined(linuxFirebird25) or Defined(windowsFirebird25)}
//bd.Dialect:=3;
bd.CharSet:=BDCHARSET;
{$IfEnd}
//oracle bd.UserName:='SYSTEM';     bd.Password:='masterkey';
//bd.DatabaseName:='XE';
//log('bd.CharSet:'+bd.CharSet);
bd.LoginPrompt:=False;
tr.DataBase:=bd;
bd.Connected:=True;
tr.Active:=True;
iq.Transaction:=tr;    iq.DataBase:=bd;
q.Transaction:=tr;     q.DataBase:=bd;
q1.Transaction:=tr;    q1.DataBase:=bd;
{$If Defined(SYSTURBOSQL)}
w(bdStructGet);
Result:=True;
//goto
{$IfEnd}
log('{1}try ok Bd Conecta');
{$If Defined(dfMY)}
bd.CharSet:=BDCHARSET;
{$IfEnd}
Result:=True;
except  on e: Exception do
        begin Result:=False;
              log(e.Message);
              //halt;
        end;
end;
end;

function pSesTSql:String;
var res:String;
    c:Char;
    cnok:Boolean;
begin
try
log('<pSesTS');
s:='';
sesionadoSI:=False;
reqCk:=GetEnv('HTTP_COOKIE');
reqCkValue:=RightStr(reqCk, Length(reqCk) - pos('=', reqCk));
//log('cockie leido al natural: |'+reqCk+'|');
ck:=ReverseString(reqCkValue);
ck:=charHumaniza(ck);
//s:=s+('Cockie revertido y humanizado='+ck+'<br>');
a:='';
a:=GetEnv('QUERY_STRING');
if a = '' then  begin a:='';
                      while not EOF(input) do
                      begin Read(c);
                            a:=a+c;
                      end;
                      //log('postWhile');
                end;
//log('Cadena recibida al natural POST/GET |'+a+'|');
//sin funciona
//a:=FlujoToStr(a);
a:=charHumaniza(a);
log('Cadena humanizada POST/GET |'+a+'|');
//log('application.requestvariables'+application.requestvariables['file']);
sesionadoSI:=(devStrP(ck, 'sesionado', '&', ':') = 'si');
cuenta:=devStrP(ck, 'c', '&', ':');
s:=s+('Leido c='+cuenta+'<br>');
if cuenta = ''
   then cuenta:='0'
   else cuenta:=IntToStr(StrToInt(cuenta)+1);
s:=s+('Nuevo c='+cuenta+'<br>');
//Cerrando sesión
//el siguiente bloque se sacó para evitar que salga msg de bd no conectado cuando cerramos sesión. Sería bueno ver la importancia de edSal q aquí s estaría ignorando al final
//if (devStr('edSal') = 'S') then
//    begin a:='';
//          sesionadoSI:=False;
//    end;
if (trim(devStr('op')) <> '')
   then OP:=devInt('op')
   else if trim(devStrP(ck, 'op', '&', ':')) = ''
           then OP:=-1
           else OP:=StrToInt(trim(devStrP(ck, 'op', '&', ':')));
//log('publico off');
if OP=opXMLPDFdownM then
   begin usLogueo:='PUBLICO';
         passLogueo:='11111111';
         log('publico on');
   end;

ckParOtros:='; path=/; expires=Sat, 20-ago-2056  18:37:00 GMT'; //-5 es la hora actual
log('pSesion.op:'+IntToStr(op));
log('xvar=['+devStr('xvar')+']');
{$If Defined(SYSTURBOSQL)}
splitCar(devStr('xvar'));
host:=    pT[1]; pathBD:=    pT[2];
usLogueo:=pT[3]; passLogueo:=pT[4];
{$IfEnd}
if OP=-1
   then begin log('sesionadoNO. Cierre sesión manual (-1)');
              outCk:='&sesionado:no&us:&sena:'+'&c:'+cuenta+'&op:';
              writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
              writeln('Content-Type:text/html', #10#13);
        end
   else begin cnok:=btBdConectaClick(usLogueo, passLogueo);
              if cnok
                then
                  begin log('btBdConectaClick');
                        outCk:='&sesionado:si&us:'+usLogueo+'&sena:'+passLogueo+'&c:'+cuenta+'&op:'+IntToStr(OP);
                        writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                        writeln('Content-Type:text/html', #10#13);
                  end
                else
                  begin log('sesionadoSI else btBdConectaClick else');
                        outCk:='&sesionado:no&us:&sena:'+'&c:'+cuenta+'&op:';
                        writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                        writeln('Content-Type:text/html', #10#13);
                        //log('Loguearse');
                        OP:=-1;
                        DatabaseError('No se puede conectar con Base de datos');
                  end;
            end;
res:=IntToStr(op)+'|';
except
  on e: Exception do begin log('Excepción: pSesion: '+e.Message);
                           res:='Error|'+e.Message;
                           //w('Exception en pSesión: '+e.Message);//Error u opción <br>incorrecta<a href="sfdsafds">Cerrar</a><br><a href="'+urlExe+'?op=5">Intentar restaurar</a>');
                           //halt;
                     end
end;
log('pSesion(Result:'+res+')>');
//log('REMOTE_ADDR :'+GetEnv('REMOTE_ADDR'));
//log('REMOTE_HOST :'+GetEnv('REMOTE_HOST'));
//log('REMOTE_PORT :'+GetEnv('REMOTE_PORT'));
//log('HTTP_ACCEPT :'+GetEnv('HTTP_ACCEPT'));
//log('HTTP_ACCEPT_ENCODING :'+GetEnv('HTTP_ACCEPT_ENCODING'));
//log('SCRIPT_FILENAME :'+GetEnv('SCRIPT_FILENAME'));
//log('SCRIPT_NAME :'+GetEnv('SCRIPT_NAME'));
//log('QUERY_STRING :'+GetEnv('QUERY_STRING'));
//log('PATH_INFO :'+GetEnv('PATH_INFO'));
//log('CONTENT_TYPE :'+GetEnv('CONTENT_TYPE'));
//log('CONTENT_LENGTH :'+GetEnv('CONTENT_LENGTH'));
//log('REQUEST_METHOD :'+GetEnv('REQUEST_METHOD'));
result:=res;
end;

function splitCar(cad:String;car:string='|'): integer;
var c, L, i: integer;
begin
IF length(cad)=0 THEN BEGIN result:=0; exit; END;
CAD:=CAD+CAR;
L:=length(cad);
c:=0;
pTab[0]:=0;
for i:=1 to L do
   if cad[i]=car then
      begin c:=c+1;
            pTab[c]:=i;
      end;
if c > 0 then
   begin for i:=1 to c do
           if pTab[i] - pTab[i - 1] > 1
              then pT[i]:=copy(cad, pTab[i - 1]+1, pTab[i] - pTab[i - 1] - 1)
              else pT[i]:='';
   end;
Result:=c;
end;

function iniTSql:String;
var F:TextFile; linea:ansistring;c,i:Integer;
    valor,fullExe,res:String;
    tCampos:Integer;
begin
try
logACTIVO:=False;
stCad:=TStringList.Create;  //CNFBASE.Delimiter:='|';CNFBASE.StrictDelimiter:=True;
sLog:=TStringList.Create;
_Ini:='--'; _Fin:='--'; printSI:=True;logOpen:=false;
ShortDateFormat:='dd/mm/yyyy'; LongTimeFormat:='hh:mm'; DecimalSeparator:='.';
//if xSO=SOWINDOWS then splitCar(par);

fullExe:=ParamStr(0);
pathCGI:=ExtractFilePath(fullExe);      //   E:\programas\xampp\cgi-bin\bici\
ArchLOG:=pathCGI+'log/log.txt';
ArchAudiLog:=pathCGI+'log/audiLog.txt';
//WriteLn('ArchLOG:'+ArchLOG);
aLogOpen:=pathCGI+'log/qLog.txt';
archLogAlter:=pathCGI+'log/logAlter.txt';
//ArchLOG:='/home/edgard/log.txt';
subDirPublic:='public/';subDirPublicCargo:='public/cargo/';

invRUC:=RUC;
if logACTIVO then
   begin  AssignFile(fArch, ArchLOG); if FileExists(ArchLOG) then Append(fArch) else ReWrite(fArch);
          if desactivaLog
             then logACTIVO:=false
             else WriteLn(fArch, '***'+DateToStr(Now)+':'+TimeToStr(Now));
          CloseFile(fArch);
   end;

log('<Inicializa');
log('SCRIPT_FILENAME :'+GetEnv('SCRIPT_FILENAME'));
log('SCRIPT_NAME :'+GetEnv('SCRIPT_NAME'));
{$ifdef win32}
 //log('pathCGI+CNFFOLDER:'+pathCGI+CNFFOLDER+'cnf.ini');
{$endif}
{$ifdef Unix}
//log('pathCGI+CNFFOLDER:'+pathCGI+CNFFOLDER+'cnfLinux.ini');
// ConfigFilePath := GetAppConfigFile(False) + '.conf';
{$endif}

nomExe:=ExtractFileName(fullExe);
tipoOp:='';sOpWhereAnio:='';
cliMovPagIntervalo:=12;provMovPagIntervalo:=10;
//tmp cliMovPagIntervalo:=10;provMovPagIntervalo:=10;
{$ifdef win32}
//independientes stCad.LoadFromFile(pathCGI+CNFFOLDER+'cnf.ini');
stCad.LoadFromFile(pathCGI+'cnf.ini');
{$endif}
{$If Defined(Unix)}
     {$If Defined(dfREMOTO)}
          stCad.LoadFromFile(pathCGI+'cnfLinuxRemoto.ini');
     {$Else}
          stCad.LoadFromFile(pathCGI+'cnfLinux.ini');
     {$IfEnd}
{$IfEnd}
//{$ifdef Unix}
//stCad.LoadFromFile(pathCGI+CNFFOLDER+'cnfLinux.ini');
//{$endif}

for linea in stCad do
  begin //log(linea);
        c:=splitCar(linea,'=');
        pT[2]:=trim(pT[2]);
        //if      pT[1]='Param1' then begin urlExeSoloRutaSlash:=slashAdd(pT[2]);  //optimizar slashAdd
        //                                  urlExe:=urlExeSoloRutaSlash+nomExe;   // /unet/bici/
        //                            end
        //else if pT[1]='Param2' then begin urlImg:=     slashAdd(pT[2]);    //  /carpetaHttpW/img/
        //                                  urlImgMante:=pT[2]+'../../uBiblio/';
        //                            end
        //else if pT[1]='Param3' then pathHTTP:=StringReplace(slashAdd(pT[2]),'\','/',[rfReplaceAll, rfIgnoreCase])
        //else if pT[1]='Param4' then begin //sRutaEjeSlash:=slashAdd(pT[2]);
        //                                  pathBD:=slashAdd(pT[2])+BDNOMBRE;
        //                            end
        //else if pT[1]='Param5' then host:=       pT[2]
        //else if pT[1]='Param6' then charSetBD:=  pT[2]
        //else
             if pT[1]='Param7' then begin CNFBASE:=pT[2];
                                          break;
                                    end;
  end;

tvTabla:=0;
tvCampo:=0;
tvMenu:=0;
if CNFBASE[vaLog]='1' then logACTIVO:=True else logACTIVO:=False;
sManteMn:='<a onclick="pManteMn();"><img src="'+urlImg+'mOff.png" title="Opciones" onmouseover="this.src='''+urlImg+'mOn.png''" onmouseout="this.src='''+urlImg+'mOff.png''"></a>';
tPost:=splitCar(a,'&');
xMsg:='';
log('pathBD:'+pathBD);
usNODEF:=false;usGERENTE:=false;usADMIN:=false;usENSABLE:=false;usVENDEDOR:=false;usCONTAB:=false;usALMACEN:=false;usADMINSIS:=false;usOPERA:=false;usTRANSP:=false;usCAJA:=false;usCOMPRA:=false;
for i:=1 to MAXCARGOS do vAcc[i]:=false;
res:=pSesTSql;
splitCar(res,'|');
if pT[1]<>'Error' then op:=StrToInt(pT[1]);
result:=res;
log('Inicializa(Result:'+res+')>');
except on e: Exception do begin log('Error: '+e.Message); halt; end
end;
end;

procedure ptsBDcn(xvar:String);
var res,fullExe,pathCGI:String;
    fArch: TextFile;
begin
try
//fullExe:=ParamStr(0);
//pathCGI:=ExtractFilePath(fullExe);      //   E:\programas\xampp\cgi-bin\bici\
//ArchLOG:=pathCGI+'log/log.txt';
//
//logACTIVO:=True;
//if logACTIVO then
//   begin  AssignFile(fArch, ArchLOG); if FileExists(ArchLOG) then Append(fArch) else ReWrite(fArch);
//          WriteLn(fArch, '***'+DateToStr(Now)+':'+TimeToStr(Now));
//          CloseFile(fArch);
//   end;
log('<ptsBDcn('+xvar+')');
splitCar(xvar);

tr:=TSQLTransaction.Create(nil);
iq:=TSqlQuery.Create(nil);     q:=TSqlQuery.Create(nil); q1:=TSqlQuery.Create(nil);
bd.Connected:=False;
tr.Active:=False;
bd.HostName:=pT[1]; bd.DatabaseName:=pT[2]; bd.UserName:=pT[3];  bd.Password:=pT[4];
{$If Defined(linuxFirebird25) or Defined(windowsFirebird25)}
bd.CharSet:=BDCHARSET;
{$IfEnd}
bd.LoginPrompt:=False;
tr.DataBase:=bd;
bd.Connected:=True;
tr.Active:=True;
iq.Transaction:=tr;    iq.DataBase:=bd;
q.Transaction:=tr;     q.DataBase:=bd;
q1.Transaction:=tr;    q1.DataBase:=bd;

res:=''
except  on e: Exception do
        begin log(e.Message);
              res:='Error:_:'+e.Message;
        end;
end;
w(res);
end;

function ptsSqlQuery(xvar:string):String;
type tCampo=record
     id:String;
     pk:String;
     end;
var  sSql,s,s1,tablas:String;
     tvCampo,i,j:SmallInt;
     vCampo:array[1..1000] of tCampo;
begin
try
log('<ptsSqlQuery('+xvar+')');
splitCar(xvar);
sSql:=trim(FlujoToStr(pT[5]));
log('pT[5]:'+sSql);
if UpperCase(LeftStr(sSql,6))='SELECT'
   then begin bQ(sSql);i:=0;s:='';
              tvCampo:=q.Fields.Count;
              s:='';
              for i:=0 to tvCampo-1 do
              if i=0 then s:=s+      q.Fields[i].DisplayName
                     else s:=s+'~_~'+q.Fields[i].DisplayName; //delimita campo ~_~
              while not q.eof do
                begin inc(i);
                      if i>1 then s:=s+':_:'; //delimita fila
                      for j:=0 to tvCampo-1 do
                        if j=0 then s:=s+      q.Fields[j].AsString
                               else s:=s+'~_~'+q.Fields[j].AsString; //delimita campo ~_~
                      q.Next;
                end;
        end
   else begin xQ(sSql);s:='';tr.Commit;
         //grant all on "BIT1" to ADM;
         //grant all on "BIT1" to PUBLIC;
         //grant all on "BIT1" to SYSDBA;
        end;
Result:=sSql+'*_*'+s+'*_*';
except  on e: Exception do
        begin log(e.Message);
              Result:='Error:_:'+e.Message;
        end;
end;
end;

function ptsTablaSave(xvar:string):String;
var  s:String;
     i,c:SmallInt;
begin
try
log('<ptsTablaSave('+xvar+')');
splitCar(xvar);
c:=splitCar(pT[6],'~');
for i:=1 to c do
  begin
    //log(apost1to2(FlujoToStr(pT[i])));
    //xQ(apost1to2(FlujoToStr(pT[i])));
    log((FlujoToStr(pT[i])));
    xQ((FlujoToStr(pT[i])));
  end;
tr.Commit;
s:='Ok';
except  on e: Exception do
        begin s:=e.Message;
              log(e.Message);
        end;
end;
Result:=s;
end;

function pCmdGet:String;
type tCampo=record
     id:String;
     pk:String;
     end;
var  sSql,s,s1,tablas:String;
     tvCampo,i,j:SmallInt;
     vCampo:array[1..1000] of tCampo;
begin
log('<pCmdGet');
s:=IntToStr(ParamCount);
//s:='select first 1000 * from '+Trim(pT[5]);
//sSql:=s;
//bQ(s);
Result:=s;
end;

function pUShell(xvar:string):String;
var  sSql,s,s1,tablas,DOCUMENT_ROOT,SCRIPT_FILENAME:String;
     tvCampo,i,j:SmallInt;
begin
log('<pUShell('+xvar+')');
splitCar(xvar);
DeleteFile('resultado.txt');
DOCUMENT_ROOT:=GetEnv('DOCUMENT_ROOT'); //D:/ultranet/xampp/htdocs
SCRIPT_FILENAME:=GetEnv('SCRIPT_FILENAME'); //D:/ultranet/xampp/cgi-bin/apolo/apolo.exe
s:=DOCUMENT_ROOT+'/../php/php.exe '+ExtractFilePath(SCRIPT_FILENAME)+'uShell.php '+pT[5]
  //+' >resulta.txt'
  ;
pCmd2(s);
//log('resultado obtenido:{{{'+pCmd2(s)+'}}}');
log('1');
stCad:=TStringList.Create;
if FileExists('resultado.txt') then log('si existe');
log('1');
stCad.LoadFromFile('resultado.txt');
log('2');
log('archivo leido:{{{'+stCad.Text+'}}}');
Result:=(stCad.Text);
end;
