const
  esFLarco=     (sisActual='fLarco');
  esFCapullanas=(sisActual='fCapullanas');
  esPollo=      (sisActual='pollo');
  esHuevo=      (sisActual='huevo');
  esLider=      (sisActual='lider');
  esLiderCaja=  (sisActual='liderCaja');
  esLedCar=     (sisActual='ledCar');
  esBici=       (sisActual='bici');
  esBiciCaja=   (sisActual='biciCaja');
  esAcp=        (sisActual='acp');
  esGestion=    (sisActual='gestion');
  esCalzaPc=    (sisActual='calzaPc');
  esCBello=     (sisActual='cBello');
  esSMoto=      (sisActual='sMoto');
  esQSiaf=      (sisActual='qSiaf');
  esFarma=      ((sisActual='farma') or esFLarco or esFCapullanas);
  esBiciMoto=   (esLiderCaja or esLider or esLedCar or esBici);    //Todos los establecimientos de Bicisport/Lider y Bicisport/Ledcar
  FVenceControla=esFarma;
  tidNODEF=0;tidGERENTE=1;tidADMIN=2;tidENSABLE=3;tidVENDEDOR=4;tidCONTAB=5;tidALMACEN=6;tidADMINSIS=7;
  tidOPERA=8;tidTRANSP=9;tidCAJA=10;tidCOMPRA=11;

  uNN	=0;
  uGER	=1;
  uADM	=2;
  uENS	=3;
  uVTA	=4;
  uCNT	=5;
  uALM	=6;
  uSYS	=7;
  uOP	=8;
  uTR	=9;
  uCAJ	=10;
  uCMP 	=11;
  uLGJ	=12;
  uLGO 	=13;
  uDSP  =14;

  MAXCARGOS=50;

  ACTUALIZAR=1;INSERTAR=2;ELIMINAR=3;CONSULTAR=4;

  DOCBOLVTA='10';
  DOCFACVTA='11';
  DOCCONSIGNAVTA='19';
  DOCPROFORMA='53';
  DOCINVINICIAL='14';
  wBARRA=13;
  wBARRACBELLO=13;
  wPRODID=7; wPRODPESO=wBARRACBELLO-wPRODID;

  cssWIDTH=199;
  wINPUT=196;

  rARCHINV='1300130100001111.txt';
  SALTOHINT='&#13';
  opCargaIni = 0;
  opProgRol = 1;        opProductoFiltra = 11;         opCliCredCta = 21;            opSocUno=31;           opManteFiltra=41;
  opTareaDiario = 2;    opVtaReg = 12;                 opCuotaPagoGuarda = 22;       opSocGuarda=32;        opManteUnoVer=42;
  opTareaje = 3;        opClienteMante = 13;           opCliCredPendientes = 23;     opSocNew=33;           opManteActUno=43;
  opProgMes = 4;        opClienteFiltra = 14;          opVtaDetBD = 24;              opSocGuardaNew=34;     opManteAdd=44;
  opLogin = 5;          opClienteSelUno = 15;          opStockMin = 25;              opSocSolicita=35;      opManteDel=45;
  opExpoTar = 6;        opClienteActUno = 16;          opStockAlmsVer = 26;          opSocAprueba=36;       opCronograma=46;
  opJust = 7;           opClienteSectorLista = 17;     opSimula = 27;                opSocRechaza=37;       opCronoGuarda=47;
  opJustVer = 8;        opClienteDel = 18;             opSocCred = 28;               opCmd=38;              opDesembolso=48;
  opPedidoNuevo = 9;    opClienteCtaCredAdd = 19;      opSocCredLista=29;            opGetTEMdeFPago=39;    opOpFiltra=49;
  opClienteSel = 10;    opLugarRefresh = 20;           opSocFiltra=30;               opDocVer=50;           opVtaRegSi=51;
  opOpNuevo=52;         opOpSave=53;                   opBaseCarga=54;               opManteUnoVerDet=56;   opManteAddDet=57;
  opManteFiltraDet=58;  opVtaIdNew=59;                 opModeloCarga=60;             opFasePendFiltra=61;   opFasePendSave=62;
  opPersoFaseCambia=63; opTermPendFiltra=64;           opTermPendSave=65;            opPagoPendFiltra=66;   opPagoPendSave=67;
  opPersoPagoDet=68;    opPrintOrdPVer=69;             opPrintOrdPrn=70;             opCodBarGen=71;        opQrGen=72;
  opOpPrint=73;         opSaleRepQR=74;                opSusp=75;                    opSuspDesact=76;       opPagado=77;
  opPagadoDet=78;       opPagoPendConsolida=79;

  opCliMovDet=80;       opCliMovDetSave=81;            opCliMovDetReload=82;         opCliMovDetNew=83;     opCliMovDetSaveUno=84;
  opCliMovDetGet=85;    opCliMovDetCargaUno=86;        opCliMovDetDel=87;            opCliMovDetCierra=88;
  opProvCredCta=91;     opProvCredCliFiltra=92;        opProvMovDet=93;              opProvMovDetNew=94;    opProvMovDetSaveUno=95;
  opProvMovDetGet=96;   opProvMovDetCargaUno=97;       opProvMovDetDel=98;           opProvMovDetCierra=99;
  opManteMn=200;
  opOpMn=300;
  opOpSaleShow=301;     opOpLlegaShow=302;             opOpSenaShow=303;              opOpEmpShow=304;
  opOpItnEsq=305;       opOpEsqHorAdd=306;             opEsqCiudadAdd=307;
  opCiudadShow=308;     opEsqHoraDel=309;              opEsqCiudadDel=310;            opEsqGuarda=311;
  opOpServShow=312;     opOpServGuarda=313;            opOpServDel=314;               opITNGuardaUno=315;    opItnDel=316;
  opItnEsqTvHacer=317;  opOpSenaGuarda=318;            opOpEmpGuarda=319;             opPuertaAct=320;
  opOpManteSenaShow=325;opCajaVer=326;                 opCajaQuery=327;
  opInvPerVal=328;      opInvProcesar=329;             opInvUltQuery=330;             opInvTxtExpoUno=331;   opInvTxtExpoAll=332;
  opGenInvUno=333;      opComercialMovDetUno=334;      opComercialMovDetHistodo=335;  opProdStock=336;       opGenInvUnoSolo=337;
  opInvProcesarIni=338; opGenInvTanda=339;
  opVentaMarco=340;     opVtaCliComboRefresh=341;      opVtaClienteGetDatos=342;      opVtaCliSerieRefresh=343;
  opVtaCliNroRefresh=344;opPolloVtaReg=345;            opVtaMarco=346;                opVtaGet=347;          opVtaDetOp=348;
  opCliCredCliFiltra=350;
  opInvAct=351;         opInvActFiltra=352;            opInvActCargaUno=353;          opInvUnoSave=354;     opAlmStMove=355;
  opAlmStMoveFiltra=356;opStSaveTmpYFiltra=357;        opStMoveSave=358;
  opInvProcesarFin=360;
  opPolloPesoCaptura=370;

  opCajaResumen=380;    opCajaQueryDet=381;
  opInvDocEntra=391;
  opRepMn=400;
  opSale=500; opSaleSale=501; opSaleExtorna=502;       opSaleRepOp=503;              opBuscaXQr=504;
  opViajeInicia=600;    opViajeMonitor=601;
  opEmpW=701;
  opVDetProdFiltra=801; opVDetProdxGen=802;            opVDetSave=803;               opP100Carga=804;        opVtaAnula=805;
  opVDetGenFiltra=806;
  opPrnSaltaLinea=901;
  opCompraMarco=951;    opCmpProvComboRefresh=952;     opCmpProvGetDatos=953;        opCmpReg=954;           opCmpHistMarco=955;
  opCmpHistFiltro=956;  opCmpDetVer=957;               opCmpNtCredGen=958;           opCmpNtOp=959;             opCmpNtDetVer=960;
  opCmpNtDetAmlVer=961;    opCmpNtDetAmlSave=962;      opCmpNtSaveSerieNro=963;
  opRepFVence=1001;     opRepFVenceFiltra=1002;        opRepFVenceFiltraDet1=1003;   opRepStock=1004;        opRepStockFiltra=1005;
  opRepProvPrecio=1006; opRepProvPrecioFiltra=1007;
  opPolloMuertoMarco=1101;  opPolloMuertoSave=1102; opPolloDevolucionMarco=1103;  opPolloDevolucionSave=1104;
  opProdToXls=1010;         opCmpToXls=1011;
  opVtaHistMarco=1020;   opVtaHistFiltro=1021;  opVtaDetVer=1022;            opVtaNtCredGen=1023;           opVtaNtOp=1024;
  opVtaNtDetVer=1025;    opVtaNtDetAmlVer=1026;    opVtaNtDetAmlSave=1027;            opVtaNtSaveSerieNro=1028;
  opProdSaleHistMarco=1501;   opProdSaleHistFiltra=1502;
  opOpOrden=2001;opOpPre=2002; opOpFiltraPre=2003;   opOpNuevoPre=2004;
  opFaseMn=2300;
  opFaseRep=2400;
  opKardex=3001;        opRepKxFiltra=3002;
  opKx=3003;            opKxFiltra=3004;      opKxUnoVer=3005;
  opKxMat=3006;    opKxMatFiltra=3007;  opKxMatUnoVer=3008;    opKxMatMovSave=3009;     opKxEditSave=3010;    opStActVer=3011;
  //calzaPc
  opDestPendFiltra=4064;           opDestPendSave=4065;         opDestinadoFiltra=4066;

  opHvCorrIni=5001;   opHuevoPesoCaptura=5002;   opProdDetSave=5103;

  opProdDetMarco=5101;opModeloGet=5102;
  opSiafMarco=6000; opSiaf=6001;
type TRestric=record
     Cargo:SmallInt;
     No:string[5];
     Tabla:String[50];
     //L
     //E
     //W
     // ID  Lectura,escritura,inserción,delete

end;

var
     vC:Array[1..MAXINPUTS] of TCampo; tvCampo:Integer;
     vCargo:array[1..100] of SmallInt; tvCargo:Integer;
     vAcc:array[1..100] of Boolean; tvAcc:Integer;
     vTabla:array[1..MAXTABLAS] of TTabla; tvTabla:Integer;
     vCampo:array[1..MAXTABLAS,1..MAXCAMPOS] of TCampo;
     vMenu: array[1..MAXTABLAS] of TMenu; tvMenu:Integer;
     vRestric:array[0..100] of TRestric; tvRestric:SmallInt;
     vAdminTabExclusivo:array[0..100] of string; tvAdminTabExclusivo:SmallInt;
     tvHtCol,tvsPK,ivsPK,tvsFKMaeDet,tLsBotFilt:Integer;
     vsPK,vsFKMaeDet:array[1..50] of String;
     IDCAJATERMINAL,FULLARCHINVTXT,INVANIO,invRUC,rutaInvRep:String;
     usNODEF,usGERENTE,usADMIN,usENSABLE,usVENDEDOR,usCONTAB,usALMACEN,usADMINSIS,usOPERA,usTRANSP,usCAJA,usCOMPRA:Boolean;

function iif(condicion: boolean; cad1, cad2: string): string;
begin if condicion
         then Result:=cad1
         else Result:=cad2;
end;

procedure log(cad:string);
var F: TextFile;
begin
      if not logACTIVO then exit;
      AssignFile(F, ArchLOG);
      Append(F);
      WriteLn(F, cad);
      CloseFile(F);
end;
procedure logTiempo(cad:string);
var F: TextFile;
    Hour, Minute, Second, MilliSecond: word;
begin
      //if not logACTIVO then exit;
      AssignFile(F, ArchLOG);
      Append(F);
      DecodeTime(now,Hour,Minute,Second,MilliSecond);
      WriteLn(F, IntToStr(Hour)+':'+IntToStr(Minute)+':'+IntToStr(Second)+' '+cad);
      CloseFile(F);
end;

function splitCar(cad, car: string): integer;
var c, L, i: integer;
begin
IF length(cad)=0 THEN BEGIN result:=0; exit; END;
CAD:=CAD+CAR;
L:=length(cad);
c:=0;
pTab[0]:=0;
for i:=1 to L do
   if cad[i]=car then
      begin c:=c+1;
            pTab[c]:=i;
      end;
if c > 0 then
   begin for i:=1 to c do
           if pTab[i] - pTab[i - 1] > 1
              then pT[i]:=copy(cad, pTab[i - 1]+1, pTab[i] - pTab[i - 1] - 1)
              else pT[i]:='';
   end;
Result:=c;
end;


function slashAdd(cad:String):String;
begin
if (RightStr(cad,1)<>'/') and (RightStr(cad,1)<>'\')
   then result:=cad+'/'
   else result:=cad;
end;

function charHumaniza(cad:string):string;
var p,L,i,tvRemp:integer;
    s,r,sHex:string;
    sC:array[1..250] of string;
begin
sHex:='%F1%D1%E1%E9%ED%F3%FA%C1%C9%CD%D3%DA%40%2F%28%29%5B%5D%7B%7D%BF%2B%2C%3B%3C%3E%21%22%23%24%25%26%2F%28%29%3D%3F%A1%7C%27';
i:=0;
inc(i);sC[i]:='ñ';
inc(i);sC[i]:='Ñ';
inc(i);sC[i]:='á';
inc(i);sC[i]:='é';
inc(i);sC[i]:='í';
inc(i);sC[i]:='ó';
inc(i);sC[i]:='ú';
inc(i);sC[i]:='Á';
inc(i);sC[i]:='É';
inc(i);sC[i]:='Í';
inc(i);sC[i]:='Ó';
inc(i);sC[i]:='Ú';
inc(i);sC[i]:='@';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='[';
inc(i);sC[i]:=']';
inc(i);sC[i]:='{';
inc(i);sC[i]:='}';
inc(i);sC[i]:='¿';
inc(i);sC[i]:='+';
inc(i);sC[i]:=',';
inc(i);sC[i]:=';';
inc(i);sC[i]:='<';
inc(i);sC[i]:='>';
inc(i);sC[i]:='!';
inc(i);sC[i]:='"';
inc(i);sC[i]:='#';
inc(i);sC[i]:='$';
inc(i);sC[i]:='%';
inc(i);sC[i]:='&';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='=';
inc(i);sC[i]:='?';
inc(i);sC[i]:='¡';
inc(i);sC[i]:='|';
inc(i);sC[i]:='''';
s:=trim(cad);
L:=length(s);
i:=0;r:='';
while i<L do
  begin inc(i);
        if s[i]='+' then r:=r+' '
        else if s[i]='%' then
                begin p:=pos(s[i]+s[i+1]+s[i+2],sHex);
                      if p>0 then begin r:=r+sC[(p+2) div 3];
                                        i:=i+2;
                                  end;
                end
             else r:=r+s[i];
  end;
result:=r;
end;

function charHumanizaNoTrim(cad:string):string;
var p,L,i,tvRemp:integer;
    s,r,sHex:string;
    sC:array[1..250] of string;
begin
sHex:='%F1%D1%E1%E9%ED%F3%FA%C1%C9%CD%D3%DA%40%2F%28%29%5B%5D%7B%7D%BF%2B%2C%3B%3C%3E%21%22%23%24%25%26%2F%28%29%3D%3F%A1%7C%27';
i:=0;
inc(i);sC[i]:='ñ';
inc(i);sC[i]:='Ñ';
inc(i);sC[i]:='á';
inc(i);sC[i]:='é';
inc(i);sC[i]:='í';
inc(i);sC[i]:='ó';
inc(i);sC[i]:='ú';
inc(i);sC[i]:='Á';
inc(i);sC[i]:='É';
inc(i);sC[i]:='Í';
inc(i);sC[i]:='Ó';
inc(i);sC[i]:='Ú';
inc(i);sC[i]:='@';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='[';
inc(i);sC[i]:=']';
inc(i);sC[i]:='{';
inc(i);sC[i]:='}';
inc(i);sC[i]:='¿';
inc(i);sC[i]:='+';
inc(i);sC[i]:=',';
inc(i);sC[i]:=';';
inc(i);sC[i]:='<';
inc(i);sC[i]:='>';
inc(i);sC[i]:='!';
inc(i);sC[i]:='"';
inc(i);sC[i]:='#';
inc(i);sC[i]:='$';
inc(i);sC[i]:='%';
inc(i);sC[i]:='&';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='=';
inc(i);sC[i]:='?';
inc(i);sC[i]:='¡';
inc(i);sC[i]:='|';
inc(i);sC[i]:='''';
s:=(cad);
L:=length(s);
i:=0;r:='';
while i<L do
  begin inc(i);
        if s[i]='+' then r:=r+' '
        else if s[i]='%' then
                begin p:=pos(s[i]+s[i+1]+s[i+2],sHex);
                      if p>0 then begin r:=r+sC[(p+2) div 3];
                                        i:=i+2;
                                  end;
                end
             else r:=r+s[i];
  end;
result:=r;
end;

function uPos(xCad, xCar: string): integer;
var i: integer;
begin
  Result:=0;
  for i:=1 to length(xCad) do
    if xCad[i] = xCar then
    begin Result:=i;
          exit;
    end;
end;

function devStrP(var cadFuente: string; cadBusca, separa, igualdad: string): string;
var i, p: integer;
begin tPost:=splitCar(cadFuente, separa);
      Result:='';
      for i:=1 to tPost do
      begin p:=uPos(UpperCase(pT[i]), igualdad);
            if (p > 0) and (UpperCase(LeftStr(pT[i], p - 1)) = UpperCase(cadBusca)) then
                begin Result:=RightStr(pT[i], length(pT[i]) - p);
                      exit;
                end;
      end;
end;

function ReverseString(s: string): string;
var i: integer; s2: string;
begin s2:='';
      for i:=1 to Length(s) do s2:=s[i]+s2;
      Result:=s2;
end;

function devStr(xCad: string): string;
var i, p: integer;
begin tPost:=splitCar(a, '&');
      Result:='';
      for i:=1 to tPost do
        begin p:=uPos(UpperCase(pT[i]), '=');
              if (p > 0) and (UpperCase(LeftStr(pT[i], p - 1)) = UpperCase(xCad)) then
                  begin Result:=RightStr(pT[i], length(pT[i]) - p);
                        exit;
                  end;
        end;
end;

function devInt(xCad: string): integer;
begin Result:=StrToInt(Trim(devStr(xCad)));
end;

function devTrim(xCad: string): string;
begin Result:=Trim(devStr(xCad));
end;

function deCripta(x: string): string;
var y, s: string;
    sw, L, i: smallint;
begin
  //result:=x; exit;
  y:=x;
  s:='';
  sw:=(-10);
  L:=length(y);
  for i:=1 to L do
  begin s:=s+chr(Ord(y[i])+sw);
        sw:=-sw;
  end;
  Result:=s;
end;

function cripta(x: string): string;
var y, s: string;
    sw, L, i: smallint;
begin
  //result:=x; exit;
  y:=x;
  s:='';
  sw:=(10);
  L:=length(y);
  for i:=1 to L do
  begin s:=s+chr(Ord(y[i])+sw);
        sw:=-sw;
  end;
  Result:=s;
end;
function bQ(xvar: string):integer;
begin q.Close; q.SQL.Text:=xvar; if logACTIVO then log(xvar);
      q.Open; Result:=q.RecordCount;
end;
function bQNoLog(xvar: string):integer;
begin q.Close; q.SQL.Text:=xvar; q.Open; Result:=q.RecordCount;
end;

function bQ1(xvar: string):integer;
begin q1.Close; q1.SQL.Text:=xvar; if logACTIVO then log(xvar);
      q1.Open; Result:=q1.RecordCount;
end;

function bQ1NoLog(xvar: string):integer;
begin q1.Close; q1.SQL.Text:=xvar; q1.Open; Result:=q1.RecordCount;
end;

function bIq(xvar: string):integer;
begin iq.Close; iq.SQL.Text:=xvar; if logACTIVO then log(xvar);
      iq.Open; Result:=iq.RecordCount;
end;

function bIqNoLog(xvar: string):integer;
begin iq.Close; iq.SQL.Text:=xvar; iq.Open; Result:=iq.RecordCount;
end;

function rQ(xvar: string): string;
begin q.Close; q.SQL.Text:=xvar; if logACTIVO then log(xvar);
      q.Open; Result:=q.Fields[0].AsString;
end;
function rQ1(xvar: string): string;
begin q1.Close; q1.SQL.Text:=xvar; if logACTIVO then log(xvar);
      q1.Open; Result:=q1.Fields[0].AsString;
end;
function rIQ(xvar: string): string;
begin iq.Close; iq.SQL.Text:=xvar; if logACTIVO then log(xvar);
      iq.Open; Result:=iq.Fields[0].AsString;
end;
function rIQNoLog(xvar: string): string;
begin iq.Close; iq.SQL.Text:=xvar;
      iq.Open; Result:=iq.Fields[0].AsString;
end;

function rQInt(xvar: string): integer;
begin q.Close; q.SQL.Text:=xvar;if logACTIVO then log(xvar);
      q.Open; Result:=q.Fields[0].AsInteger;
end;

function rQFloat(xvar: string):Real;
begin q.Close; q.SQL.Text:=xvar;if logACTIVO then log(xvar);
      q.Open; Result:=q.Fields[0].AsFloat;
end;

procedure xQ(xvar: string);
begin q.Close; q.SQL.Text:=xvar; if logACTIVO then log(xvar);
      q.ExecSQL;
end;

procedure xIq(xvar: string);
begin iq.Close; iq.SQL.Text:=xvar; if logACTIVO then log(xvar);
      iq.ExecSQL;
end;

procedure xIqNoLog(xvar: string);
begin iq.Close; iq.SQL.Text:=xvar; iq.ExecSQL;
end;

procedure xQNoLog(xvar: string);
begin q.Close;   q.SQL.Text:=xvar;  q.ExecSQL;
end;

procedure xQ1(xvar: string);
begin q1.Close; q1.SQL.Text:=xvar; if logACTIVO then log(xvar);
      q1.ExecSQL;
end;

procedure xQ1NoLog(xvar: string);
begin q1.Close; q1.SQL.Text:=xvar; q1.ExecSQL;
end;

procedure w(cad: string);
begin if printSI then
         if SALTOLINEA
            then writeln(cad)
            else Write(cad);
end;

function btBdConectaClick(xUsuario,xPassword: string): boolean;
begin
  Result:=False;
  bd:=TIBConnection.Create(nil);
  tr:=TSQLTransaction.Create(nil);
  iq:=TSqlQuery.Create(nil);     q:=TSqlQuery.Create(nil); q1:=TSqlQuery.Create(nil);  qRol:=TSqlQuery.Create(nil);
  dsPersonal:=TDataSource.Create(nil);
  bd.Connected:=False; tr.Active:=False;
  if usDirecto
     then begin bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:=xUsuario;  bd.Password:=xPassword; end  //Usuario y sena son creados en servidor
     else begin bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:='sysdba';  bd.Password:='masterke' end; //Usuario y sena están en tabla
     //else begin bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:=deCripta(criUS);  bd.Password:=deCripta(criPASS); end; //Usuario y sena están en tabla
  bd.Dialect:=3;
  //if (sisActual='bici') or (sisActual='ledCar') then bd.CharSet:='ISO8859_1';
  bd.CharSet:=BDCHARSET;
  log('bd.CharSet:'+bd.CharSet);
  bd.LoginPrompt:=False;
  tr.DataBase:=bd;
  try bd.Connected:=True;
      tr.Active:=True;
      iq.Transaction:=tr;    iq.DataBase:=bd;
      q.Transaction:=tr;     q.DataBase:=bd;
      q1.Transaction:=tr;    q1.DataBase:=bd;
      qRol.Transaction:=tr;  qRol.DataBase:=bd;
      qRol.DataSource:=dsPersonal;
      Result:=True;
      log('try ok Bd Conecta');
      if not usDirecto then
             begin  //q.close; q.SQL.Text:=xvar; log(xvar); q.Open;
                    bQ('select first 1 ID from PERSO where CORREO='''+usLogueo+''' and SENA='''+passLogueo+'''');
                    if q.RecordCount=0
                       then begin Result:=False;
                                  log(pathBD+': Usuario ('+bd.UserName+') o contraseña ('+bd.Password+') incorrectos.');
                            end
                       else begin usIdPerso:=q.Fields[0].AsString;
                                  log('Us indirecto logueado Ok');
                            end;
              end;
  except on e: Exception do
      begin Result:=False;
            log('Excepción: '+pathBD+': Usuario ('+bd.UserName+') o contraseña ('+bd.Password+') incorrectos. '+e.Message);
      end;
  end;
end;

function pSesion:SmallInt;
begin
try
log('<pSesion');
s:='';
sesionadoSI:=False;
reqCk:=GetEnv('HTTP_COOKIE');
reqCkValue:=RightStr(reqCk, Length(reqCk) - pos('=', reqCk));
//log('cockie leido al natural: |'+reqCk+'|');
ck:=ReverseString(reqCkValue);
ck:=charHumaniza(ck);
//s:=s+('Cockie revertido y humanizado='+ck+'<br>');
a:='';
a:=GetEnv('QUERY_STRING');
if a = '' then  begin a:='';
                      while not EOF(input) do
                      begin Read(c);
                            a:=a+c;
                      end;
                end;
//log(s);
//log('Cadena natural recibida POST/GET |'+a+'|');
//sin funciona
//a:=FlujoToStr(a);
a:=charHumaniza(a);
log('Cadena humanizada POST/GET |'+a+'|');
//log('application.requestvariables'+application.requestvariables['file']);
sesionadoSI:=(devStrP(ck, 'sesionado', '&', ':') = 'si');
cuenta:=devStrP(ck, 'c', '&', ':');
s:=s+('Leido c='+cuenta+'<br>');
if cuenta = ''
   then cuenta:='0'
   else cuenta:=IntToStr(StrToInt(cuenta)+1);
s:=s+('Nuevo c='+cuenta+'<br>');
//Cerrando sesión
if (devStr('edSal') = 'S') then
    begin a:='';
          sesionadoSI:=False;
    end;
log('pre1');
if (trim(devStr('op')) <> '')
   then OP:=devInt('op')
   else if trim(devStrP(ck, 'op', '&', ':')) = ''
           then OP:=-1
           else OP:=StrToInt(trim(devStrP(ck, 'op', '&', ':')));
log('Entrando Cockie:op='+devStrP(ck, 'op', '&', ':')+'|us='+devStrP(ck, 'us', '&', ':')+'|sena='+devStrP(ck, 'sena', '&', ':')+'|sesionado='+devStrP(ck, 'sesionado', '&', ':'));
log('Entrando Data:  op='+devStr('op')+'|us='+devStr('us')+'|sena='+devStr('sena'));
//ckParOtros:='; path=/; expires= Sat, 21-Mar-2024  18:37:00 GMT';
if esFLarco then ckParOtros:=deCripta('EzW~^G%Eonz_|[}3*Ikj6<''7Ckh7(:(>*''B0=-D&:QC^') //   ; path=/; expires= Sat, 21-Mar-2024  18:37:00 GMT
else if sisActual='farma'  then ckParOtros:=deCripta('EzW~^G%Eonz_|[}3*Ikj6<''7Ckh7(:(>*''B0=-D&:QC^') //   ; path=/; expires= Sat, 29-Nov-2024  18:37:00 GMT
else if (sisActual='bici')     or(sisActual='lider')
      or(sisActual='biciCaja') or(sisActual='liderCaja')
      or(sisActual='ledCar')
      or(sisActual='sMoto')
      or(sisActual='calza')    or(sisActual='calzaPc')
      or(sisActual='pollo')
      or(sisActual='cBello')
      or(sisActual='huevo')
      or(sisActual='qSiaf')
      then ckParOtros:=deCripta('EzW~^G%Eonz_|[}3*Ikj6<''7Ckh7(:(>*''B0=-D&:QC^') //   ; path=/; expires= Sat, 29-Nov-2024  18:37:00 GMT
else if sisActual='cBello' then ckParOtros:=deCripta('EzW~^G%Eonz_|[}3*Ikj6:-7<oX7(:''?*''B0=-D&:QC^') //   ; path=/; expires= Sat, 07-Feb-2015  18:37:00 GMT
else             ckParOtros:=deCripta('EzW~^G%Eonz_|[}3*Ikj6;+7Dyl7(:''>*''B0=-D&:QC^');          //   [; path=/; expires= Sat, 15-Nov-2014  18:37:00 GMT]
                 //ckParOtros:=deCripta('EzW~^G%Eonz_|[}3*Ikj6<''7Ckh7(:(>*''B0=-D&:QC^'); //   ; path=/; expires= Sat, 21-Mar-2024  18:37:00 GMT;//log('Expira:'+ckParOtros)
if OP=-1
   then begin log('sesionadoNO. Cierre sesión manual (-1)');
              outCk:='&sesionado:no&us:&sena:'+'&c:'+cuenta+'&op:';
              writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
              writeln('Content-Type:text/html', #10#13);
        end
   else
      if sesionadoSI
         then   begin
                  log('sesionadoSI then');
                  usLogueo:=devStrP(ck, 'us', '&', ':');
                  passLogueo:=devStrP(ck, 'sena', '&', ':');//opCockie:=devStrP(ck,'op','&',':');
                  if btBdConectaClick(usLogueo, passLogueo)
                   then begin outCk:='&sesionado:si&us:'+usLogueo+'&sena:'+passLogueo+'&c:'+cuenta+'&op:'+IntToStr(OP);
                         //     writeln('Set-cookie:pollo='+ReverseString(outCk)+'; path=/; expires= Sat, 01-Dic-2012  18:37:00 GMT'); dura hasta q se cierre el navegador
                              writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);  //Dura hastas que se cierre sesio explícitamente
                              writeln('Content-Type:text/html', #10#13);
      {
                              sCurANIO:=rQ('select first 1 cast(VALOR as smallint) from CNF where ID=''CURANIO''');
                              if ProgVencido then
                                 begin log('Vencido'); op:=-1;
                                       q.Close;q.SQL.Text:='update PERSONAL set ACTIVO=null where ID=13';
                                       q.ExecSQL;tr.Commit;
                                 end;
                              q.Close;q.SQL.Text:='select count(*) from PERSONAL where ID=13 and trim(ACTIVO)=''''';
                              q.Open;
                              if q.Fields[0].AsInteger=0 then halt;
      }
                              log('Reabierto');
                        end
                   else begin log('Sesionado si pero no abre BD: uslogueo='+usLogueo);
                              outCk:='&sesionado:no&us:&sena:'+'&c:'+cuenta+'&op:';
                              writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                              writeln('Content-Type:text/html', #10#13);
                              OP:=-1;
                        end;
                end
         else   begin
                  log('sesionadoSI else');
                  usLogueo:=devTrim('us');
                  passLogueo:=devTrim('sena');//opCockie:=trim(devStr('op'));
                  //IF(passLogueo='12345678') THEN HALT;
                  if btBdConectaClick(usLogueo, passLogueo)
                    then
                      begin
                        log('sesionadoSI else btBdConectaClick then');
                        outCk:='&sesionado:si&us:'+usLogueo+'&sena:'+passLogueo+'&c:'+cuenta+'&op:'+IntToStr(OP);
                        writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                        writeln('Content-Type:text/html', #10#13);     {
                        sCurANIO:=rQ('select first 1 cast(VALOR as smallint) from CNF where ID=''CURANIO''');
                        if ProgVencido then
                           begin log('Vencido'); op:=-1;
                                 q.Close;q.SQL.Text:='update PERSONAL set ACTIVO=null where ID=13';
                                 q.ExecSQL;tr.Commit;
                           end;
                        q.Close;q.SQL.Text:='select count(*) from PERSONAL where ID=13 and trim(ACTIVO)=''''';
                        q.Open;
                        if q.Fields[0].AsInteger=0 then halt;
      }
                        log('Abierto');
                        OP:=opLogin;
                      end
                    else
                      begin
                        log('sesionadoSI else btBdConectaClick else');
                        outCk:='&sesionado:no&us:&sena:'+'&c:'+cuenta+'&op:';
                        writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                        writeln('Content-Type:text/html', #10#13);
                        //log('Loguearse');
                        OP:=-1;
                      end;
                end;
except
  on e: Exception do begin log('Excepción: pSesion: '+e.Message);
                           w('Exception en pSesión: '+e.Message);//Error u opción <br>incorrecta<a href="sfdsafds">Cerrar</a><br><a href="'+urlExe+'?op=5">Intentar restaurar</a>');
                           halt;
                     end
end;
log('pSesion(Result:'+IntToStr(OP)+')>');
result:=OP;
end;


function Inicializa:SmallInt;
var F:TextFile; linea:ansistring;c,i:Integer;
    valor,fullExe:String;
begin
_Ini:='--'; _Fin:='--'; logACTIVO:=True; printSI:=True;
ShortDateFormat:='dd/mm/yyyy'; LongTimeFormat:='hh:mm'; DecimalSeparator:='.';
//if xSO=SOWINDOWS then splitCar(par);

fullExe:=ParamStr(0);
pathCGI:=ExtractFilePath(fullExe);      //   E:\programas\xampp\cgi-bin\bici\
ArchLOG:=pathCGI+'log/log.txt';
subDirPublic:='public/';subDirPublicCargo:='public/cargo/';

if       sisActual='bici'        then invRUC:='20440433945'
else if pos('lider',sisActual)>0 then invRUC:='20480926910'
else if  sisActual='ledCar'      then invRUC:='20477734155'
else                                  invRUC:='00000000000';
//ArchGPS:=pathCGI +'gps/gps.txt';
AssignFile(F,pathCGI+'cnf.ini');
Reset(F);
nomExe:=ExtractFileName(fullExe);
tipoOp:='';sOpWhereAnio:='';
cliMovPagIntervalo:=10;provMovPagIntervalo:=10;
log('Entramos a ['+nomExe+']');
while not EOF(F) do
  begin ReadLn(F, linea);
        c:=splitCar(linea,'=');
        pT[2]:=trim(pT[2]);
        if UpperCase('Param1')=trim(UpperCase(pT[1])) then begin urlExe:=       slashAdd(pT[2])+nomExe;   // /unet/bici/
                                                              end;
        if UpperCase('Param2')=trim(UpperCase(pT[1])) then urlImg:=             slashAdd(pT[2]);    //  /carpetaHttpW/img/
        if UpperCase('Param2')=trim(UpperCase(pT[1])) then urlImgMante:=        pT[2]+'../../uBiblio/';
        if UpperCase('Param3')=trim(UpperCase(pT[1])) then pathHTTP:=           slashAdd(pT[2]);
        if UpperCase('Param4')=trim(UpperCase(pT[1])) then begin sRutaEjeSlash:=slashAdd(pT[2]);
                                                                    //if esLiderCaja then pathBD:=BDNOMBRE
                                                                    //           else
                                                                    pathBD:=slashAdd(pT[2])+BDNOMBRE;
                                                              end;
        if UpperCase('Param5')=trim(UpperCase(pT[1])) then host:=               pT[2];
        if UpperCase('Param6')=trim(UpperCase(pT[1])) then charSetBD:=          pT[2];
        //if UpperCase('Param7')=trim(UpperCase(pT[1])) then sRutaBD:=           pT[2];
        if UpperCase('Param7')=trim(UpperCase(pT[1])) then if pT[2]='0' then usDirecto:=false else usDirecto:=true; //0:Usuario y sena son definidos en la tabla personal de ba BD data.unet u otra; 1:Usuario y sena son definidos en el servidor firebird
  end;
CloseFile(F);
AssignFile(fArch, ArchLOG); if FileExists(ArchLOG) then Append(fArch) else ReWrite(fArch);
WriteLn(fArch, '******************'+DateToStr(Now)+':'+TimeToStr(Now)+'******************');
CloseFile(fArch);
log('<Inicializa');
tvTabla:=0;
tvCampo:=0;
tvMenu:=0;
IDCAJATERMINAL:='CJA';
OP:=pSesion;
tPost:=splitCar(a,'&');
xMsg:='';
result:=OP;
log('pathBD:'+pathBD);
usNODEF:=false;usGERENTE:=false;usADMIN:=false;usENSABLE:=false;usVENDEDOR:=false;usCONTAB:=false;usALMACEN:=false;usADMINSIS:=false;usOPERA:=false;usTRANSP:=false;usCAJA:=false;usCOMPRA:=false;
for i:=1 to MAXCARGOS do vAcc[i]:=false;
log('Inicializa(Result:='+IntToStr(OP)+')>');
end;

function Lee(archivo:string;soloBody:boolean):string;
var F:Textfile;
    s,finLinea,linea:String;
    swBody:boolean;
    i:Integer;
begin
finLinea:=#13#10;
log(pathHTTP+archivo);

AssignFile(F,pathHTTP+archivo);
Reset(F);
swBody:=false;
s:='';
i:=0;
while not EOF(F) do
  begin ReadLn(F, linea);
        if not soloBody
           then s:=s+linea+finLinea
           else
                if swBody
                   then begin i:=pos('</BODY',uppercase(linea));
                              if i>0 then begin s:=s+LeftStr(linea,i-1)+finLinea;
                                                break;
                                           end;
                              for i:=1 to length(linea)do s:=s+linea[i];
                              s:=s+finLinea;
                        end
                   else begin i:=pos('<BODY',uppercase(linea));
                              if i>0 then
                                 begin while((linea[i+1]<>'>') and (not EOF(F)) and (i<length(linea))) do
                                          begin inc(i);
                                                //ReadLn(F, linea);
                                          end;
                                       s:=s+RightStr(linea,length(linea)-i-1)+finLinea;
                                       swBody:=true;
                                 end;
                         end;
  end;
CloseFile(F);
result:=s;
end;

function bCampo(valor:String;t:SmallInt):SmallInt;
var i:Integer;
begin
  for i:=1 to t do
    if UpperCase(vC[i].Id)=valor then
       begin //log(UpperCase(vC[i].Id)+'|'+valor);
             result:=i; exit;
       end;
  result:=-1;
end;

function devHTML(arch:String):string;
var s,rs:String;
    c,i,L:Integer;
    swEnScrip:SmallInt;  //-1 inicio, 1 En script, 0 apaga
    sScript:String;
begin
log('<devHTML('+arch+')');
s:=Lee(arch,false); //log(s);
L:=length(s);
swEnScrip:=-1;
i:=0; sScript:='';
rs:='';
while i<L do
 begin inc(i);
       if (copy(s,i,2)=_Ini) and (swEnScrip=-1) then swEnScrip:=0;
       if copy(s,i,2)=_Ini then
          if swEnScrip=0
             then begin swEnScrip:=1; Inc(i,2);  sScript:='';
                  end
             else begin swEnScrip:=0; Inc(i,1);
                  end;
       if swEnScrip=1 then sScript:=sScript+s[i]
       else if swEnScrip=0 then
                begin c:=bCampo(UpperCase(trim(sScript)),tvCampo);
                      swEnScrip:=-1;
                      if c=-1
                         then rs:=rs+'{ERROR}{No existe}{'+sScript+'}'
                         else rs:=rs+UTF8Decode(vC[c].value);
                end
       else rs:=rs+s[i];
 end;
result:=rs;
end;

procedure pHtmlShow(htmlArch:String);
begin
log('<pHtmlShow('+htmlArch+')');
TRY
//GenVm('USCock',                   '');
EXCEPT on e:Exception do log(e.Message);
END;
w((devHTML(htmlArch)));
end;

function opcionIncorrecta(msg:String):String;
var s:String;
begin
log('<opcionIncorrecta: op='+IntToStr(OP));
s:=UTF8Decode('<div class=csMsgErr><br>Error.'+msg);
s:=s+'<br><a href="'+urlExe+Ejecutable+'?op=5">Reactivar</a>';
s:=s+'<br><a href="'+urlExe+Ejecutable+'?op=-1">Cerrar</a>';
//s:=s+'<center><table><tr><td><form name=fOp acction="'+urlExe+Ejecutable+'" method="post"><input type=hidden name=op value=-1><input type=submit value=Cerrar></form>';
//s:=s+'<td><form name=fOp acction="'+urlExe+Ejecutable+'" method="post"><input type=hidden name=op value=5><input type=submit value="Reactivar"></form></table></center></div>';
result:=s;
end;

procedure GenVm(id,dat:string);
begin inc(tvCampo);vC[tvCampo].Id:=id; vC[tvCampo].value:=dat;
end;


