//{$I ../uBiblio/uVenta.pas}
uses
  dos,
  {$If Defined(linuxMySql55)}     mysql55conn,   {$IfEnd}
  {$If Defined(linuxMySql56)}     mysql56conn,   {$IfEnd}
  {$If Defined(linuxFirebird25) or Defined(windowsFirebird25)}  IBConnection,   {$IfEnd}
  sqldb,DB,dateUtils,SysUtils,process,
  ShellApi,
  FileUtil,
  Classes;

//{$R *.res}
{$I gestionIni.pas}
//  {$I ../uBiblio/bibAnx1.pas}
{$I ../uBiblio/bib1.pas}
//{$If Defined(SYSBUS)}
//{$I ../uBiblio/busBiblio.pas}
//{$IfEnd}
{$I ../uBiblio/manteIni.pas}
//{$I ../uBiblio/kxIni.pas}
//{$I ../uBiblio/vta.pas}
//{$I ../uBiblio/anlsis.pas}

//*****************************************

{$If Defined(FEDEF)}
procedure pCmdLinea(Comando:String;salida:string='salida.txt');
var UnProceso: TProcess;
    UnaLista: TStringList;
begin
log('<pCmdLinea('+Comando+','+salida+')');
// Creamos el objeto TStringList.
   UnaLista := TStringList.Create;
   UnProceso := TProcess.Create(nil);
   UnProceso.CommandLine := Comando;
   UnProceso.Options := UnProceso.Options + [poWaitOnExit, poUsePipes];
   // Lanzamos la ejecución de 'ppc386 -h'.
   UnProceso.Execute;
   UnaLista.LoadFromStream(UnProceso.Output);
   // Guardamos la salida en un archivo.
   UnaLista.SaveToFile(salida);
   UnaLista.Free;
   UnProceso.Free;
//fpsystem('dir');
//s:='d:\strip.exe '+trim(Memo1.Lines[0]);
//ShellExecute(Handle, PChar ('open'), PChar (s),PChar (''), PChar (trim(Memo1.Lines[0])), 1);
////ShellExecute(Handle, PChar ('open'), PChar (s),PChar ('127.0.0.1:888/utes6h'), PChar (''), 1);
end;

function solesAletras(APagar:Real):String;
var xTotal,xEntero,xDecimal:String;
begin xTotal:='0'+FloatToStr(APagar);
      if pos('.',xTotal)>0
         then begin xEntero:=LeftStr(xTotal,pos('.',xTotal)-1);
                    xDecimal:=LeftStr(RightStr(xTotal,length(xTotal)-pos('.',xTotal))+'0',2);
              end
         else begin xEntero:=xTotal;
                    xDecimal:='00';
              end;
      result:=NumLetra(StrToFloat(xEntero),1,1)+ ' con '+xDecimal+'/100 soles';
end;

{$IfEnd}

function pXMLPDFdownM(docVta:String):String;
var n,i,c:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    sFE,sFEdet,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,
    txtCOD_TIPO_MOTIVO,txtDESCRIPCION_MOTIVO,
    txtTIPO_COMPROBANTE_MODIFICA,txtNRO_DOCUMENTO_MODIFICA,
    txtNRO_COMPROBANTE,txtCOD_TIPO_DOCUMENTO,
    txtNRO_DOCUMENTO_CLIENTE,xRUC,IDDOC,SERIE,NRO,resCPEenviado,s,
    VTAIDDOC,VTAFECHA,
    cpeRUC,cpeRSocialTienda,cpeDomicilio
    :String;
    IGV:Real;

begin
try
log('<pXMLPDFdownM('+docVta+')');
//s:='<html lang="es"><head>'
//  +'<meta http-equiv="content-type" content="text/html; charset=utf-8"><title>Consulta de documento de venta</title>'
//  +'<meta name="viewport" content="width=device-width, user-scalable:no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">'
//  +'<script src="/uBiblio/fCpe.js" type="text/javascript" language="javascript"></script>'
//  +'<body>'
//  +'<table><tr>'
//  +'<td>Tipo de documento<td>Serie-Correlativo'
//  +'<tr><td><select id=idTipoDoc><option id=1>Boleta<option id=3>Factura<option id=7>Nota de crédito<option id=8>Nota de débito</select>'
//  +'<td><input type=text id=idSerieNro value=23746 placeHolder="Ej.: F005-239">'
//  +'<tr><td>Fecha de emisión<td>Monto total'
//  +'<tr><td><input type=date id=idFEmision><td><input type=number id=idTotal>'
//  +'<tr><td colspan=2 rowspan=1><input type=button value=Consultar onclick="pXMLPDFdownGet()";>'
//  +'</table>'
//  +'</body></html>'
//  ;
GenVm('iniScript','');
w((devHTML('../uBiblio/pXMLPDFdownM.html')));
except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
//w(s);
end;

function pXMLPDFdownGet(docVta:String):String;
var n,i,c:Integer;
    aPagar,totalVta,inafecta,tIGV,TIGVdeducido,SUBTOTAL:real;
    sFE,sFEdet,
    cliDIR,rSOCIAL,sImporte,sIGV,
    FEmodo,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,
    txtCOD_TIPO_MOTIVO,txtDESCRIPCION_MOTIVO,
    txtTIPO_COMPROBANTE_MODIFICA,txtNRO_DOCUMENTO_MODIFICA,
    txtNRO_COMPROBANTE,txtCOD_TIPO_DOCUMENTO,
    txtNRO_DOCUMENTO_CLIENTE,xRUC,IDDOC,SERIE,NRO,resCPEenviado,s,
    VTAIDDOC,VTAFECHA,
    cpeRUC,cpeRSocialTienda,cpeDomicilio
    :String;
    IGV:Real;

begin
try
log('<pXMLPDFdownGet('+docVta+')');
stCad:=TStringList.Create;
FEmodo:='1'; //Produccion
c:=splitCar(docVta,'-'); // 20559678491-01-F021-98
xRUC:=pT[1];
txtCOD_TIPO_DOCUMENTO:=pT[2];
txtNRO_COMPROBANTE:=pT[3]+'-'+pT[4];

if      txtCOD_TIPO_DOCUMENTO='01' then IDDOC:='11'
else if txtCOD_TIPO_DOCUMENTO='03' then IDDOC:='10'
else if txtCOD_TIPO_DOCUMENTO='07' then IDDOC:='63'
else DatabaseError('Error IDDOC('+txtCOD_TIPO_DOCUMENTO+') no identificado');

//if copy(pT[3],1,1)='F' then IDDOCUMENTO:=DOCFACVTA else IDDOCUMENTO:=DOCBOLVTA;
SERIE:=IntToStr(StrToInt(copy(pT[3],2,3)));
NRO:=trim(pT[4]);
igv:=rQFloat('select VALOR from CNFPARAM where ID=''IGV''');
bIq('select * from VENTA,CLIENTE where IDCLIENTE=CLIENTE.ID and IDDOCUMENTO='+IDDOC+' and SERIE='+SERIE+' and NRO='+NRO);
VTAIDDOC:=lPad(trim(qsI('VTAIDDOC')),'0',2);
VTAFECHA:=IbFechaGuion(iq.FieldByName('FECHA').AsDateTime);

{$If Defined(BDshared)}
if bQ('select RUC,RSOCIAL,DOMIC from CAJATERMINAL,EMP where RUC=EMP.ID and CAJATERMINAL.ID='+qsI('IDCJATRM'))=0 then
   DatabaseError('<pGenXMLfromVentaUno: RUC no ubicado en CAJATERMINAL');
cpeRUC:=            qs('RUC');
cpeRSocialTienda:=  qs('RSOCIAL');
cpeDomicilio:=      qs('DOMIC');
{$Else}
cpeRUC:=            RUC;
cpeRSocialTienda:=  rSocialTienda;
cpeDomicilio:=      Domicilio;
{$IfEnd}

n:=0;
while not iq.eof do
  begin
        txtNRO_DOCUMENTO_CLIENTE:=Trim(qsI('DI'));
        //rSOCIAL:=(qsI('RAZONSOCIAL'));
        //cliDIR:=(qsI('DIRECCION'));
        rSOCIAL:=StringReplace(qsI('RAZONSOCIAL'),'&',' ',[rfReplaceAll, rfIgnoreCase]);
        rSOCIAL:=StringReplace(rSOCIAL,'"','¨',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(qsI('DIRECCION'),  '&',' ',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  '"','¨',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  'Ñ','N',[rfReplaceAll, rfIgnoreCase]);
        cliDIR:= StringReplace(cliDIR,  '?',' ',[rfReplaceAll, rfIgnoreCase]);
        sFEdet:='';
        aPagar:=0;tIGV:=0;inafecta:=0;
        bQ('select * from VVENTADET where VTASERIE='+qsI('SERIE')+' and VTANRO='+qsI('NRO')+' and IDDOCUMENTO='+qsI('IDDOCUMENTO'));
        i:=0;
        while not q.eof do
          begin inc(i);
                aPagar:=aPagar+q.FieldByName('IMPORTE').AsFloat;
                tIGV:=tIGV+q.FieldByName('IMPORTE').AsFloat*(igv/100.0);
                if i>1 then sFEdet:=sFEdet+',';
                sImporte:=Format('%.2f',[qf('IMPORTE')]);
                sIGV:=Format('%.2f',[qf('IMPORTE')*(igv/100.0)]);
                sFEdet:=sFEdet
                             +'{"txtITEM":"'+IntToStr(i)
                             +'","txtUNIDAD_MEDIDA_DET":"NIU","txtCANTIDAD_DET":"'+qTrim('CANTIDAD')
                             +'","txtPRECIO_DET":"'+Format('%.2f',[StrToFloat(sImporte)-StrToFloat(sIGV)])
                             +'","txtIMPORTE_DET":"'+sImporte
                             +'","txtPRECIO_TIPO_CODIGO":"01'
                             +'","txtIGV":"'+sIGV
                             +'","txtISC":"0","txtCOD_TIPO_OPERACION":"10","txtCODIGO_DET":"'+qTrim('IDPRODUCTO')
                             +'","txtDESCRIPCION_DET":"'
                             +StringReplace(qTrim('DESCRIPCION'),'"','¨',[rfReplaceAll, rfIgnoreCase])
                             +'"}';
                q.Next;
          end;
        totalVta:=aPagar-tIGV;

        TIGVdeducido:=(aPagar)-(aPagar)/(1.0+igv/100.0);
        SUBTOTAL:=aPagar-TIGVdeducido;
        txtSUB_TOTAL:=format('%.2f',[SUBTOTAL]);
        txtTOTAL:=format('%.2f',[aPagar]);
        txtTOTAL_IGV:=format('%.2f',[StrToFloat(txtTOTAL)-StrToFloat(txtSUB_TOTAL)]);
        sFE:=format('{"txtTOTAL_GRAVADAS":"%s","txtSUB_TOTAL":"%s","txtTOTAL_IGV":"%s","txtTOTAL":"%s","txtTOTAL_LETRAS":"%s"',
                    [txtSUB_TOTAL,txtSUB_TOTAL,txtTOTAL_IGV,txtTOTAL,solesAletras(aPagar)]
                   );
        //idVtaCliDocTipo:=qsI('IDDOCUMENTO');
        txtTIPO_COMPROBANTE_MODIFICA:='';txtNRO_DOCUMENTO_MODIFICA:='';
        txtCOD_TIPO_MOTIVO:='';txtDESCRIPCION_MOTIVO:='';
        //if      idVtaCliDocTipo=DOCFACVTA    then
        //        begin txtCOD_TIPO_DOCUMENTO:='01';
        //        end
        //else if idVtaCliDocTipo=DOCBOLVTA    then
        //        begin txtCOD_TIPO_DOCUMENTO:='03';
        //        end
        //else
        if IDDOC=DOCNTCREDVTA then
                begin
                      if      VTAIDDOC=DOCFACVTA then
                         begin txtTIPO_COMPROBANTE_MODIFICA:='01';
                               txtNRO_DOCUMENTO_MODIFICA:='F'+lPad(trim(qsI('VTASERIE')),'0',3)+'-'+trim(qsI('VTANRO'));
                         end
                      else if VTAIDDOC=DOCBOLVTA then
                         begin txtTIPO_COMPROBANTE_MODIFICA:='03';
                               txtNRO_DOCUMENTO_MODIFICA:='B'+lPad(trim(qsI('VTASERIE')),'0',3)+'-'+trim(qsI('VTANRO'));
                         end
                      else DatabaseError('Documento interno qsI(VTAIDDOC) '+VTAIDDOC+' no definido');
                      txtCOD_TIPO_MOTIVO:='01';txtDESCRIPCION_MOTIVO:='ANULACION DE LA OPERACION';
                end;

        //txtNRO_COMPROBANTE:=iif(IDDOC=DOCFACVTA,'F','B')+lPad(trim(qsI('SERIE')),'0',3)+'-'+trim(qsI('NRO'));
        sFE:=sFE
            +',"txtNRO_COMPROBANTE":"'           +txtNRO_COMPROBANTE+'"'
            +',"txtFECHA_DOCUMENTO":"'           +VTAFECHA{IbFechaGuion(now)}+'"'
            +',"txtCOD_TIPO_DOCUMENTO":"'        +txtCOD_TIPO_DOCUMENTO+'"'
            +',"txtCOD_MONEDA":"PEN"'
            +',"txtTIPO_COMPROBANTE_MODIFICA":"' +txtTIPO_COMPROBANTE_MODIFICA+'"'
            +',"txtNRO_DOCUMENTO_MODIFICA":"'    +txtNRO_DOCUMENTO_MODIFICA+'"'
            +',"txtCOD_TIPO_MOTIVO":"'           +txtCOD_TIPO_MOTIVO+'"'
            +',"txtDESCRIPCION_MOTIVO":"'        +txtDESCRIPCION_MOTIVO+'"'
            +',"txtNRO_DOCUMENTO_CLIENTE":"'     +txtNRO_DOCUMENTO_CLIENTE+'"'
            +',"txtRAZON_SOCIAL_CLIENTE":"'      +rSOCIAL+'"'
            +',"txtTIPO_DOCUMENTO_CLIENTE":"'    +iif(Length(txtNRO_DOCUMENTO_CLIENTE)=11,'6','1')+'"'
            +',"txtDIRECCION_CLIENTE":"'         +cliDIR+'"'
            +',"txtCIUDAD_CLIENTE":"TRUJILLO","txtCOD_PAIS_CLIENTE":"PE","txtNRO_DOCUMENTO_EMPRESA":"'
            +cpeRUC+'"'
            +',"txtTIPO_DOCUMENTO_EMPRESA":"6","txtNOMBRE_COMERCIAL_EMPRESA":"'
            +cpeRSocialTienda
            +'","txtCODIGO_UBIGEO_EMPRESA":"130101","txtDIRECCION_EMPRESA":"'
            +cpeDomicilio
            +'","txtDEPARTAMENTO_EMPRESA":"LA LIBERTAD","txtPROVINCIA_EMPRESA":"TRUJILLO","txtDISTRITO_EMPRESA":"TRUJILLO","txtCODIGO_PAIS_EMPRESA":"PE","txtRAZON_SOCIAL_EMPRESA":"'
            +cpeRSocialTienda
            +'"'
            +',"txtUSUARIO_SOL_EMPRESA":"'+usTiendaSOL+'","txtPASS_SOL_EMPRESA":"'+psTiendaSOL+'","psFirma":"'+psFirma+'"';
        sFE:=sFE
            +',"txtTIPO_PROCESO":"'+FEmodo+'"'
            +',"detalle":['+sFEdet+']'
            +',"datosGenerales":[{'
            + '"IDCAJAT":""'
            +',"VENDEDOR":""'
            +',"CAJERO":""'
            +'}]'
            +'}'
            ;
        stCad.Text:=StringReplace(sFE,chr(13)+chr(10),' ',[rfReplaceAll, rfIgnoreCase]);
        stCad.SaveToFile('D:/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/'+docVta+'.js');
        s:='D:/ultranet/xampp/php/php.exe D:/ultranet/xampp/htdocs/fe/controller/controller_cpeFromArchFromLazarusDaeFe.php '
          +docVta+'.js'
          ;
        pCmdLinea(s,       'D:/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docVta+'.js.txt');
        stCad.LoadFromFile('D:/ultranet/xampp/cgi-bin/'+sisOrg+'/fe/json/mensajes/'+docVta+'.js.txt');

        log('Resultado de pCmdLinea:'+stCad.Text);
        iq.Next;
        inc(n);
  end;
//WriteLn('Ok|XML generados para enviar a SUNAT: '+IntToStr(n));
//s:=StringReplace(stCad.Text,':_:_:','ñ',[rfReplaceAll, rfIgnoreCase]);
//DatabaseError('nO ES ERROR');
log(stCad.Text);
s:=trim(stCad.Text);//Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="  (hash de ida)
splitCar(s,'"');
log('pT[1]'+pT[1]+'|');
//if pT[1]='Ok'
//   then  begin xQ('update VENTA set HASH_CDR='''+pT[2]+''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC);
//               resCPEenviado:=pCPEnviaUno(docVta)+'"';
//               splitCar(resCPEenviado,'"');
//               if pT[1]='1'
//                  then begin if trim(rQ('select FENVIO from VENTA where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC))
//                                =''
//                                then xQ('update VENTA set COD_SUNAT='''
//                                       +StringReplace(pT[2],'''','´',[rfReplaceAll, rfIgnoreCase])
//                                       +''',MSJ_SUNAT='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
//                                       +iif(pT[2]='?','',''',CON_CDR=''S') //Sunat no devolvio Zip de respuesta
//                                       +''',MSJ_DEVUELTO='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
//                                       +''',FENVIO=current_date,HENVIO=current_time,USENVIO='+IDUSLOGUEO
//                                       +' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC)
//                                else xQ('update VENTA set COD_SUNAT='''
//                                       +StringReplace(pT[2],'''','´',[rfReplaceAll, rfIgnoreCase])
//                                       +''',MSJ_SUNAT='''+StringReplace(pT[3],'''','´',[rfReplaceAll, rfIgnoreCase])
//                                       +''' where SERIE='+SERIE+' and NRO='+NRO+' and IDDOCUMENTO='+IDDOC);
//                             s:=s+pT[2]+'"'+pT[3]+'"';
//                             //Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="0000"...aceptada u otro..."
//
//                       end
//                  else s:=s+'Error"'+resCPEenviado+'"';
//                       //Ok"vR+VAtLJMzQEbWvMqz0oWlcyRCk="Error"...mensaje de error..."
//                       //0          1                      2         3
//               tr.CommitRetaining;
//         end
//   else DatabaseError(s);
except on e: Exception do begin log(e.Message); s:='Error"'+e.Message; end
end;
w(s);
//pXMLPDFdownGet>
end;

BEGIN //main()
//iniciar;
//log('antes de Inicializa:'+sisActual);
logACTIVO:=False;
sTmp:=Inicializa;
log('SCRIPT_FILENAME :'+GetEnv('SCRIPT_FILENAME'));
splitCar(sTmp,'|');
if pT[1]='Error' then
   begin GenVm('Error',pT[2]);
         w(devHTML('index.html'));
         if bd.Transaction.Active then bd.Close;
         halt;
   end;
op:=StrToInt(pT[1]);
//OP:=Inicializa;
log('op despues de sesionar:'+IntToStr(OP));
if OP = -1 then begin {if bd.Transaction.Active then bd.Close;} pHtmlShow('index.html'); exit; end;
log('op(Enviado):'+IntToStr(op));
case OP of


    //FE
    opXMLPDFdownM:         pXMLPDFdownM(devStr('xvar'));
    //opFEGenXMLsinFirma:    pFEGenXMLsinFirma(devStr('xvar'));
  else w(opcionIncorrecta(''));
end;
if bd.Transaction.Active then bd.Close;
END.

