function esEntero(cad:String):boolean;
var i,iValue, iCode: Integer; begin val(cad, i, iCode); if iCode = 0 then result:=true else Result:=false;
                            end;
function esNro(s:String):Boolean;
var i,L:Integer;
begin
L:=Length(s); if L=0 then begin result:=false; exit; end;
for i:=1 to L do if (s[i]<'0') or (s[i]>'9') then
                    begin result:=False; exit;
                    end;
result:=true;
end;

function gramat(cad:String;tipo:SmallInt):String;
begin case tipo of
      0: gramat:=UpperCase(LeftStr(cad,1))+LowerCase(RightStr(cad,length(cad)-1));
      1: gramat:=LowerCase(cad);
      2: gramat:=UpperCase(cad);
      else gramat:=cad;
      end;
end;

function NumLetraDecimal(valor:Real):String;
var xTotal,xEntero,xDecimal:string;
begin
xTotal:='0'+FloatToStr(valor);
if pos('.',xTotal)>0
   then begin xEntero:=LeftStr(xTotal,pos('.',xTotal)-1);
              xDecimal:=LeftStr(RightStr(xTotal,length(xTotal)-pos('.',xTotal))+'0',2);
        end
   else begin xEntero:=xTotal;
              xDecimal:='00';
   end;
Result:=xDecimal;
end;

function NumLetra(const mNum: Currency; const iIdioma, iModo: Smallint): String;
const
  iTopFil: Smallint = 6;
  iTopCol: Smallint = 10;
  aCastellano: array[0..5, 0..9] of PChar =
  ( ('UNA ','DOS ','TRES ','CUATRO ','CINCO ',
    'SEIS ','SIETE ','OCHO ','NUEVE ','UN '),
    ('ONCE ','DOCE ','TRECE ','CATORCE ','QUINCE ',
    'DIECISEIS ','DIECISIETE ','DIECIOCHO ','DIECINUEVE ',''),
    ('DIEZ ','VEINTE ','TREINTA ','CUARENTA ','CINCUENTA ',
    'SESENTA ','SETENTA ','OCHENTA ','NOVENTA ','VEINTI'),
    ('CIEN ','DOSCIENTAS ','TRESCIENTAS ','CUATROCIENTAS ','QUINIENTAS ',
    'SEISCIENTAS ','SETECIENTAS ','OCHOCIENTAS ','NOVECIENTAS ','CIENTO '),
    ('CIEN ','DOSCIENTOS ','TRESCIENTOS ','CUATROCIENTOS ','QUINIENTOS ',
    'SEISCIENTOS ','SETECIENTOS ','OCHOCIENTOS ','NOVECIENTOS ','CIENTO '),
    ('MIL ','MILLON ','MILLONES ','CERO ','Y ',
    'UNO ','DOS ','CON ','','') );
  aCatalan: array[0..5, 0..9] of PChar =
  ( ( 'UNA ','DUES ','TRES ','QUATRE ','CINC ',
    'SIS ','SET ','VUIT ','NOU ','UN '),
    ( 'ONZE ','DOTZE ','TRETZE ','CATORZE ','QUINZE ',
    'SETZE ','DISSET ','DIVUIT ','DINOU ',''),
    ( 'DEU ','VINT ','TRENTA ','QUARANTA ','CINQUANTA ',
    'SEIXANTA ','SETANTA ','VUITANTA ','NORANTA ','VINT-I-'),
    ( 'CENT ','DOS-CENTES ','TRES-CENTES ','QUATRE-CENTES ','CINC-CENTES ',
    'SIS-CENTES ','SET-CENTES ','VUIT-CENTES ','NOU-CENTES ','CENT '),
    ( 'CENT ','DOS-CENTS ','TRES-CENTS ','QUATRE-CENTS ','CINC-CENTS ',
    'SIS-CENTS ','SET-CENTS ','VUIT-CENTS ','NOU-CENTS ','CENT '),
    ( 'MIL ','MILIO ','MILIONS ','ZERO ','-',
    'UN ','DOS ','AMB ','','') );
var
  aTexto: array[0..5, 0..9] of PChar;
  cTexto, cNumero: String;
  iCentimos, iPos: Smallint;
  bHayCentimos, bHaySigni: Boolean;

  (* Cargar Textos según Idioma / Modo *)
  procedure NumLetra_CarTxt;
  var i, j: Smallint;
  begin (* Asignación según Idioma *)
    for i := 0 to iTopFil - 1 do
      for j := 0 to iTopCol - 1 do
        case iIdioma of
          1: aTexto[i, j] := aCastellano[i, j];
          2: aTexto[i, j] := aCatalan[i, j];
        else aTexto[i, j] := aCastellano[i, j];
        end;

    (* Asignación si Modo Masculino *)
    if (iModo = 1) then
        begin for j := 0 to 1 do
                aTexto[0, j] := aTexto[5, j + 5];
              for j := 0 to 9 do
                aTexto[3, j] := aTexto[4, j];
        end;
  end;

  (* Traducir Dígito -Unidad- *)
  procedure NumLetra_Unidad;
  begin
    if not( (cNumero[iPos] = '0') or (cNumero[iPos - 1] = '1')
       or ((Copy(cNumero, iPos - 2, 3) = '001') and ((iPos = 3) or (iPos = 9))) ) then
          if (cNumero[iPos] = '1') and (iPos <= 6)
              then cTexto := cTexto + aTexto[0, 9]
              else cTexto := cTexto + aTexto[0, StrToInt(cNumero[iPos]) - 1];
    if ((iPos = 3) or (iPos = 9)) and (Copy(cNumero, iPos - 2, 3) <> '000') then cTexto := cTexto + aTexto[5, 0];
    if (iPos = 6) then
        if (Copy(cNumero, 1, 6) = '000001')
           then cTexto := cTexto + aTexto[5, 1]
           else cTexto := cTexto + aTexto[5, 2];
  end;

  (* Traducir Dígito -Decena- *)
  procedure NumLetra_Decena;
  begin if (cNumero[iPos] = '0') then Exit
        else if (cNumero[iPos + 1] = '0') then cTexto := cTexto + aTexto[2, StrToInt(cNumero[iPos]) - 1]
        else if (cNumero[iPos] = '1') then cTexto := cTexto + aTexto[1, StrToInt(cNumero[iPos + 1]) - 1]
        else if (cNumero[iPos] = '2') then cTexto := cTexto + aTexto[2, 9]
        else cTexto := cTexto + aTexto[2, StrToInt(cNumero[iPos]) - 1]+ aTexto[5, 4];
  end;

  (* Traducir Dígito -Centena- *)
  procedure NumLetra_Centena;
  var iPos2: Smallint;
  begin if (cNumero[iPos] = '0') then Exit;
        iPos2 := 4 - Ord(iPos > 6);
        if (cNumero[iPos] = '1') and (Copy(cNumero, iPos + 1, 2) <> '00')
           then cTexto := cTexto + aTexto[iPos2, 9]
           else cTexto := cTexto + aTexto[iPos2, StrToInt(cNumero[iPos]) - 1];
  end;

  (* Eliminar Blancos previos a guiones *)
  procedure NumLetra_BorBla;
  var i: Smallint;
  begin i := Pos(' -', cTexto);
        while (i > 0) do
          begin Delete(cTexto, i, 1);
                i := Pos(' -', cTexto);
          end;
  end;

begin
  (* Control de Argumentos *)
  if (mNum < 0.00) or (mNum > 999999999999.99) or (iIdioma < 1) or (iIdioma > 2) or (iModo < 1) or (iModo > 2) then
        begin Result := 'ERROR EN ARGUMENTOS';
              Abort;
        end;

  (* Cargar Textos según Idioma / Modo *)
  NumLetra_CarTxt;

  (* Bucle Exterior -Tratamiento Céntimos-     *)
  (* NOTA: Se redondea a dos dígitos decimales *)
  cNumero := Trim(Format('%12.0f', [Int(mNum)]));
  cNumero := StringOfChar('0', 12 - Length(cNumero)) + cNumero;
  iCentimos := Trunc((Frac(mNum) * 100) + 0.5);

  repeat
    (* Detectar existencia de Céntimos *)
    if (iCentimos <> 0)
       then bHayCentimos := True
       else bHayCentimos := False;

    (* Bucle Interior -Traducción- *)
    bHaySigni := False;
    for iPos := 1 to 12 do
    begin
      (* Control existencia Dígito significativo *)
      if not(bHaySigni) and (cNumero[iPos] = '0')
         then Continue
         else bHaySigni := True;

      (* Detectar Tipo de Dígito *)
      case ((iPos - 1) mod 3) of
        0: NumLetra_Centena;
        1: NumLetra_Decena;
        2: NumLetra_Unidad;
      end;
    end;

    (* Detectar caso 0 *)
    if (cTexto = '') then cTexto := aTexto[5, 3];

    (* Traducir Céntimos -si procede- *)
    if (iCentimos <> 0) then
    begin cTexto := cTexto + aTexto[5, 7];
          cNumero := Trim(Format('%.12d', [iCentimos]));
          iCentimos := 0;
    end;
  until not (bHayCentimos);
  if (iIdioma = 2) then NumLetra_BorBla; (* Eliminar Blancos innecesarios -sólo Catalán- *)
  Result := Trim(cTexto);  (* Retornar Resultado *)
end;
procedure log(cad:string);
var F: TextFile;
begin if not logACTIVO then exit;
      AssignFile(F, ArchLOG);
      Append(F);
      WriteLn(F, cad);
      CloseFile(F);
end;

function bQ(xvar: string):integer;
begin q.Close; q.SQL.Text:=xvar; log(xvar); q.Open; Result:=q.RecordCount;
end;

function bQ1(xvar: string):integer;
begin q1.Close; q1.SQL.Text:=xvar; log('BQ1:'+xvar); q1.Open; Result:=q1.RecordCount;
end;

function bIq(xvar: string):integer;
begin iq.Close; iq.SQL.Text:=xvar; log(xvar);
      iq.Open; Result:=iq.RecordCount;
end;

function rQ(xvar: string): string;
begin q.Close; q.SQL.Text:=xvar; log(xvar);
      q.Open; Result:=q.Fields[0].AsString;
end;
function rIQ(xvar: string): string;
begin iq.Close; iq.SQL.Text:=xvar; log(xvar);
      iq.Open; Result:=iq.Fields[0].AsString;
end;

  function rQInt(xvar: string): integer;
  begin q.Close; q.SQL.Text:=xvar;log(xvar);
        q.Open; Result:=q.Fields[0].AsInteger;
  end;

procedure xQ(xvar: string);
begin q.Close; q.SQL.Text:=xvar; log(xvar); q.ExecSQL;
end;

function splitCar(cad, car: string): integer;
var c, L, i: integer;
begin
IF length(cad)=0 THEN BEGIN result:=0; exit; END;
CAD:=CAD+CAR;
L:=length(cad);
c:=0;
pTab[0]:=0;
for i:=1 to L do
   if cad[i]=car then
      begin c:=c+1;
            pTab[c]:=i;
      end;
if c > 0 then
   begin for i:=1 to c do
           if pTab[i] - pTab[i - 1] > 1
              then pText[i]:=copy(cad, pTab[i - 1]+1, pTab[i] - pTab[i - 1] - 1)
              else pText[i]:='';
   end;
Result:=c;
end;

function splTrim(cad, car: string): integer;
var c, L, i: integer;
begin
  CAD:=CAD+CAR; L:=length(cad); c:=0;
  pTabTrim[0]:=0;
  for i:=1 to L do
    if cad[i] = car then  begin c:=c+1;
                                pTabTrim[c]:=i;
                          end;
  if c > 0 then begin for i:=1 to c do
                        if pTabTrim[i] - pTabTrim[i - 1] > 1
                           then pTextTrim[i]:=trim(copy(cad, pTabTrim[i - 1]+1, pTabTrim[i] - pTabTrim[i - 1] - 1))
                           else pTextTrim[i]:='';
                end;
  Result:=c;
end;

function uPos(xCad, xCar: string): integer;
var i: integer;
begin
  Result:=0;
  for i:=1 to length(xCad) do
    if xCad[i] = xCar then
    begin Result:=i;
          exit;
    end;
end;

function ReverseString(s: string): string;
var i: integer; s2: string;
begin s2:='';
      for i:=1 to Length(s) do s2:=s[i]+s2;
      Result:=s2;
end;

function devStr(xCad: string): string;
var i, p: integer;
begin tPost:=splitCar(a, '&');
      Result:='';
      for i:=1 to tPost do
        begin p:=uPos(UpperCase(pText[i]), '=');
              if (p > 0) and (UpperCase(LeftStr(pText[i], p - 1)) = UpperCase(xCad)) then
                  begin Result:=RightStr(pText[i], length(pText[i]) - p);
                        exit;
                  end;
        end;
end;

function devInt(xCad: string): integer;
begin Result:=StrToInt(Trim(devStr(xCad)));
end;

function devTrim(xCad: string): string;
begin Result:=Trim(devStr(xCad));
end;

procedure w(cad: string);
begin if printSI then
         if SALTOLINEA
            then writeln(cad)
            else Write(cad);
end;

function devStrP(var cadFuente: string; cadBusca, separa, igualdad: string): string;
var i, p: integer;
begin tPost:=splitCar(cadFuente, separa);
      Result:='';
      for i:=1 to tPost do
      begin p:=uPos(UpperCase(pText[i]), igualdad);
            if (p > 0) and (UpperCase(LeftStr(pText[i], p - 1)) = UpperCase(cadBusca)) then
                begin Result:=RightStr(pText[i], length(pText[i]) - p);
                      exit;
                end;
      end;
end;

function deCripta(x: string): string;
var y, s: string;
    sw, L, i: smallint;
begin
  //result:=x; exit;
  y:=x;
  s:='';
  sw:=(-10);
  L:=length(y);
  for i:=1 to L do
  begin s:=s+chr(Ord(y[i])+sw);
        sw:=-sw;
  end;
  Result:=s;
end;

function cripta(x: string): string;
var y, s: string;
    sw, L, i: smallint;
begin
  //result:=x; exit;
  y:=x;
  s:='';
  sw:=(10);
  L:=length(y);
  for i:=1 to L do
  begin s:=s+chr(Ord(y[i])+sw);
        sw:=-sw;
  end;
  Result:=s;
end;


function btBdConectaClick(xUsuario,xPassword: string): boolean;
begin
  Result:=False;
  bd:=TIBConnection.Create(nil);
  tr:=TSQLTransaction.Create(nil);
  iq:=TSqlQuery.Create(nil);     q:=TSqlQuery.Create(nil); q1:=TSqlQuery.Create(nil);  qRol:=TSqlQuery.Create(nil);
  dsPersonal:=TDataSource.Create(nil);
  bd.Connected:=False; tr.Active:=False;
  bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:='sysdba';  bd.Password:='masterke';
//  bd.HostName:=host; bd.DatabaseName:=pathBD; bd.UserName:=xUsuario;  bd.Password:=xPassword;
  bd.Dialect:=3;
  bd.CharSet:='UTF8';
  bd.LoginPrompt:=False;
  tr.DataBase:=bd;
  try bd.Connected:=True;
      tr.Active:=True;
      iq.Transaction:=tr;    iq.DataBase:=bd;
      q.Transaction:=tr;     q.DataBase:=bd;
      q1.Transaction:=tr;    q1.DataBase:=bd;
      qRol.Transaction:=tr;  qRol.DataBase:=bd;
      qRol.DataSource:=dsPersonal;
      Result:=True;
      //q.SQL.Text:=xvar; log(xvar); q.Open;
      bQ('select first 1 ID from PERSO where CORREO='''+usLogueo+''' and SENA='''+passLogueo+'''');
      if q.RecordCount=0
         then begin Result:=False;
                    log('Usuario o contraseña incorrectos.');
              end
         else begin log('try ok Bd Conecta');
                    usIdPerso:=q.Fields[0].AsString;
              end;
  except on e: Exception do
      begin Result:=False;
            log('Error en conexión a base de datos. '+e.Message);
      end;
  end;
end;

procedure LeeYEnvia(archivo, ini, fin: string);
var F:Textfile; linea:ansistring; sw:boolean;
begin
AssignFile(F, pathHTTP+archivo); Reset(F);
sw:=False;
while not EOF(F) do
  begin ReadLn(F, linea);
        if ini = LeftStr(linea, Length(ini)) then sw:=True;
        if fin = LeftStr(linea, Length(fin)) then sw:=False;
        if sw then w(Linea);
  end;
CloseFile(F);
end;

procedure ArchEnvia(archivo:string);
var F:Textfile; linea:ansistring;
begin
AssignFile(F, pathHTTP+archivo);Reset(F);
while not EOF(F) do
  begin ReadLn(F,linea);
        w(linea);
  end;
CloseFile(F);
end;

procedure loguearse;
begin
log('Loguearse');
LeeYEnvia('index.html', '<!DOCTYPE', '<!--|body|-->');
LeeYEnvia('index.html', '<!--|body|-->', '<!--|finLogin|-->');
LeeYEnvia('index.html', '<!--|finLogin|-->', '<!--|fin|-->');
end;

function fechaInt(Fecha:TDate):Integer;
begin result:=DayOf(Fecha)+MonthOf(Fecha)*30+YearOf(Fecha)*30*12;
log(IntToStr(DayOf(Fecha)+MonthOf(Fecha)*30+YearOf(Fecha)*30*12));
end;

function ProgVencido:boolean;
var dd,mm,yy,intHoy:Integer;
begin
result:=false;
intHoy:=fechaInt(now);
if (intHoy<fechaInt(StrToDate('01/10/2012')))
//     or(intHoy>fechaInt(StrToDate('10/05/2013'))) then result:=true;      //10/05/2013
or(intHoy>fechaInt(StrToDate(deCripta(';&9&?%<&;*')))) then result:=true;      //10/05/2014
end;

function charHumaniza(cad:string):string;
var p,L,i,tvRemp:integer;
    s,r,sHex:string;
    sC:array[1..250] of string;
begin
sHex:='%F1%D1%E1%E9%ED%F3%FA%C1%C9%CD%D3%DA%40%2F%28%29%5B%5D%7B%7D%BF%2B%2C%3B%3C%3E%21%22%23%24%25%26%2F%28%29%3D%3F%A1%7C%27';
i:=0;
inc(i);sC[i]:='ñ';
inc(i);sC[i]:='Ñ';
inc(i);sC[i]:='á';
inc(i);sC[i]:='é';
inc(i);sC[i]:='í';
inc(i);sC[i]:='ó';
inc(i);sC[i]:='ú';
inc(i);sC[i]:='Á';
inc(i);sC[i]:='É';
inc(i);sC[i]:='Í';
inc(i);sC[i]:='Ó';
inc(i);sC[i]:='Ú';
inc(i);sC[i]:='@';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='[';
inc(i);sC[i]:=']';
inc(i);sC[i]:='{';
inc(i);sC[i]:='}';
inc(i);sC[i]:='¿';
inc(i);sC[i]:='+';
inc(i);sC[i]:=',';
inc(i);sC[i]:=';';
inc(i);sC[i]:='<';
inc(i);sC[i]:='>';
inc(i);sC[i]:='!';
inc(i);sC[i]:='"';
inc(i);sC[i]:='#';
inc(i);sC[i]:='$';
inc(i);sC[i]:='%';
inc(i);sC[i]:='&';
inc(i);sC[i]:='/';
inc(i);sC[i]:='(';
inc(i);sC[i]:=')';
inc(i);sC[i]:='=';
inc(i);sC[i]:='?';
inc(i);sC[i]:='¡';
inc(i);sC[i]:='|';
inc(i);sC[i]:='''';
s:=trim(cad);
L:=length(s);
i:=0;r:='';
while i<L do
  begin inc(i);
        if s[i]='+' then r:=r+' '
        else if s[i]='%' then
                begin p:=pos(s[i]+s[i+1]+s[i+2],sHex);
                      if p>0 then begin r:=r+sC[(p+2) div 3];
                                        i:=i+2;
                                  end;
                end
             else r:=r+s[i];
  end;
result:=r;
end;

function pSesion:SmallInt;
begin
try
log('<pSesion');
s:='';
sesionadoSI:=False;
reqCk:=GetEnv('HTTP_COOKIE');
reqCkValue:=RightStr(reqCk, Length(reqCk) - pos('=', reqCk));
log('cockie leido al natural: |'+reqCk+'|');
ck:=ReverseString(reqCkValue);
ck:=charHumaniza(ck);
s:=s+('Cockie revertido y humanizado='+ck+'<br>');
a:='';
a:=GetEnv('QUERY_STRING');
if a = '' then  begin a:='';
                      while not EOF(input) do
                      begin Read(c);
                            a:=a+c;
                      end;
                end;
log(s);
log('Cadena natural recibida POST/GET |'+a+'|');
a:=charHumaniza(a);
log('Cadena humanizada POST/GET |'+a+'|');
//log('application.requestvariables'+application.requestvariables['file']);
sesionadoSI:=(devStrP(ck, 'sesionado', '&', ':') = 'si');
cuenta:=devStrP(ck, 'c', '&', ':');
s:=s+('Leido c='+cuenta+'<br>');
if cuenta = ''
   then cuenta:='0'
   else cuenta:=IntToStr(StrToInt(cuenta)+1);
s:=s+('Nuevo c='+cuenta+'<br>');
//Cerrando sesión
if (devStr('edSal') = 'S') then
    begin a:='';
          sesionadoSI:=False;
    end;
log('pre1');
if (trim(devStr('op')) <> '')
   then OP:=devInt('op')
   else if trim(devStrP(ck, 'op', '&', ':')) = ''
           then OP:=-1
           else OP:=StrToInt(trim(devStrP(ck, 'op', '&', ':')));
log('Entrando Cockie:op='+devStrP(ck, 'op', '&', ':')+'|us='+devStrP(ck, 'us', '&', ':')+'|sena='+devStrP(ck, 'sena', '&', ':')+'|sesionado='+devStrP(ck, 'sesionado', '&', ':'));
log('Entrando Data:  op='+devStr('op')+'|us='+devStr('us')+'|sena='+devStr('sena'));
ckParOtros:='; path=/; expires= Mon, 21-Mar-2014  18:37:00 GMT';
if sesionadoSI
   then   begin
            log('sesionadoSI then');
            usLogueo:=devStrP(ck, 'us', '&', ':');
            passLogueo:=devStrP(ck, 'sena', '&', ':');//opCockie:=devStrP(ck,'op','&',':');
            if btBdConectaClick(usLogueo, passLogueo)
             then begin outCk:='&{}|..|{a}}sdas&sesionado:si&us:'+usLogueo+'&sena:'+passLogueo+'&c:'+cuenta+'&op:'+IntToStr(OP);
                        log('asdsa');
                   //     writeln('Set-cookie:pollo='+ReverseString(outCk)+'; path=/; expires= Sat, 01-Dic-2012  18:37:00 GMT'); dura hasta q se cierre el navegador
                        writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);  //Dura hastas que se cierre sesio explícitamente
                        writeln('Content-Type:text/html', #10#13);
{
                        sCurANIO:=rQ('select first 1 cast(VALOR as smallint) from CNF where ID=''CURANIO''');
                        if ProgVencido then
                           begin log('Vencido'); op:=-1;
                                 q.Close;q.SQL.Text:='update PERSONAL set ACTIVO=null where ID=13';
                                 q.ExecSQL;tr.Commit;
                           end;
                        q.Close;q.SQL.Text:='select count(*) from PERSONAL where ID=13 and trim(ACTIVO)=''''';
                        q.Open;
                        if q.Fields[0].AsInteger=0 then halt;
}
                        log('Reabierto');
                  end
             else begin log('Sesionado si pero no abre BD: uslogueo='+usLogueo);
                        OP:=-1;
                  end;
          end
   else   begin
            log('sesionadoSI else');
            usLogueo:=devTrim('us');
            passLogueo:=devTrim('sena');//opCockie:=trim(devStr('op'));
            //IF(passLogueo='12345678') THEN HALT;
            if btBdConectaClick(usLogueo, passLogueo)
              then
                begin
                  log('sesionadoSI else btBdConectaClick then');
                  outCk:='&sesionado:si&us:'+usLogueo+'&sena:'+passLogueo+'&c:'+cuenta+'&op:'+IntToStr(OP);
                  writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                  writeln('Content-Type:text/html', #10#13);     {
                  sCurANIO:=rQ('select first 1 cast(VALOR as smallint) from CNF where ID=''CURANIO''');
                  if ProgVencido then
                     begin log('Vencido'); op:=-1;
                           q.Close;q.SQL.Text:='update PERSONAL set ACTIVO=null where ID=13';
                           q.ExecSQL;tr.Commit;
                     end;
                  q.Close;q.SQL.Text:='select count(*) from PERSONAL where ID=13 and trim(ACTIVO)=''''';
                  q.Open;
                  if q.Fields[0].AsInteger=0 then halt;
}
                  log('Abierto');
                  OP:=opLogin;
                end
              else
                begin
                  log('sesionadoSI else btBdConectaClick else');
                  outCk:='&sesionado:no&us:&sena:'+'&c:'+cuenta+'&op:';
                  writeln('Set-cookie:pollo='+ReverseString(outCk)+ckParOtros);
                  writeln('Content-Type:text/html', #10#13);
                  //log('Loguearse');
                  OP:=-1;
                end;
          end;
except
  on e: Exception do begin log('Excepción: pSesion: '+e.Message);
                           w('Exception en pSesión: '+e.Message);//Error u opción <br>incorrecta<a href="sfdsafds">Cerrar</a><br><a href="'+urlExe+'?op=5">Intentar restaurar</a>');
                           halt;
                     end
end;
log('pSesion(Result:'+IntToStr(OP)+')>');
result:=OP;
end;

function Inicializa:SmallInt;
var F:TextFile; linea:ansistring;c:Integer;
    valor:String;
begin
_Ini:='--'; _Fin:='--'; logACTIVO:=True; printSI:=True;
ShortDateFormat:='dd/mm/yyyy'; LongTimeFormat:='hh:mm'; DecimalSeparator:='.';
//if xSO=SOWINDOWS then splitCar(par);
pathCGI:=ExtractFilePath(ParamStr(0));
ArchLOG:=pathCGI +'log/log.txt';
//ArchGPS:=pathCGI +'gps/gps.txt';
AssignFile(F,pathCGI+'cnf.ini');
Reset(F);
log('estamos dentro');
while not EOF(F) do
  begin ReadLn(F, linea);
        c:=splitCar(linea,'=');
        if UpperCase('Param1')=trim(UpperCase(pText[1])) then begin urlExe:=      pText[2]+ExtractFileName(ParamStr(0));   // Url Ejecutable
                                                              end;
        if UpperCase('Param2')=trim(UpperCase(pText[1])) then urlImg:=            pText[2];    //  /tx/img/
        if UpperCase('Param3')=trim(UpperCase(pText[1])) then pathHTTP:=          pText[2];
        if UpperCase('Param4')=trim(UpperCase(pText[1])) then begin pathBD:=      pText[2]+'data.unet';
                                                                    sRutaEjeSlash:= pText[2];
                                                              end;
        if UpperCase('Param5')=trim(UpperCase(pText[1])) then host:=              pText[2];
        if UpperCase('Param6')=trim(UpperCase(pText[1])) then charSetBD:=         pText[2];
        if UpperCase('Param7')=trim(UpperCase(pText[1])) then sRutaBD:=           pText[2];
  end;
CloseFile(F);
AssignFile(fArch, ArchLOG); if FileExists(ArchLOG) then Append(fArch) else ReWrite(fArch);
WriteLn(fArch, '******************'+DateToStr(Now)+':'+TimeToStr(Now)+'******************');
CloseFile(fArch);
log('<Inicializa');
tvCampo:=0;
OP:=pSesion;
tPost:=splitCar(a,'&');
xMsg:='';
result:=OP;
log('Inicializa(Result:='+IntToStr(OP)+')>');
end;

function IbFecha(xFecha: TDate): string;        //31/1/1111 to '1111/1/31'
var Year, Month, Day: word;
begin DecodeDate(xFecha, Year, Month, Day);
      Result:=IntToStr(Year)+'/'+IntToStr(Month)+'/'+IntToStr(Day);
end;

function lPad(cadena, car: string; ancho: integer): string;
var i: integer;
begin
  while length(cadena) < ancho do
    cadena:=car+cadena;
  Result:=cadena;
end;

function iif(condicion: boolean; cad1, cad2: string): string;
begin if condicion
         then Result:=cad1
         else Result:=cad2;
end;

procedure crk;
var
  dd, mm, yy: integer;
  ddTope, mmTope, yyTope: integer;
  rr: TRect;
  cad, msgPirata, sd, s1, s2, s3, s4, s5, s6, s7: string;
begin
  s4:='),extract(year from ';
  sd:='current_date';
  s5:=') from CNF';
  s3:='),extract(month from ';
  s7:='select extractor(secure_crack) from noip.com_db';
  s2:='(day from ';
  s1:='select first 1 extract';
  cad:=s1+s2+sd+s3+sd+s4+sd+s5;
  log('sale'+cad);
  bQ(cad);
  log('post bq'+cad);
  dd:=q.Fields[0].AsInteger;
  mm:=q.Fields[1].AsInteger;
  yy:=q.Fields[2].AsInteger;

  bQ('select 100+cast(OBS2 as integer),ID,''201''||OBS1 from INF where OBS3=''1''');
  //select 100+cast(OBS2 as integer),ID,'201'||OBS1 from INF where OBS3='1'
  ddTope:=q.Fields[0].AsInteger;
  mmTope:=q.Fields[1].AsInteger;
  yyTope:=q.Fields[2].AsInteger;
  if (dd+mm * 30+yy * 30 * 12 > ddTope+mmTope * 30+yyTope * 30 * 12) then
  begin
    w('Vigencia caducada. Contactarse con programador');
    log('caduca');
    halt;
  end;
end;

function Lee(archivo:string;soloBody:boolean):string;
var F:Textfile;
    s,finLinea,linea:String;
    swBody:boolean;
    i:Integer;
begin
finLinea:=#13#10;
AssignFile(F,pathHTTP+archivo);
Reset(F);
swBody:=false;
s:='';
i:=0;
while not EOF(F) do
  begin ReadLn(F, linea);
        if not soloBody
           then s:=s+linea+finLinea
           else
                if swBody
                   then begin i:=pos('</BODY',uppercase(linea));
                              if i>0 then begin s:=s+LeftStr(linea,i-1)+finLinea;
                                                break;
                                           end;
                              for i:=1 to length(linea)do s:=s+linea[i];
                              s:=s+finLinea;
                        end
                   else begin i:=pos('<BODY',uppercase(linea));
                              if i>0 then
                                 begin while((linea[i+1]<>'>') and (not EOF(F)) and (i<length(linea))) do
                                          begin inc(i);
                                                //ReadLn(F, linea);
                                          end;
                                       s:=s+RightStr(linea,length(linea)-i-1)+finLinea;
                                       swBody:=true;
                                 end;
                         end;
  end;
CloseFile(F);
result:=s;
end;

function bCampo(valor:String;t:SmallInt):SmallInt;
var i:Integer;
begin
  for i:=1 to t do
    if UpperCase(vC[i].Id)=valor then
       begin //log(UpperCase(vC[i].Id)+'|'+valor);
             result:=i; exit;
       end;
  result:=-1;
end;

function dmyTOymd(sFechaDDMMYYYY:string):string;
begin Result:=IbFecha(StrToDate(sFechaDDMMYYYY));
end;

function valCad(cad:string):string;
var r:string;
begin
r:=devStr(cad);
if trim(r)='' then result:='null' else result:=''''+r+'''';
end;

function valorFecha(cad:string):string;
var r:string;
begin
r:=devStr(cad);
if trim(r)='' then result:='null' else result:=''''+dmyTOymd(devStr(cad))+'''';
end;

function boton(id, titu: string): string;
begin
Result:=UTF8Decode('<img id="im'+id+'" title="'+titu+'" src="' +urlImg+'bt'+id+'.png" onclick="p'+id
                  +'();"    style="cursor: pointer;"'+' onmouseover="document.getElementById(''im'
                  +id+''').src='''+urlImg+'bt'+id
                  +'Cur.png''" onmouseout="document.getElementById(''im'+id
                  +''').src='''+urlImg+'bt'+id+'.png''">'
                  );
end;

function tablaIdToIdx(tabla:String):Integer;
var i:Integer;
begin
for i:=1 to tvTabla do
    if tabla=vTabla[i].Id then
       begin result:=i;
             exit;
       end;
result:=0;
end;

function opcionIncorrecta(msg:String):String;
var s:String;
begin
log('<opcionIncorrecta: op='+IntToStr(OP));
s:=UTF8Decode('<div class=csMsgErr><br>Error.'+msg);
s:=s+'<center><table><tr><td><form name=fOp acction="'+urlExe+Ejecutable+'" method="post"><input type=hidden name=op value=-1><input type=submit value=Cerrar></form>';
s:=s+'<td><form name=fOp acction="'+urlExe+Ejecutable+'" method="post"><input type=hidden name=op value=5><input type=submit value="Reactivar"></form></table></center></div>';
result:=s;
end;

procedure setTabla(id,des,sql,img,sMaeDet,tColsVer:string);
var c:SmallInt;
begin
log('Entrando a setTabla(id,des,sql,img,sMaeDet,tColsVer)('+id+','+des+','+sql+','+img+','+sMaeDet+','+tColsVer+')');
inc(tvTabla); tvCampo:=0;
vTabla[tvTabla].Id:=id;     vTabla[tvTabla].Des:=des;
vTabla[tvTabla].Sql:=sql;   vTabla[tvTabla].Img:=img;
vTabla[tvTabla].tColsVer:=StrToInt(tColsVer);
if trim(sMaeDet)<>''
   then begin c:=splitCar(sMaeDet,':');
              if c=2 then
                 begin vTabla[tvTabla].fkMaeDet:= pText[1];
                       vTabla[tvTabla].iTMaestra:=tablaIdToIdx(pText[2]);
                 end
              else if c=0 then
                 begin vTabla[tvTabla].fkMaeDet:='';
                       vTabla[tvTabla].iTMaestra:=0;
                 end
              else begin w(opcionIncorrecta('Error en config MaeDet c='+IntToStr(c)));
                         halt;
                  end;
        end
   else begin vTabla[tvTabla].fkMaeDet:='';
              vTabla[tvTabla].iTMaestra:=0;
        end
end;
//Mante ini
procedure setCampo(id,pk,des,tipo,size,maxLen,req,conBoton,
                   gridVer,unoVer,sFORMFIELD,sFORMFIELDSQL,valida,sAutoNum,sReadOnly,onChange,sHidden,
                   sCol,sValorIni:string);
//                  1  2    3    4     5     6    7       8       9      10    11            12       13
var c:Integer;
begin
log('Entrando a setCampo');
inc(tvCampo); vTabla[tvTabla].TCampos:=tvCampo;
vCampo[tvTabla,tvCampo].Id:=id;
vCampo[tvTabla,tvCampo].PK:=pk='S';
vCampo[tvTabla,tvCampo].Des:=des;
vCampo[tvTabla,tvCampo].Tipo:=tipo;
vCampo[tvTabla,tvCampo].size:=StrToInt(size);
vCampo[tvTabla,tvCampo].maxLength:=StrToInt(maxLen);
vCampo[tvTabla,tvCampo].req:=     req='S';
vCampo[tvTabla,tvCampo].conBoton:=conBoton='S';
vCampo[tvTabla,tvCampo].gridVer:= gridVer='S';
vCampo[tvTabla,tvCampo].unoVer:=  unoVer='S';
vCampo[tvTabla,tvCampo].FORMFIELD:=sFORMFIELD;
vCampo[tvTabla,tvCampo].FORMFIELDSQL:=sFORMFIELDSQL;
vCampo[tvTabla,tvCampo].valida:=valida;
vCampo[tvTabla,tvCampo].autoNum:=sAutoNum='S';
vCampo[tvTabla,tvCampo].readOnly:=sReadOnly='S';
vCampo[tvTabla,tvCampo].hidden:=sHidden='S';
vCampo[tvTabla,tvCampo].onChange:=onChange;
vCampo[tvTabla,tvCampo].col:=StrToInt(sCol);
if vCampo[tvTabla,tvCampo].col>tvHtCol then tvHtCol:=vCampo[tvTabla,tvCampo].col;
vCampo[tvTabla,tvCampo].valorIni:=sValorIni;
end;
//Mante fin

//Mante ini
procedure setTablaCampos;
var F:Textfile; L:string; i,j,c:Integer;
begin
log('Entrando a setTablaCampos');
AssignFile(F, pathCGI+'sumario.unet');
Reset(F);
tvTabla:=0;
ReadLn(F, L);ReadLn(F, L);
while not eof(F) do
  begin ReadLn(F, L); c:=splTrim(L,'&');
        if L[1]<>' '
           then setTabla(pTextTrim[1],(pTextTrim[2]),pTextTrim[3],pTextTrim[4],pTextTrim[5],pTextTrim[6])
           else setCampo(pTextTrim[1],(pTextTrim[2]),pTextTrim[3],pTextTrim[4],pTextTrim[5],pTextTrim[6],pTextTrim[7],pTextTrim[8],
                         pTextTrim[9],pTextTrim[10],pTextTrim[11],pTextTrim[12],pTextTrim[13],pTextTrim[14],pTextTrim[15],pTextTrim[16],
                         pTextTrim[17],pTextTrim[18],pTextTrim[19]);
  end;
CloseFile(F);
for i:=1 to tvTabla do if vTabla[i].iTMaestra>0 then vTabla[vTabla[i].iTMaestra].iTDetalle:=i;//tMaeDetToDetIdx(i);
for i:=1 to tvTabla do log(IntToStr(i)+')|'+vTabla[i].Id+'|'+IntToStr(vTabla[i].iTMaestra)+'|'+IntToStr(vTabla[i].iTDetalle));
end;
//Mante fin

procedure GenVm(id,dat:string);
begin inc(tvCampo);vC[tvCampo].Id:=id; vC[tvCampo].value:=dat;
end;

function devHTML(arch:String):string;
var s,rs:String;
    c,i,L:Integer;
    swEnScrip:SmallInt;  //-1 inicio, 1 En script, 0 apaga
    sScript:String;
begin
s:=Lee(arch,false); //log(s);
L:=length(s);
swEnScrip:=-1;
i:=0; sScript:='';
rs:='';
while i<L do
 begin inc(i);
       if (copy(s,i,2)=_Ini) and (swEnScrip=-1) then swEnScrip:=0;
       if copy(s,i,2)=_Ini then
          if swEnScrip=0
             then begin swEnScrip:=1; Inc(i,2);  sScript:='';
                  end
             else begin swEnScrip:=0; Inc(i,1);
                  end;
       if swEnScrip=1 then sScript:=sScript+s[i]
       else if swEnScrip=0 then
                begin c:=bCampo(UpperCase(trim(sScript)),tvCampo);
                      swEnScrip:=-1;
                      if c=-1
                         then rs:=rs+'{ERROR}{No existe}{'+sScript+'}'
                         else rs:=rs+UTF8Decode(vC[c].value);
                end
       else rs:=rs+s[i];
 end;
result:=rs;
end;

function devHTMLnoBody(arch:String):string;
var s,rs:String;
    c,i,L:Integer;
    swEnScrip:SmallInt;  //-1 inicio, 1 En script, 0 apaga
    sScript:String;
begin
s:=Lee(arch,true); //log(s);
L:=length(s);
swEnScrip:=-1;
i:=0; sScript:='';
rs:='';
while i<L do
 begin inc(i);
       if (copy(s,i,2)=_Ini) and (swEnScrip=-1) then swEnScrip:=0;
       if copy(s,i,2)=_Ini then
          if swEnScrip=0
             then begin swEnScrip:=1; Inc(i,2);  sScript:='';
                  end
             else begin swEnScrip:=0; Inc(i,1);
                  end;
       if swEnScrip=1 then sScript:=sScript+s[i]
       else if swEnScrip=0 then
                begin c:=bCampo(UpperCase(trim(sScript)),tvCampo);
                      swEnScrip:=-1;
                      if c=-1
                         then rs:=rs+'{ERROR}{No existe}{'+sScript+'}'
                         else rs:=rs+UTF8Decode(vC[c].value);
                end
       else rs:=rs+s[i];
 end;
result:=rs;
end;

procedure pOpManteMn;
type TProc=record
   img,des,href:string;
end;
var onclick,url,rowColor,s:string;
    i:Integer;
begin
log('pOpManteMn');     //procesos a partir del 201,202,203,...
try
setTablaCampos;
s:='<div id="dvImpOp" class="impOpMas clsImpOp" style="visibility: visible; display: block;">';
s:=s+'<table style="text-align: left; width: 100%;" border="0" cellpadding="0" cellspacing="0">';
s:=s+'<tr style="height:15px;text-align: center;color: rgb(255, 255, 204); background-color: rgb(0, 51, 0);"><td colspan="2" rowspan="1"><big>Mantenimiento</big>';
s:=s+'<tr style="height:10px;"><td></table>';
//s:=s+'<br>';
s:=s+'<table style="text-align: left; width: 100%;" border="0" cellpadding="0" cellspacing="0">';
for i:=1 to tvTabla do
    if vTabla[i].iTMaestra=0 then
       begin if i mod 2=0
                then rowColor:='background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);'
                else rowColor:='background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);';
             url:='href='''+urlExe+'?op='+IntToStr(iProcIni0+i)+'''';// target=''_blanck''';
             onclick:='onclick=document.location.href='''+urlExe+'?op='+IntToStr(iProcIni0+i)+''';';
             s:=s+'<tr style="Cursor:pointer;">'
                       +'<td style="text-align: center; width: 1px;background-color: rgb(255, 255, 204);"><a '+url+'><img src="'+urlImg+vTabla[i].Img+'"></a>'
                       +'<td style="width: 10px;background-color: rgb(255, 255, 204);" '+onclick+'>'
                       +'<td style="'+rowColor+'">'+'<a style="color: rgb(0, 51, 0);" '+url+'>'+vTabla[i].Des+'</a>';
       end;
s:=s+'</table><div onclick="window.close();" style="Cursor:pointer;text-align:center;height:25px;valign:top;"><small>Cerrar</small></div>';
s:=s+'</div>';
GenVm('zMante',s);
GenVm('titu',                  '<title>'+deCripta(licEmp)+'</title>');
w((devHTML('mnmante.html')));
except  on e: Exception do
        begin log(e.Message);
              w(e.Message);
        end;
end;
end;

function igualOptimista(cad1,cad2:string):boolean;
begin if trim(UpperCase(cad1))=trim(UpperCase(cad2))
         then result:=true
         else result:=false;
end;

function genBotones(iTabla:Integer):string;
var s,sLs:String; c,i,k:Integer; vRadio,vHtCol:array[1..50] of String;
begin s:='<table><tr>';
      for i:=1 to vTabla[iTabla].TCampos do
       if vCampo[iTabla,i].conBoton then
          begin
            if (igualOptimista(vCampo[iTabla,i].FORMFIELD,'RadioH')) or (igualOptimista(vCampo[iTabla,i].FORMFIELD,'RadioV'))
             then
               begin inc(tLsBotFilt);
                     //sLs:='<select name=ls'+vCampo[iTabla,i].Id+' onchange="pLsFilt('+IntToStr(tLsBotFilt-1)+','+IntToStr(i)+',this.value);"><option value="-1">';
                     sLs:='<select name=lsbt_'+IntToStr(tLsBotFilt)+' id=idlsbt_'+IntToStr(tLsBotFilt)+'><option value="'+IntToStr(i)+':-1Ultranet">';
                     c:=splitCar(vCampo[iTabla,i].FORMFIELDSQL,',');
                     for k:=1 to c do vRadio[k]:=pText[k];
                     for k:=1 to c do
                       begin splitCar(vRadio[k],':');
                             sLs:=sLs+'<option value="'+IntToStr(i)+':'+pText[1]+'">'+pText[2];
                       end;
                     sLs:=sLs+'</select>';
                     s:=s+'<td><span style="white-space:nowrap;">'+vCampo[iTabla,i].Des+'</span>'+sLs;
               end
             else s:=s+'<td><button style="height:30px;margin-top:-5px;" onclick="pManteFiltra('''+IntToStr(iTabla)+':'+IntToStr(i)+':'+vCampo[iTabla,i].FORMFIELD+':'+maxIniFiltro
                 //+''');" class=bt2><table border=0><tr><td><td>'+vCampo[iTabla,i].Des+'</table></button>';
                      +''');"><table border=0><tr><td><img src="'+urlImg+'lupa.png"><td style="white-space:nowrap;">'+vCampo[iTabla,i].Des+'</table></button>';
          end;
      s:=s+'</table>'; Result:=s;
end;

function getBotonPrimero(iTabla:Integer):string;
var s:String;i:Integer;
begin for i:=1 to vTabla[iTabla].TCampos do
         if vCampo[iTabla,i].conBoton then
            begin result:='pManteFiltra('''+IntToStr(iTabla)+':'+IntToStr(i)+':'+vCampo[iTabla,i].FORMFIELD+':'+maxIniFiltro+''');';
                  exit;
       end;
      Result:='';
end;

function genInsUpBoton(iTabla:Integer;sDet:String):string;
var sGraba,sGrabaAux,sI,valida:String;
    i:Integer;
begin
sGrabaAux:='';
for i:=1 to vTabla[iTabla].TCampos do
  begin  sI:=IntToStr(i);
	 if vCampo[iTabla,i].unoVer then
	    begin if igualOptimista(vCampo[iTabla,i].FORMFIELD,'Text') then
		      begin valida:=trim(vCampo[iTabla,i].valida);
				    if      valida='Entero'       then sGrabaAux:=sGrabaAux+' && okManteInt('+sI+')'
				    else if valida='Real'         then sGrabaAux:=sGrabaAux+' && okManteReal('+sI+')'
				    else if valida='Sólo letras'  then sGrabaAux:=sGrabaAux+' && okManteSoloLetras('+sI+')'
				    else if valida='Alfanum'      then sGrabaAux:=sGrabaAux+' && okManteAlfanum('+sI+')'
				    else if valida='Fecha'        then sGrabaAux:=sGrabaAux+' && okManteFecha('+sI+')'
				    else if valida='Hora'         then sGrabaAux:=sGrabaAux+' && okManteHora('+sI+')'
				    else if valida='DNI'          then sGrabaAux:=sGrabaAux+' && okManteDNI('+sI+')'
				    else if valida='RUC'          then sGrabaAux:=sGrabaAux+' && okManteRUC('+sI+')';
				    if vCampo[iTabla,i].req       then sGrabaAux:=sGrabaAux+' && okReq'+sDet+'('+sI+')';
		      end;
	    end;
  end;
if trim(sGrabaAux)=''
   then sGraba:='<img id="imManteGuarda'+sDet+'"  style="Cursor:pointer;" src="'+urlImg+'disquetteOff.png" title="Guardar" onclick="pManteGuarda'+sDet+'();">'
   else sGraba:='<img id="imManteGuarda'+sDet+'"  style="Cursor:pointer;" src="'+urlImg+'disquetteOff.png" title="Guardar" onclick="if(1==1'+sGrabaAux
			   +')pManteGuarda'+sDet+'();">';
result:=sGraba;
end;

function insFiltro(cSql,filt:String):String;
begin cSql:=trim(cSql);
      result:='select first '+filt+' '+RightStr(cSql,Length(cSql)-6);
end;

procedure Fin(msg:String);
begin w(opcionIncorrecta(msg)); halt;
end;

procedure pManteFiltraDet(cad:String);
var res, xFormField,s, BuscaPor,BuscaPorNormal, valor, cadBusca, maxFiltro,sGrid,sUno,wAncho,ColFondo,sPK,sWhere: string;
    tvValue,tvFK,iCampo,c,i:Integer;
    iTabla:SmallInt;
    vValue,vFK:array[1..100] of string;
begin
try
log('<pManteFiltraDet('+cad+')');
wAncho:='600';
maxFiltro:='';
splitCar(cad,':');
iTabla:= StrToInt(pText[1]);
tvValue:=splitCar(pText[2],',');   //values
for i:=1 to tvValue do vValue[i]:=pText[i];
tvFK:=splitCar(vTabla[iTabla].fkMaeDet,',');
for i:=1 to tvFK do vFK[i]:=pText[i];
if tvValue<>tvFK then Fin('Maedet error. tvValue('+IntToStr(tvValue)+') <> tvFK('+IntToStr(tvFK)+')');
ColFondo:='';
sWhere:='';
for i:=1 to tvFK do
    if i=1
       then sWhere:=sWhere+' where '+vFK[i]+'='''+vValue[i]+''''
       else sWhere:=sWhere+' and '  +vFK[i]+'='''+vValue[i]+'''';
bQ(vTabla[iTabla].Sql+sWhere);
sGrid:='<table style="border-collapse:collapse;" cellpadding="2" cellspacing="0" width=100% border=1><tr style="background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);"><th>';
for i:=1 to vTabla[iTabla].TCampos do
  begin if vCampo[iTabla,i].gridVer then sGrid:=sGrid+'<th align=center><span style="white-space:nowrap;height:10px;font:110% calibri,tahoma,arial,sans-serif;">'+vCampo[iTabla,i].Des+'</span>';

  end;
while not q.EOF do
 begin sPK:='';
       for i:=1 to vTabla[iTabla].TCampos do if vCampo[iTabla,i].PK then sPK:=sPK+q.FieldByName(vCampo[iTabla,i].Id).AsString+',';
       if sPK<>'' then sPK:=LeftStr(sPK,Length(sPK)-1);
       sGrid:=sGrid+'<tr style="background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);" onmouseover="overRaton(this)" onmouseout="outRaton(this)">';
       sGrid:=sGrid+'<td style="text-align: center;"><img src="'+urlImg+'erase.png" onclick="pManteDelDet('''+IntToStr(iTabla)+':'+sPK+''')">';
       for i:=1 to vTabla[iTabla].TCampos do
           if vCampo[iTabla,i].gridVer then
            begin
             sGrid:=sGrid+#13#10'<td onclick="pManteUnoVerDet('''+IntToStr(iTabla)+':'+sPK+':'+vCampo[iTabla,i].FORMFIELD+''',true);" style="'+ColFondo+'">'
                   +q.FieldByName(vCampo[iTabla,i].Id).AsString;
//             +'<input class=input1 type="text" value="'+q.FieldByName(vCampo[iTabla,i].Id).AsString+'">';
            end;
       q.Next;
 end;
sGrid:=sGrid+'</table>';
sUno:='<div id=dvzUnoDet_1>';
//s:=s+'<center>';
s:=s+'<table style="border-collapse:collapse;color:rgb(255, 255, 204);border="0" width='+wAncho+'px cellpadding="0" cellspacing="0"><tr><td width=100%>';
s:=s+'<tr><td>&nbsp;';
s:=s+'	<table width=100% border=0 cellpadding="0" cellspacing="0"><tr><td><div id=dvzUnoDet>'+sUno+'</div>';
s:=s+'	<tr style="height:15px;"><td><div id=dvzGridDet class="marco1 marco1_mod">'+sGrid;
s:=s+'<div style="Cursor:pointer;text-align:center;height:10px;valign:top;"><small><small></small></small></div>';
s:=s+'</div>';
s:=s+'	</table>';
s:=s+'</table>';
w(s+':_:'+cad);
log('pManteFiltraDet>');
except
  on e: Exception do begin log(e.Message); res:=e.Message;
                           w(e.Message);
                           w(UTF8Decode('<br>Para intentar restaurar haga click <a href="'+urlExe+Ejecutable+'?op=5">aquí</a>'));
                     end
end;
end;

function fkMaeDetIdToIdx(xId:String):Integer;
var i,j,k:Integer;
begin
for i:=1 to tvsFKMaeDet do
  if xId=vsFKMaeDet[i] then
     begin result:=i; exit;
     end;
result:=-1;
end;

function pManteUnoVer(tipo,cad,sDet:string):string;
var iTabla,c:Integer;
    var i,j,k:Integer;
    s,sUno,xId,valida,sVal,sI,sUnoHidden,Id0,sWhere,sLsPos,sReadOnly,sOnChange,outOnChange,sFORMFIELDSQL:String;
    vRadio,vHtCol:array[1..50] of String;
begin
log('Entrando a pManteUnoVer('+cad+')');
try
c:=splitCar(cad,':');
iTabla:=StrToInt(pText[1]);
xId:=Trim(pText[2]);
tvsPK:=splitCar(xId,',');   //Dual. Son los valores actuales del PK si es acUpdate. Si es acInsert entonces son los valores de FK que enlazan al maestro
for i:=1 to tvsPK do vsPK[i]:=pText[i];
tvsFKMaeDet:=splitCar(vTabla[iTabla].fkMaeDet,',');
for i:=1 to tvsFKMaeDet do vsFKMaeDet[i]:=pText[i];
outOnChange:='';
if  tipo=acUpdate then
    begin sWhere:='';ivsPK:=0;
          for i:=1 to vTabla[iTabla].TCampos do
              if vCampo[iTabla,i].PK then
                 begin inc(ivsPK);
                       sWhere:=sWhere+' and '+vCampo[iTabla,i].Id+'='''+vsPK[ivsPK]+'''';
                 end;
          if trim(sWhere)<>'' then sWhere:=RightStr(sWhere,Length(sWhere)-5);
          bQ('select * from ('+vTabla[iTabla].Sql+') where '+sWhere);
          for i:=1 to vTabla[iTabla].TCampos do
            begin if not igualOptimista(vCampo[iTabla,i].FORMFIELD,'Calculado') then
                     vCampo[iTabla,i].value:=q.FieldByName(vCampo[iTabla,i].Id).AsString;
                  if trim(vCampo[iTabla,i].onChange)<>'' then outOnChange:=outOnChange+vCampo[iTabla,i].onChange+'_-_';
            end;
    end
else if tipo=acInsert then
    begin if vTabla[iTabla].iTMaestra>0 then //Es tabla detalle
             begin if tvsFKMaeDet<>tvsPK then Fin('FKsMaeDet no emparejados con PKsMaeDet');
                   sWhere:='';
                   for i:=1 to tvsFKMaeDet do sWhere:=sWhere+' and '+vsFKMaeDet[i]+'='''+vsPK[i]+'''';
                   if trim(sWhere)<>'' then sWhere:=' where '+RightStr(sWhere,Length(sWhere)-5);
             end;
           for i:=1 to vTabla[iTabla].TCampos do
             begin if vCampo[iTabla,i].autoNum
                      then begin  if igualOptimista(vCampo[iTabla,i].Tipo,   'SMALLINT')
                                     or igualOptimista(vCampo[iTabla,i].Tipo,'INTEGER')
                                     or igualOptimista(vCampo[iTabla,i].Tipo,'NUMERIC')
                                     then vCampo[iTabla,i].value:=rQ('select coalesce(max('+vCampo[iTabla,i].Id+'),0)+1 from '+vTabla[iTabla].Id+sWhere)
                           end
                      else begin vCampo[iTabla,i].value:=trim(vCampo[iTabla,i].valorIni);
                                 if UpperCase(LeftStr(vCampo[iTabla,i].value,7))='SELECT '
                                    then vCampo[iTabla,i].value:=rQ(vCampo[iTabla,i].value);
                           end;
                   k:=fkMaeDetIdToIdx(vCampo[iTabla,i].Id);
                   if k>0 then vCampo[iTabla,i].value:=vsPK[i];
             end;
    end;
sUnoHidden:='';
for i:=1 to tvHtCol do vHtCol[i]:='<table cellpadding="0" cellspacing="0">';
for i:=1 to vTabla[iTabla].TCampos do
 begin
     sI:=IntToStr(i);
     if (vCampo[iTabla,i].unoVer) and (not vCampo[iTabla,i].hidden)
       then
        begin s:='<tr><td style="text-align:right;"><span style="white-space: nowrap;height:10px;font: 100% tahoma,arial,sans-serif;">'+vCampo[iTabla,i].Des+'</span>';
              s:=s+'<td style="text-align:left;">';
              sReadOnly:='';
              if (igualOptimista(vCampo[iTabla,i].FORMFIELD,'Text')) or (igualOptimista(vCampo[iTabla,i].FORMFIELD,'Calculado')) then
                      begin s:=s+'<input class=input1 type="text" id="id'+sDet+sI
                                      +'" name="ed'       +sDet+vCampo[iTabla,i].Id
                                      +'" size="'        +IntToStr(vCampo[iTabla,i].size * 120 div 100)
                                      +'" maxLength="'   +IntToStr(vCampo[iTabla,i].maxLength)
                                      +'" value="'       +vCampo[iTabla,i].value+'"';
                            if (vCampo[iTabla,i].readOnly) or (fkMaeDetIdToIdx(vCampo[iTabla,i].Id)>0) or (igualOptimista(vCampo[iTabla,i].FORMFIELD,'Calculado')) then
                               sReadOnly:=' readonly';
                            s:=s+sReadOnly+' onchange="manteCambio'+sDet+'(true);'+vCampo[iTabla,i].onChange+'" >';
                            valida:=trim(vCampo[iTabla,i].valida);
                            if vCampo[iTabla,i].req then s:=s+'*';
                      end
              else if igualOptimista(vCampo[iTabla,i].FORMFIELD,'Select') then
                      begin  bQ1(vCampo[iTabla,i].FORMFIELDSQL);
                             sLsPos:='';
                             //if tipo=acInsert then Id0:='0'
                             //else if tipo=acUpdate then
                             Id0:=vCampo[iTabla,i].value;
                             s:=s+'<select class=input1 id="id'+sDet+sI+'" name="ed'+sDet+vCampo[iTabla,i].Id+'"'
                                       +' onchange="manteCambio'+sDet+'(true);'+vCampo[iTabla,i].onChange+'">';
                             while not q1.EOF do
                              begin if(Id0=q1.Fields[0].AsString)
                                      then s:=s+'<option value="'+q1.Fields[0].AsString+'" selected>'+q1.Fields[1].AsString
                                      else s:=s+'<option value="'+q1.Fields[0].AsString+'">'         +q1.Fields[1].AsString;
                                    q1.Next;
                              end;
                             s:=s+'</select>';
                      end
              else if igualOptimista(vCampo[iTabla,i].FORMFIELD,'RadioV') then
                      begin  c:=splitCar(vCampo[iTabla,i].FORMFIELDSQL,',');
                             s:=s+'<input type=hidden id="id'+sDet+sI+'" name=ed'+sDet+vCampo[iTabla,i].Id+'>';
                             for k:=1 to c do vRadio[k]:=pText[k];
                             s:=s+'<table class=input1 cellpadding="0" cellspacing="0">';
                             for k:=1 to c do
                               begin splitCar(vRadio[k],':');
                                     s:=s+'<tr><td><input '+iif(tipo=acInsert,iif(k=1,' checked ',''),iif(vCampo[iTabla,i].value=pText[1],' checked ',''))+' id="id'+sDet+'R'+sI+'" name="ed'+sDet+'R'+vCampo[iTabla,i].Id
                                               +'" type="radio" onchange="document.getElementById(''id'+sDet+sI+''').value='''+pText[1]+''';manteCambio'+sDet+'(true);'+vCampo[iTabla,i].onChange+'"'
                                               +' value="'+pText[1]+'"><td>'+pText[2];
                               end;
                             s:=s+'</table>';
                      end
              else if igualOptimista(vCampo[iTabla,i].FORMFIELD,'RadioH') then
                      begin  c:=splitCar(vCampo[iTabla,i].FORMFIELDSQL,',');
                             s:=s+'<input type=hidden id="id'+sDet+sI+'" name=ed'+sDet+vCampo[iTabla,i].Id+'>';
                             for k:=1 to c do vRadio[k]:=pText[k];
                             s:=s+'<table class=input1 cellpadding="0" cellspacing="0"><tr>';
                             for k:=1 to c do
                               begin splitCar(vRadio[k],':');
                                     s:=s+iif(k>1,'<td>&nbsp;','')+'<td><input '+iif(tipo=acInsert,iif(k=1,' checked ',''),iif(vCampo[iTabla,i].value=pText[1],' checked ',''))+' id="id'+sDet+'R'+sI+'" name="ed'+sDet+'R'+vCampo[iTabla,i].Id
                                               +'" type="radio" onchange="document.getElementById(''id'+sDet+sI+''').value='''+pText[1]+''';manteCambio'+sDet+'(true);'+vCampo[iTabla,i].onChange+'"'
                                               +' value="'+pText[1]+'"><td>'+pText[2];
                               end;
                             s:=s+'</table>';
                      end
              else if igualOptimista(vCampo[iTabla,i].FORMFIELD,'VIRTUAL') then
                      begin s:=s+'<input class=input1 type="text" id="id'+sDet+sI
                                      +'" name=ed'       +sDet+vCampo[iTabla,i].Id
                                      +'" size="'        +IntToStr(vCampo[iTabla,i].size * 120 div 100)
                                      +'" maxLength="'   +IntToStr(vCampo[iTabla,i].maxLength)
                                      +'" value="'       +vCampo[iTabla,i].value
                                      +'" disabled="disabled" >';
                      end;
              vHtCol[vCampo[iTabla,i].col]:=vHtCol[vCampo[iTabla,i].col]+s;
        end
       else
        begin sUnoHidden:=sUnoHidden+'<input type=hidden id="id'+sDet+sI+'" name=ed'+sDet+vCampo[iTabla,i].Id+' value="'+vCampo[iTabla,i].value+'">';
        end;
 end;
for i:=1 to tvHtCol do vHtCol[i]:=vHtCol[i]+'</table>';
sUno:='<div id=dvzUno'+sDet+'_1 class="marco1 marco1_mod"><form name=f'+sDet+'>';
sUno:=sUno+'<table style="width:100%;" cellpadding="1" cellspacing="1"><tr>';
  for i:=1 to tvHtCol do sUno:=sUno+'<td valign=top>'+vHtCol[i];
  sUno:=sUno+iif(sDet='','<td width=1px style="vertical-align:top;Cursor:pointer;" onclick=document.getElementById(''dvzUno'+sDet+'_1'').innerHTML=''''><img src="'+urlImg+'cierraOn.png" title="Cerrar panel" onmouseover="this.src='''+urlImg+'cierraOn.png'';" onmouseout="this.src='''+urlImg+'cierraOff.png'';">','');
  sUno:=sUno+'<tr style="height:10px;">';
  for i:=1 to tvHtCol do sUno:=sUno+'<td>';
  sUno:=sUno+'<td>';
sUno:=sUno+'</table>';
sUno:=sUno+'</form></div>'+sUnoHidden;
if outOnChange<>'' then outOnChange:=LeftStr(outOnChange,Length(outOnChange)-3);
w(sUno+':_:'+IntToStr(vTabla[iTabla].TCampos)+':_:'+'|'+':_:'+tipo+':_:'+outOnChange+':_:');      //El último hacha es necesario ya que en javascript el split no agarra al ultimo
if vTabla[iTabla].iTDetalle>0
   then begin pManteFiltraDet(IntToStr(vTabla[iTabla].iTDetalle)+':'+xId);
        end
   else w('');
except on e: Exception do begin log(e.Message); w(opcionIncorrecta(e.Message)); end
end;
end;

procedure pManteFiltra(cad:string);
var res, xFormField,s, BuscaPor,BuscaPorNormal, valor, cadBusca, maxFiltro,sGrid,sUno,wAncho,ColFondo,sPK,
    lsBotFilt,slsFilt,tabCmp,lsBotFiltVal:String;
    iTabla,iCampo,c,i,lsBotFiltCampo,tvLsBotFilt:Integer;
    vLsBotFilt:array[1..100] of string;
begin
try
log('<pManteFiltra('+cad+')');
wAncho:='600';
maxFiltro:='';
c:=splitCar(cad,'|');
  tabCmp:=pText[1];
  valor:=pText[2];
  maxFiltro:=trim(pText[3]);
  lsBotFilt:=trim(pText[4]);
  lsBotFilt:=LeftStr(lsBotFilt,Length(lsBotFilt)-1);
  tvLsBotFilt:=splitCar(lsBotFilt,'~');
  slsFilt:='';
  for i:=1 to tvLsBotFilt do vLsBotFilt[i]:=pText[i];
c:=splitCar(tabCmp,':');
  iTabla:=StrToInt(pText[1]);
  iCampo:=StrToInt(pText[2]);
  xFormField:=trim(pText[3]);
  for i:=1 to tvLsBotFilt do
    begin c:=splitCar(vLsBotFilt[i],':');
          lsBotFiltCampo:=StrToInt(pText[1]);
          lsBotFiltVal:=  trim(pText[2]);
          if lsBotFiltVal<>'-1Ultranet' then slsFilt:=slsFilt+' and '+vCampo[iTabla,lsBotFiltCampo].Id+'='''+lsBotFiltVal+'''';
          log(lsBotFilt);
    end;
if igualOptimista(xFormField,'VIRTUAL')
   then BuscaPorNormal:=vCampo[iTabla,iCampo].FORMFIELDSQL
   else BuscaPorNormal:=vCampo[iTabla,iCampo].Id; //pText[2];
buscaPor:='upper(('+BuscaPorNormal+'))';
c:=splitCar(valor,' ');
if c=0 then pText[1]:='';
log('c:'+IntToStr(c));
cadBusca:=' where '+BuscaPor+' like '''+UpperCase(trim(pText[1]))+'%''';
for i:=2 to c do
  begin valor:=trim(pText[i]);
        cadBusca:=cadBusca+' and '+BuscaPor+' like ''%'+UpperCase(pText[i])+'%''';
  end;
q.Close;
q.SQL.Text:=insFiltro(vTabla[iTabla].Sql+cadBusca+slsFilt+' order by ('+BuscaPorNormal+')',maxFiltro);
//q.SQL.Text:='select first '+maxFiltro+' * from ('+vTabla[iTabla].Sql+') '+cadBusca+' order by ('+BuscaPorNormal+')';
log(q.SQL.Text);
q.Open;
sGrid:='<table style="border-collapse:collapse;white-space:nowrap" cellpadding="2" cellspacing="0" width=100% border=1><tr style="background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);"><th width=1px>'
     +iif(vTabla[iTabla].iTDetalle>0,'<th width=1px>','');
for i:=1 to vTabla[iTabla].TCampos do
  begin if vCampo[iTabla,i].gridVer then sGrid:=sGrid+'<th align=center><span style="white-space:nowrap;height:10px;font:110% calibri,tahoma,arial,sans-serif;">'+vCampo[iTabla,i].Des+'</span>';
  end;
ColFondo:='';
while not q.EOF do
 begin sPK:='';
       for i:=1 to vTabla[iTabla].TCampos do if vCampo[iTabla,i].PK then sPK:=sPK+q.FieldByName(vCampo[iTabla,i].Id).AsString+',';
       if sPK<>'' then sPK:=LeftStr(sPK,Length(sPK)-1);
       if vTabla[iTabla].iTDetalle>0
          then begin sGrid:=sGrid+'<tr style="background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);" onmouseover="overRaton(this)" onmouseout="outRaton(this)">';
                     sGrid:=sGrid+'<td onclick="pManteUnoVer('''+IntToStr(iTabla)+':'+sPK+':'+vCampo[iTabla,i].FORMFIELD+''',true);" style="background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);">Editar';
                     sGrid:=sGrid+'<td style="text-align: center;" width=1px><img src="'+urlImg+'erase.png" onclick="pManteDel('''+IntToStr(iTabla)+':'+sPK+''')">';
                     for i:=1 to vTabla[iTabla].TCampos do
                         if vCampo[iTabla,i].gridVer then
                          begin
                           sGrid:=sGrid+#13#10'<td onclick="if(document.getElementById(''imManteGuarda'').src.indexOf(''disquette.png'')>-1) alert(''Hay cambios pendientes de guardar'');';
              //             sGrid:=sGrid+'else {pManteFiltraDet('''+IntToStr(vTabla[iTabla].iTDetalle)+':'+sPK+''');}"  style="'+ColFondo+'">'
                           sGrid:=sGrid+'else {if(document.getElementById(''dvzUno_1'').innerHTML=='''')pManteFiltraDet('''+IntToStr(vTabla[iTabla].iTDetalle)+':'+sPK+''');else pManteUnoVer('''+IntToStr(iTabla)+':'+sPK+':'+vCampo[iTabla,i].FORMFIELD+''',true);}"  style="'+ColFondo+'">'
                           +q.FieldByName(vCampo[iTabla,i].Id).AsString;
                          end;
               end
          else begin sGrid:=sGrid+'<tr onclick="pManteUnoVer('''+IntToStr(iTabla)+':'+sPK+':'+vCampo[iTabla,i].FORMFIELD+''',true);" style="background-color: rgb(255, 255, 204); color: rgb(0, 51, 0);" onmouseover="overRaton(this)" onmouseout="outRaton(this)">';
                     sGrid:=sGrid+'<td style="text-align: center;" width=1px><img src="'+urlImg+'erase.png" onclick="pManteDel('''+IntToStr(iTabla)+':'+sPK+''')">';
                     for i:=1 to vTabla[iTabla].TCampos do
                         if vCampo[iTabla,i].gridVer then
                          begin
             //              sGrid:=sGrid+#13#10'<td onclick="if(document.getElementById(''imManteGuarda'').src.indexOf(''disquette.png'')>-1) alert(''Hay cambios pendientes de guardar'');';
             ////              sGrid:=sGrid+'else {pManteFiltraDet('''+IntToStr(vTabla[iTabla].iTDetalle)+':'+sPK+''');}"  style="'+ColFondo+'">'
             //              sGrid:=sGrid+'else {if(document.getElementById(''dvzUno_1'').innerHTML=='''')pManteFiltraDet('''+IntToStr(vTabla[iTabla].iTDetalle)+':'+sPK+''');else pManteUnoVer('''+IntToStr(iTabla)+':'+sPK+':'+vCampo[iTabla,i].FORMFIELD+''',true);}"  style="'+ColFondo+'">'
                           sGrid:=sGrid+#13#10'<td>'+q.FieldByName(vCampo[iTabla,i].Id).AsString;
                          end;
               end;
       q.Next;
 end;
sGrid:=sGrid+'</table>';
sUno:='<div id=dvzUno_1>';
s:=s+'<table style="border-collapse:collapse;color:rgb(255, 255, 204);border="0" width='+wAncho+'px cellpadding="0" cellspacing="0"><tr><td width=100%>';
s:=s+'<tr><td>&nbsp;';
s:=s+'	<table width=100% border=0 cellpadding="0" cellspacing="0"><tr><td><div id=dvzUno>'+sUno+'</div>';
s:=s+'	<tr style="height:15px;"><td><div id=dvzGrid class="marco1 marco1_mod">'+sGrid;
s:=s+'<div style="Cursor:pointer;text-align:center;height:10px;valign:top;"><small><small></small></small></div>';
s:=s+'</div>';
s:=s+'	</table>';
s:=s+'</table>';
w(s);
log('pManteFiltra>');
except
  on e: Exception do begin log(e.Message); res:=e.Message;
                           w(e.Message);
                           w(UTF8Decode('<br>Para intentar restaurar haga click <a href="'+urlExe+Ejecutable+'?op=5">aquí</a>'));
                     end
end;
end;

procedure pManteActUno(cad: string);
var
  accion,xId,cSql,sCampos,sValues,cad1,res,sWhere,sPK: string;
  vsPK:array[1..50] of String;
  iTabla,nC, i, c,tvsPK,ivsPK: integer;
  Fingreso: TDate;
begin
log('Entrando a pManteActUno('+cad+')');
res:='1';
try
cad1:=cad;
c:=splitCar(cad,'|');
accion:=pText[c-1];
c:=splitCar(pText[c],':');
iTabla:=StrToInt(pText[1]);
//setTablaCampos;  //splicat y splittrim no se mexclan
if accion=acUpdate then
   begin xId:=Trim(pText[2]);
         tvsPK:=splitCar(xId,',');
         for i:=1 to tvsPK do vsPK[i]:=pText[i];
   end;
sWhere:='';ivsPK:=0;
for i:=1 to vTabla[iTabla].TCampos do
    if vCampo[iTabla,i].PK then
       begin inc(ivsPK);
             sWhere:=sWhere+' and '+vCampo[iTabla,i].Id+'='''+vsPK[ivsPK]+'''';
       end;
if trim(sWhere)<>'' then sWhere:=RightStr(sWhere,Length(sWhere)-5);
c:=splitCar(cad1,'|');
if accion=acInsert then
   begin  sCampos:=' (';sValues:=' (';
          for i:=1 to vTabla[iTabla].TCampos do
            if (trim(pText[i])<>'') and (not(igualOptimista(vCampo[iTabla,i].FORMFIELD,'VIRTUAL')))
                                    and (not(igualOptimista(vCampo[iTabla,i].FORMFIELD,'CALCULADO')))
               then begin  sCampos:=sCampos+vCampo[iTabla,i].Id+',';
                           if trim(pText[i])=''
                              then sValues:=sValues+'null,'
                              else
                                begin
                                   if      igualOptimista(vCampo[iTabla,i].Tipo,'SMALLINT')
                                        or igualOptimista(vCampo[iTabla,i].Tipo,'INTEGER')
                                        or igualOptimista(vCampo[iTabla,i].Tipo,'NUMERIC') then
                                           sValues:=sValues+pText[i]+','
                                   else if igualOptimista(vCampo[iTabla,i].Tipo,'CHAR')
                                        or igualOptimista(vCampo[iTabla,i].Tipo,'VARCHAR') then
                                           sValues:=sValues+''''+iif(charSetBD='utf8',(pText[i]),pText[i])+''','
                                   else if igualOptimista(vCampo[iTabla,i].Tipo,'TIME') then
                                           sValues:=sValues+''''+pText[i]+''','
                                   else if igualOptimista(vCampo[iTabla,i].Tipo,'DATE') then
                                           sValues:=sValues+''''+dmyTOymd(pText[i])+''',';
                                end;
                    end;
          sCampos:=LeftStr(sCampos,Length(sCampos)-1)+')';
          sValues:=LeftStr(sValues,Length(sValues)-1)+')';
          cSql:='insert into '+vTabla[iTabla].Id+sCampos+' values '+sValues;
  end
else if accion=acUpdate then
   begin  sCampos:=' ';
          for i:=1 to vTabla[iTabla].TCampos do
            if (not(igualOptimista(vCampo[iTabla,i].FORMFIELD,'VIRTUAL')))
               and (not(igualOptimista(vCampo[iTabla,i].FORMFIELD,'CALCULADO')))
               then begin
                          if trim(pText[i])=''
                             then sCampos:=sCampos+vCampo[iTabla,i].Id+'=null,'
                             else
                               begin
                                  if      igualOptimista(vCampo[iTabla,i].Tipo,'SMALLINT')
                                       or igualOptimista(vCampo[iTabla,i].Tipo,'INTEGER')
                                       or igualOptimista(vCampo[iTabla,i].Tipo,'NUMERIC') then
                                          sCampos:=sCampos+vCampo[iTabla,i].Id+'='+pText[i]+','
                                  else if igualOptimista(vCampo[iTabla,i].Tipo,'CHAR')
                                       or igualOptimista(vCampo[iTabla,i].Tipo,'VARCHAR') then
                                          sCampos:=sCampos+vCampo[iTabla,i].Id+'='''+iif(charSetBD='utf8',(pText[i]),pText[i])+''','
                                  else if igualOptimista(vCampo[iTabla,i].Tipo,'TIME') then
                                          sCampos:=sCampos+vCampo[iTabla,i].Id+'='''+pText[i]+''','
                                  else if igualOptimista(vCampo[iTabla,i].Tipo,'DATE') then
                                          sCampos:=sCampos+vCampo[iTabla,i].Id+'='''+dmyTOymd(pText[i])+''',';
                               end;
                    end;
          sCampos:=LeftStr(sCampos,Length(sCampos)-1);
          cSql:='update '+vTabla[iTabla].Id+' set '+sCampos+' where '+sWhere;
   end;
xQ(cSql);
tr.Commit;
except
  on e: Exception do begin log(e.Message); res:=e.Message;
                     end
end;
w(res);
end;

procedure pManteDel(cad: string);
var i,j,k:Integer;
var xId,res,sWhere: string;
    iTabla,c,tvsPK,ivsPK: integer;
    vsPK:array[1..50] of String;
begin
log('Entrando a pManteDel('+cad+')');
res:='1';
try
c:=splitCar(cad,':');
iTabla:=StrToInt(pText[1]);
xId:=Trim(pText[2]);
tvsPK:=splitCar(xId,',');
for i:=1 to tvsPK do vsPK[i]:=pText[i];
setTablaCampos;
sWhere:='';ivsPK:=0;
for i:=1 to vTabla[iTabla].TCampos do
    if vCampo[iTabla,i].PK then
       begin inc(ivsPK);
             sWhere:=sWhere+' and '+vCampo[iTabla,i].Id+'='''+vsPK[ivsPK]+'''';
       end;
if trim(sWhere)<>'' then sWhere:=RightStr(sWhere,Length(sWhere)-5);
xQ('delete from '+vTabla[iTabla].Id+' where '+sWhere);
tr.Commit;
except
  on e: Exception do begin log(e.Message); res:=e.Message;
                     end
end;
w(res);
end;

